#!/bin/sh

apt-get update || exit 1

apt-get install -y \
	build-essential \
	dbus \
	dbus-x11 \
	libcairo2-dev \
	libglib2.0-dev \
	libgtk-3-0 \
	libgtk-3-dev \
	libreadline-dev \
	libxml2 \
	libxml2-dev \
	nettle-dev \
	pkg-config \
	valgrind \
	debhelper \
	dh-make \
    || exit 1

export $(dbus-launch)

mkdir -p public || exit 1

echo "Build tarot"
VERSION=$(cat dist/version)

cp dist/tarot-$VERSION.tar.gz . || exit 1
tar xf tarot-$VERSION.tar.gz || exit 1
cd tarot-$VERSION
./configure DPKG_BUILDPACKAGEFLAGS="-us -uc" || exit 1
make -j 8 deb || exit 1
cp $(make print-debfiles) ../public/
make -j distclean || exit 1
cd ..
