#!/bin/sh

apt-get update || exit 1

apt-get install -y \
	build-essential \
	flatpak \
	flatpak-builder \
	libglib2.0-dev \
	libreadline-dev \
	libxml2 \
	libxml2-dev \
	nettle-dev \
	ostree \
	pkg-config \
	texinfo \
	valgrind \
	|| exit 1

flatpak remote-add --user --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo || exit 1
flatpak install -y --user flathub org.freedesktop.Platform//18.08 || exit 1
flatpak install -y --user flathub org.freedesktop.Sdk//18.08 || exit 1

mkdir -p public || exit 1

VERSION=$(cat dist/version)

cp dist/tarot-$VERSION.tar.gz . || exit 1
tar xf tarot-$VERSION.tar.gz || exit 1
cd tarot-$VERSION
# disable-program is only for this configuration step.
./configure --disable-program || exit 1
make -j 8 flatpak-bundle || exit 1
cp tarot-latest.flatpak ../public/
make -j distclean || exit 1
cd ..
