/**
 * file cards_private.h
 *
 * Copyright (C) 2018 Vivien Kraus <vivien@planete-kraus.eu>
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */
#ifndef H_TAROT_CARDS_PRIVATE_INCLUDED
#define H_TAROT_CARDS_PRIVATE_INCLUDED
#include <stddef.h>
#include <tarot/cards.h>
#define N_(String) (String)
#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  
  /** Index of card ace of hearts */
  #define TAROT_AH 0
  
  /** Index of card two of hearts */
  #define TAROT_2H 1
  
  /** Index of card three of hearts */
  #define TAROT_3H 2
  
  /** Index of card four of hearts */
  #define TAROT_4H 3
  
  /** Index of card five of hearts */
  #define TAROT_5H 4
  
  /** Index of card six of hearts */
  #define TAROT_6H 5
  
  /** Index of card seven of hearts */
  #define TAROT_7H 6
  
  /** Index of card eight of hearts */
  #define TAROT_8H 7
  
  /** Index of card nine of hearts */
  #define TAROT_9H 8
  
  /** Index of card ten of hearts */
  #define TAROT_10H 9
  
  /** Index of card jack of hearts */
  #define TAROT_JH 10
  
  /** Index of card knight of hearts */
  #define TAROT_CH 11
  
  /** Index of card queen of hearts */
  #define TAROT_QH 12
  
  /** Index of card king of hearts */
  #define TAROT_KH 13
  
  /** Index of card ace of clubs */
  #define TAROT_AC 14
  
  /** Index of card two of clubs */
  #define TAROT_2C 15
  
  /** Index of card three of clubs */
  #define TAROT_3C 16
  
  /** Index of card four of clubs */
  #define TAROT_4C 17
  
  /** Index of card five of clubs */
  #define TAROT_5C 18
  
  /** Index of card six of clubs */
  #define TAROT_6C 19
  
  /** Index of card seven of clubs */
  #define TAROT_7C 20
  
  /** Index of card eight of clubs */
  #define TAROT_8C 21
  
  /** Index of card nine of clubs */
  #define TAROT_9C 22
  
  /** Index of card ten of clubs */
  #define TAROT_10C 23
  
  /** Index of card jack of clubs */
  #define TAROT_JC 24
  
  /** Index of card knight of clubs */
  #define TAROT_CC 25
  
  /** Index of card queen of clubs */
  #define TAROT_QC 26
  
  /** Index of card king of clubs */
  #define TAROT_KC 27
  
  /** Index of card ace of diamonds */
  #define TAROT_AD 28
  
  /** Index of card two of diamonds */
  #define TAROT_2D 29
  
  /** Index of card three of diamonds */
  #define TAROT_3D 30
  
  /** Index of card four of diamonds */
  #define TAROT_4D 31
  
  /** Index of card five of diamonds */
  #define TAROT_5D 32
  
  /** Index of card six of diamonds */
  #define TAROT_6D 33
  
  /** Index of card seven of diamonds */
  #define TAROT_7D 34
  
  /** Index of card eight of diamonds */
  #define TAROT_8D 35
  
  /** Index of card nine of diamonds */
  #define TAROT_9D 36
  
  /** Index of card ten of diamonds */
  #define TAROT_10D 37
  
  /** Index of card jack of diamonds */
  #define TAROT_JD 38
  
  /** Index of card knight of diamonds */
  #define TAROT_CD 39
  
  /** Index of card queen of diamonds */
  #define TAROT_QD 40
  
  /** Index of card king of diamonds */
  #define TAROT_KD 41
  
  /** Index of card ace of spades */
  #define TAROT_AS 42
  
  /** Index of card two of spades */
  #define TAROT_2S 43
  
  /** Index of card three of spades */
  #define TAROT_3S 44
  
  /** Index of card four of spades */
  #define TAROT_4S 45
  
  /** Index of card five of spades */
  #define TAROT_5S 46
  
  /** Index of card six of spades */
  #define TAROT_6S 47
  
  /** Index of card seven of spades */
  #define TAROT_7S 48
  
  /** Index of card eight of spades */
  #define TAROT_8S 49
  
  /** Index of card nine of spades */
  #define TAROT_9S 50
  
  /** Index of card ten of spades */
  #define TAROT_10S 51
  
  /** Index of card jack of spades */
  #define TAROT_JS 52
  
  /** Index of card knight of spades */
  #define TAROT_CS 53
  
  /** Index of card queen of spades */
  #define TAROT_QS 54
  
  /** Index of card king of spades */
  #define TAROT_KS 55
  
  /** Index of card petit */
  #define TAROT_1T 56
  
  /** Index of card fifteen of trumps */
  #define TAROT_2T 57
  
  /** Index of card fifteen of trumps */
  #define TAROT_3T 58
  
  /** Index of card fifteen of trumps */
  #define TAROT_4T 59
  
  /** Index of card fifteen of trumps */
  #define TAROT_5T 60
  
  /** Index of card fifteen of trumps */
  #define TAROT_6T 61
  
  /** Index of card fifteen of trumps */
  #define TAROT_7T 62
  
  /** Index of card fifteen of trumps */
  #define TAROT_8T 63
  
  /** Index of card fifteen of trumps */
  #define TAROT_9T 64
  
  /** Index of card fifteen of trumps */
  #define TAROT_10T 65
  
  /** Index of card fifteen of trumps */
  #define TAROT_11T 66
  
  /** Index of card fifteen of trumps */
  #define TAROT_12T 67
  
  /** Index of card fifteen of trumps */
  #define TAROT_13T 68
  
  /** Index of card fifteen of trumps */
  #define TAROT_14T 69
  
  /** Index of card fifteen of trumps */
  #define TAROT_15T 70
  
  /** Index of card fifteen of trumps */
  #define TAROT_16T 71
  
  /** Index of card fifteen of trumps */
  #define TAROT_17T 72
  
  /** Index of card fifteen of trumps */
  #define TAROT_18T 73
  
  /** Index of card fifteen of trumps */
  #define TAROT_19T 74
  
  /** Index of card fifteen of trumps */
  #define TAROT_20T 75
  
  /** Index of card fifteen of trumps */
  #define TAROT_21T 76
  
  /** Index of card excuse */
  #define TAROT_EXC 77
  

#define TAROT_PETIT TAROT_1T
#define TAROT_TWENTYONE TAROT_21T

  typedef char static_assertion_excuse_eq_77[(TAROT_EXCUSE == TAROT_EXC)
                                             ? 1 : -1];

  static int of (TarotNumber n, TarotSuit s, TarotCard * c);
  static int decompose (TarotCard c, TarotNumber * n, TarotSuit * s);
  static TarotCard card_parse (const char *text, char **end);
  static TarotCard card_parse_c (const char *text, char **end);
  static size_t card_to_string (TarotCard c, size_t max, char *dest);
  static size_t card_to_string_c (TarotCard c, size_t max, char *dest);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* not H_TAROT_CARDS_PRIVATE_INCLUDED */

/* Local Variables: */
/* mode: c */
/* End: */
