/**
 * file cards_private_impl.h
 *
 * Copyright (C) 2018 Vivien Kraus <vivien@planete-kraus.eu>
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */
#ifndef H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED
#define H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED
#include <stddef.h>
#include <tarot/cards_private.h>
#include <string.h>
#include <assert.h>
#include <gettext.h>
#define _(String) dgettext (PACKAGE, String)

static inline int
of (TarotNumber n, TarotSuit s, TarotCard * c)
{
    
    if (n == 1 && s == TAROT_HEARTS)
      {
	*c = 0;
	return 0;
      }
    if (n == 2 && s == TAROT_HEARTS)
      {
	*c = 1;
	return 0;
      }
    if (n == 3 && s == TAROT_HEARTS)
      {
	*c = 2;
	return 0;
      }
    if (n == 4 && s == TAROT_HEARTS)
      {
	*c = 3;
	return 0;
      }
    if (n == 5 && s == TAROT_HEARTS)
      {
	*c = 4;
	return 0;
      }
    if (n == 6 && s == TAROT_HEARTS)
      {
	*c = 5;
	return 0;
      }
    if (n == 7 && s == TAROT_HEARTS)
      {
	*c = 6;
	return 0;
      }
    if (n == 8 && s == TAROT_HEARTS)
      {
	*c = 7;
	return 0;
      }
    if (n == 9 && s == TAROT_HEARTS)
      {
	*c = 8;
	return 0;
      }
    if (n == 10 && s == TAROT_HEARTS)
      {
	*c = 9;
	return 0;
      }
    if (n == 11 && s == TAROT_HEARTS)
      {
	*c = 10;
	return 0;
      }
    if (n == 12 && s == TAROT_HEARTS)
      {
	*c = 11;
	return 0;
      }
    if (n == 13 && s == TAROT_HEARTS)
      {
	*c = 12;
	return 0;
      }
    if (n == 14 && s == TAROT_HEARTS)
      {
	*c = 13;
	return 0;
      }
    if (n == 1 && s == TAROT_CLUBS)
      {
	*c = 14;
	return 0;
      }
    if (n == 2 && s == TAROT_CLUBS)
      {
	*c = 15;
	return 0;
      }
    if (n == 3 && s == TAROT_CLUBS)
      {
	*c = 16;
	return 0;
      }
    if (n == 4 && s == TAROT_CLUBS)
      {
	*c = 17;
	return 0;
      }
    if (n == 5 && s == TAROT_CLUBS)
      {
	*c = 18;
	return 0;
      }
    if (n == 6 && s == TAROT_CLUBS)
      {
	*c = 19;
	return 0;
      }
    if (n == 7 && s == TAROT_CLUBS)
      {
	*c = 20;
	return 0;
      }
    if (n == 8 && s == TAROT_CLUBS)
      {
	*c = 21;
	return 0;
      }
    if (n == 9 && s == TAROT_CLUBS)
      {
	*c = 22;
	return 0;
      }
    if (n == 10 && s == TAROT_CLUBS)
      {
	*c = 23;
	return 0;
      }
    if (n == 11 && s == TAROT_CLUBS)
      {
	*c = 24;
	return 0;
      }
    if (n == 12 && s == TAROT_CLUBS)
      {
	*c = 25;
	return 0;
      }
    if (n == 13 && s == TAROT_CLUBS)
      {
	*c = 26;
	return 0;
      }
    if (n == 14 && s == TAROT_CLUBS)
      {
	*c = 27;
	return 0;
      }
    if (n == 1 && s == TAROT_DIAMONDS)
      {
	*c = 28;
	return 0;
      }
    if (n == 2 && s == TAROT_DIAMONDS)
      {
	*c = 29;
	return 0;
      }
    if (n == 3 && s == TAROT_DIAMONDS)
      {
	*c = 30;
	return 0;
      }
    if (n == 4 && s == TAROT_DIAMONDS)
      {
	*c = 31;
	return 0;
      }
    if (n == 5 && s == TAROT_DIAMONDS)
      {
	*c = 32;
	return 0;
      }
    if (n == 6 && s == TAROT_DIAMONDS)
      {
	*c = 33;
	return 0;
      }
    if (n == 7 && s == TAROT_DIAMONDS)
      {
	*c = 34;
	return 0;
      }
    if (n == 8 && s == TAROT_DIAMONDS)
      {
	*c = 35;
	return 0;
      }
    if (n == 9 && s == TAROT_DIAMONDS)
      {
	*c = 36;
	return 0;
      }
    if (n == 10 && s == TAROT_DIAMONDS)
      {
	*c = 37;
	return 0;
      }
    if (n == 11 && s == TAROT_DIAMONDS)
      {
	*c = 38;
	return 0;
      }
    if (n == 12 && s == TAROT_DIAMONDS)
      {
	*c = 39;
	return 0;
      }
    if (n == 13 && s == TAROT_DIAMONDS)
      {
	*c = 40;
	return 0;
      }
    if (n == 14 && s == TAROT_DIAMONDS)
      {
	*c = 41;
	return 0;
      }
    if (n == 1 && s == TAROT_SPADES)
      {
	*c = 42;
	return 0;
      }
    if (n == 2 && s == TAROT_SPADES)
      {
	*c = 43;
	return 0;
      }
    if (n == 3 && s == TAROT_SPADES)
      {
	*c = 44;
	return 0;
      }
    if (n == 4 && s == TAROT_SPADES)
      {
	*c = 45;
	return 0;
      }
    if (n == 5 && s == TAROT_SPADES)
      {
	*c = 46;
	return 0;
      }
    if (n == 6 && s == TAROT_SPADES)
      {
	*c = 47;
	return 0;
      }
    if (n == 7 && s == TAROT_SPADES)
      {
	*c = 48;
	return 0;
      }
    if (n == 8 && s == TAROT_SPADES)
      {
	*c = 49;
	return 0;
      }
    if (n == 9 && s == TAROT_SPADES)
      {
	*c = 50;
	return 0;
      }
    if (n == 10 && s == TAROT_SPADES)
      {
	*c = 51;
	return 0;
      }
    if (n == 11 && s == TAROT_SPADES)
      {
	*c = 52;
	return 0;
      }
    if (n == 12 && s == TAROT_SPADES)
      {
	*c = 53;
	return 0;
      }
    if (n == 13 && s == TAROT_SPADES)
      {
	*c = 54;
	return 0;
      }
    if (n == 14 && s == TAROT_SPADES)
      {
	*c = 55;
	return 0;
      }
    if (n == 1 && s == TAROT_TRUMPS)
      {
	*c = 56;
	return 0;
      }
    if (n == 2 && s == TAROT_TRUMPS)
      {
	*c = 57;
	return 0;
      }
    if (n == 3 && s == TAROT_TRUMPS)
      {
	*c = 58;
	return 0;
      }
    if (n == 4 && s == TAROT_TRUMPS)
      {
	*c = 59;
	return 0;
      }
    if (n == 5 && s == TAROT_TRUMPS)
      {
	*c = 60;
	return 0;
      }
    if (n == 6 && s == TAROT_TRUMPS)
      {
	*c = 61;
	return 0;
      }
    if (n == 7 && s == TAROT_TRUMPS)
      {
	*c = 62;
	return 0;
      }
    if (n == 8 && s == TAROT_TRUMPS)
      {
	*c = 63;
	return 0;
      }
    if (n == 9 && s == TAROT_TRUMPS)
      {
	*c = 64;
	return 0;
      }
    if (n == 10 && s == TAROT_TRUMPS)
      {
	*c = 65;
	return 0;
      }
    if (n == 11 && s == TAROT_TRUMPS)
      {
	*c = 66;
	return 0;
      }
    if (n == 12 && s == TAROT_TRUMPS)
      {
	*c = 67;
	return 0;
      }
    if (n == 13 && s == TAROT_TRUMPS)
      {
	*c = 68;
	return 0;
      }
    if (n == 14 && s == TAROT_TRUMPS)
      {
	*c = 69;
	return 0;
      }
    if (n == 15 && s == TAROT_TRUMPS)
      {
	*c = 70;
	return 0;
      }
    if (n == 16 && s == TAROT_TRUMPS)
      {
	*c = 71;
	return 0;
      }
    if (n == 17 && s == TAROT_TRUMPS)
      {
	*c = 72;
	return 0;
      }
    if (n == 18 && s == TAROT_TRUMPS)
      {
	*c = 73;
	return 0;
      }
    if (n == 19 && s == TAROT_TRUMPS)
      {
	*c = 74;
	return 0;
      }
    if (n == 20 && s == TAROT_TRUMPS)
      {
	*c = 75;
	return 0;
      }
    if (n == 21 && s == TAROT_TRUMPS)
      {
	*c = 76;
	return 0;
      }
  return 1;
}

static inline int
decompose (TarotCard c, TarotNumber * n, TarotSuit * s)
{
    
    if (c == 0)
      {
	*n = 1;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 1)
      {
	*n = 2;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 2)
      {
	*n = 3;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 3)
      {
	*n = 4;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 4)
      {
	*n = 5;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 5)
      {
	*n = 6;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 6)
      {
	*n = 7;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 7)
      {
	*n = 8;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 8)
      {
	*n = 9;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 9)
      {
	*n = 10;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 10)
      {
	*n = 11;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 11)
      {
	*n = 12;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 12)
      {
	*n = 13;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 13)
      {
	*n = 14;
	*s = TAROT_HEARTS;
	return 0;
      }
    if (c == 14)
      {
	*n = 1;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 15)
      {
	*n = 2;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 16)
      {
	*n = 3;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 17)
      {
	*n = 4;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 18)
      {
	*n = 5;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 19)
      {
	*n = 6;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 20)
      {
	*n = 7;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 21)
      {
	*n = 8;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 22)
      {
	*n = 9;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 23)
      {
	*n = 10;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 24)
      {
	*n = 11;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 25)
      {
	*n = 12;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 26)
      {
	*n = 13;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 27)
      {
	*n = 14;
	*s = TAROT_CLUBS;
	return 0;
      }
    if (c == 28)
      {
	*n = 1;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 29)
      {
	*n = 2;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 30)
      {
	*n = 3;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 31)
      {
	*n = 4;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 32)
      {
	*n = 5;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 33)
      {
	*n = 6;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 34)
      {
	*n = 7;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 35)
      {
	*n = 8;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 36)
      {
	*n = 9;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 37)
      {
	*n = 10;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 38)
      {
	*n = 11;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 39)
      {
	*n = 12;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 40)
      {
	*n = 13;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 41)
      {
	*n = 14;
	*s = TAROT_DIAMONDS;
	return 0;
      }
    if (c == 42)
      {
	*n = 1;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 43)
      {
	*n = 2;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 44)
      {
	*n = 3;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 45)
      {
	*n = 4;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 46)
      {
	*n = 5;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 47)
      {
	*n = 6;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 48)
      {
	*n = 7;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 49)
      {
	*n = 8;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 50)
      {
	*n = 9;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 51)
      {
	*n = 10;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 52)
      {
	*n = 11;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 53)
      {
	*n = 12;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 54)
      {
	*n = 13;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 55)
      {
	*n = 14;
	*s = TAROT_SPADES;
	return 0;
      }
    if (c == 56)
      {
	*n = 1;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 57)
      {
	*n = 2;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 58)
      {
	*n = 3;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 59)
      {
	*n = 4;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 60)
      {
	*n = 5;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 61)
      {
	*n = 6;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 62)
      {
	*n = 7;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 63)
      {
	*n = 8;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 64)
      {
	*n = 9;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 65)
      {
	*n = 10;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 66)
      {
	*n = 11;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 67)
      {
	*n = 12;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 68)
      {
	*n = 13;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 69)
      {
	*n = 14;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 70)
      {
	*n = 15;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 71)
      {
	*n = 16;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 72)
      {
	*n = 17;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 73)
      {
	*n = 18;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 74)
      {
	*n = 19;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 75)
      {
	*n = 20;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 76)
      {
	*n = 21;
	*s = TAROT_TRUMPS;
	return 0;
      }
    if (c == 77)
      {
	return 1;
      }
  return 1;
}

static inline TarotCard
card_parse (const char *text, char **end)
{
  size_t len = 0;
  len = strlen (text);
  
  if (len >= strlen (_ ("AH"))
      && strncmp (text, _ ("AH"), strlen (_ ("AH"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("AH"));
	}
      return 0;
    }
  else if (len < strlen (_ ("AH"))
	   && strncmp (text, _ ("AH"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("2H"))
      && strncmp (text, _ ("2H"), strlen (_ ("2H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("2H"));
	}
      return 1;
    }
  else if (len < strlen (_ ("2H"))
	   && strncmp (text, _ ("2H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("3H"))
      && strncmp (text, _ ("3H"), strlen (_ ("3H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("3H"));
	}
      return 2;
    }
  else if (len < strlen (_ ("3H"))
	   && strncmp (text, _ ("3H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("4H"))
      && strncmp (text, _ ("4H"), strlen (_ ("4H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("4H"));
	}
      return 3;
    }
  else if (len < strlen (_ ("4H"))
	   && strncmp (text, _ ("4H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("5H"))
      && strncmp (text, _ ("5H"), strlen (_ ("5H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("5H"));
	}
      return 4;
    }
  else if (len < strlen (_ ("5H"))
	   && strncmp (text, _ ("5H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("6H"))
      && strncmp (text, _ ("6H"), strlen (_ ("6H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("6H"));
	}
      return 5;
    }
  else if (len < strlen (_ ("6H"))
	   && strncmp (text, _ ("6H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("7H"))
      && strncmp (text, _ ("7H"), strlen (_ ("7H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("7H"));
	}
      return 6;
    }
  else if (len < strlen (_ ("7H"))
	   && strncmp (text, _ ("7H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("8H"))
      && strncmp (text, _ ("8H"), strlen (_ ("8H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("8H"));
	}
      return 7;
    }
  else if (len < strlen (_ ("8H"))
	   && strncmp (text, _ ("8H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("9H"))
      && strncmp (text, _ ("9H"), strlen (_ ("9H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("9H"));
	}
      return 8;
    }
  else if (len < strlen (_ ("9H"))
	   && strncmp (text, _ ("9H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("10H"))
      && strncmp (text, _ ("10H"), strlen (_ ("10H"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("10H"));
	}
      return 9;
    }
  else if (len < strlen (_ ("10H"))
	   && strncmp (text, _ ("10H"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("JH"))
      && strncmp (text, _ ("JH"), strlen (_ ("JH"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("JH"));
	}
      return 10;
    }
  else if (len < strlen (_ ("JH"))
	   && strncmp (text, _ ("JH"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("CH"))
      && strncmp (text, _ ("CH"), strlen (_ ("CH"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("CH"));
	}
      return 11;
    }
  else if (len < strlen (_ ("CH"))
	   && strncmp (text, _ ("CH"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("QH"))
      && strncmp (text, _ ("QH"), strlen (_ ("QH"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("QH"));
	}
      return 12;
    }
  else if (len < strlen (_ ("QH"))
	   && strncmp (text, _ ("QH"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("KH"))
      && strncmp (text, _ ("KH"), strlen (_ ("KH"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("KH"));
	}
      return 13;
    }
  else if (len < strlen (_ ("KH"))
	   && strncmp (text, _ ("KH"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("AC"))
      && strncmp (text, _ ("AC"), strlen (_ ("AC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("AC"));
	}
      return 14;
    }
  else if (len < strlen (_ ("AC"))
	   && strncmp (text, _ ("AC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("2C"))
      && strncmp (text, _ ("2C"), strlen (_ ("2C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("2C"));
	}
      return 15;
    }
  else if (len < strlen (_ ("2C"))
	   && strncmp (text, _ ("2C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("3C"))
      && strncmp (text, _ ("3C"), strlen (_ ("3C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("3C"));
	}
      return 16;
    }
  else if (len < strlen (_ ("3C"))
	   && strncmp (text, _ ("3C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("4C"))
      && strncmp (text, _ ("4C"), strlen (_ ("4C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("4C"));
	}
      return 17;
    }
  else if (len < strlen (_ ("4C"))
	   && strncmp (text, _ ("4C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("5C"))
      && strncmp (text, _ ("5C"), strlen (_ ("5C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("5C"));
	}
      return 18;
    }
  else if (len < strlen (_ ("5C"))
	   && strncmp (text, _ ("5C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("6C"))
      && strncmp (text, _ ("6C"), strlen (_ ("6C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("6C"));
	}
      return 19;
    }
  else if (len < strlen (_ ("6C"))
	   && strncmp (text, _ ("6C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("7C"))
      && strncmp (text, _ ("7C"), strlen (_ ("7C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("7C"));
	}
      return 20;
    }
  else if (len < strlen (_ ("7C"))
	   && strncmp (text, _ ("7C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("8C"))
      && strncmp (text, _ ("8C"), strlen (_ ("8C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("8C"));
	}
      return 21;
    }
  else if (len < strlen (_ ("8C"))
	   && strncmp (text, _ ("8C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("9C"))
      && strncmp (text, _ ("9C"), strlen (_ ("9C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("9C"));
	}
      return 22;
    }
  else if (len < strlen (_ ("9C"))
	   && strncmp (text, _ ("9C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("10C"))
      && strncmp (text, _ ("10C"), strlen (_ ("10C"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("10C"));
	}
      return 23;
    }
  else if (len < strlen (_ ("10C"))
	   && strncmp (text, _ ("10C"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("JC"))
      && strncmp (text, _ ("JC"), strlen (_ ("JC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("JC"));
	}
      return 24;
    }
  else if (len < strlen (_ ("JC"))
	   && strncmp (text, _ ("JC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("CC"))
      && strncmp (text, _ ("CC"), strlen (_ ("CC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("CC"));
	}
      return 25;
    }
  else if (len < strlen (_ ("CC"))
	   && strncmp (text, _ ("CC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("QC"))
      && strncmp (text, _ ("QC"), strlen (_ ("QC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("QC"));
	}
      return 26;
    }
  else if (len < strlen (_ ("QC"))
	   && strncmp (text, _ ("QC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("KC"))
      && strncmp (text, _ ("KC"), strlen (_ ("KC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("KC"));
	}
      return 27;
    }
  else if (len < strlen (_ ("KC"))
	   && strncmp (text, _ ("KC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("AD"))
      && strncmp (text, _ ("AD"), strlen (_ ("AD"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("AD"));
	}
      return 28;
    }
  else if (len < strlen (_ ("AD"))
	   && strncmp (text, _ ("AD"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("2D"))
      && strncmp (text, _ ("2D"), strlen (_ ("2D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("2D"));
	}
      return 29;
    }
  else if (len < strlen (_ ("2D"))
	   && strncmp (text, _ ("2D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("3D"))
      && strncmp (text, _ ("3D"), strlen (_ ("3D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("3D"));
	}
      return 30;
    }
  else if (len < strlen (_ ("3D"))
	   && strncmp (text, _ ("3D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("4D"))
      && strncmp (text, _ ("4D"), strlen (_ ("4D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("4D"));
	}
      return 31;
    }
  else if (len < strlen (_ ("4D"))
	   && strncmp (text, _ ("4D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("5D"))
      && strncmp (text, _ ("5D"), strlen (_ ("5D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("5D"));
	}
      return 32;
    }
  else if (len < strlen (_ ("5D"))
	   && strncmp (text, _ ("5D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("6D"))
      && strncmp (text, _ ("6D"), strlen (_ ("6D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("6D"));
	}
      return 33;
    }
  else if (len < strlen (_ ("6D"))
	   && strncmp (text, _ ("6D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("7D"))
      && strncmp (text, _ ("7D"), strlen (_ ("7D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("7D"));
	}
      return 34;
    }
  else if (len < strlen (_ ("7D"))
	   && strncmp (text, _ ("7D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("8D"))
      && strncmp (text, _ ("8D"), strlen (_ ("8D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("8D"));
	}
      return 35;
    }
  else if (len < strlen (_ ("8D"))
	   && strncmp (text, _ ("8D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("9D"))
      && strncmp (text, _ ("9D"), strlen (_ ("9D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("9D"));
	}
      return 36;
    }
  else if (len < strlen (_ ("9D"))
	   && strncmp (text, _ ("9D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("10D"))
      && strncmp (text, _ ("10D"), strlen (_ ("10D"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("10D"));
	}
      return 37;
    }
  else if (len < strlen (_ ("10D"))
	   && strncmp (text, _ ("10D"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("JD"))
      && strncmp (text, _ ("JD"), strlen (_ ("JD"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("JD"));
	}
      return 38;
    }
  else if (len < strlen (_ ("JD"))
	   && strncmp (text, _ ("JD"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("CD"))
      && strncmp (text, _ ("CD"), strlen (_ ("CD"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("CD"));
	}
      return 39;
    }
  else if (len < strlen (_ ("CD"))
	   && strncmp (text, _ ("CD"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("QD"))
      && strncmp (text, _ ("QD"), strlen (_ ("QD"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("QD"));
	}
      return 40;
    }
  else if (len < strlen (_ ("QD"))
	   && strncmp (text, _ ("QD"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("KD"))
      && strncmp (text, _ ("KD"), strlen (_ ("KD"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("KD"));
	}
      return 41;
    }
  else if (len < strlen (_ ("KD"))
	   && strncmp (text, _ ("KD"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("AS"))
      && strncmp (text, _ ("AS"), strlen (_ ("AS"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("AS"));
	}
      return 42;
    }
  else if (len < strlen (_ ("AS"))
	   && strncmp (text, _ ("AS"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("2S"))
      && strncmp (text, _ ("2S"), strlen (_ ("2S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("2S"));
	}
      return 43;
    }
  else if (len < strlen (_ ("2S"))
	   && strncmp (text, _ ("2S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("3S"))
      && strncmp (text, _ ("3S"), strlen (_ ("3S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("3S"));
	}
      return 44;
    }
  else if (len < strlen (_ ("3S"))
	   && strncmp (text, _ ("3S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("4S"))
      && strncmp (text, _ ("4S"), strlen (_ ("4S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("4S"));
	}
      return 45;
    }
  else if (len < strlen (_ ("4S"))
	   && strncmp (text, _ ("4S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("5S"))
      && strncmp (text, _ ("5S"), strlen (_ ("5S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("5S"));
	}
      return 46;
    }
  else if (len < strlen (_ ("5S"))
	   && strncmp (text, _ ("5S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("6S"))
      && strncmp (text, _ ("6S"), strlen (_ ("6S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("6S"));
	}
      return 47;
    }
  else if (len < strlen (_ ("6S"))
	   && strncmp (text, _ ("6S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("7S"))
      && strncmp (text, _ ("7S"), strlen (_ ("7S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("7S"));
	}
      return 48;
    }
  else if (len < strlen (_ ("7S"))
	   && strncmp (text, _ ("7S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("8S"))
      && strncmp (text, _ ("8S"), strlen (_ ("8S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("8S"));
	}
      return 49;
    }
  else if (len < strlen (_ ("8S"))
	   && strncmp (text, _ ("8S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("9S"))
      && strncmp (text, _ ("9S"), strlen (_ ("9S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("9S"));
	}
      return 50;
    }
  else if (len < strlen (_ ("9S"))
	   && strncmp (text, _ ("9S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("10S"))
      && strncmp (text, _ ("10S"), strlen (_ ("10S"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("10S"));
	}
      return 51;
    }
  else if (len < strlen (_ ("10S"))
	   && strncmp (text, _ ("10S"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("JS"))
      && strncmp (text, _ ("JS"), strlen (_ ("JS"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("JS"));
	}
      return 52;
    }
  else if (len < strlen (_ ("JS"))
	   && strncmp (text, _ ("JS"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("CS"))
      && strncmp (text, _ ("CS"), strlen (_ ("CS"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("CS"));
	}
      return 53;
    }
  else if (len < strlen (_ ("CS"))
	   && strncmp (text, _ ("CS"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("QS"))
      && strncmp (text, _ ("QS"), strlen (_ ("QS"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("QS"));
	}
      return 54;
    }
  else if (len < strlen (_ ("QS"))
	   && strncmp (text, _ ("QS"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("KS"))
      && strncmp (text, _ ("KS"), strlen (_ ("KS"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("KS"));
	}
      return 55;
    }
  else if (len < strlen (_ ("KS"))
	   && strncmp (text, _ ("KS"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("1T"))
      && strncmp (text, _ ("1T"), strlen (_ ("1T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("1T"));
	}
      return 56;
    }
  else if (len < strlen (_ ("1T"))
	   && strncmp (text, _ ("1T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("2T"))
      && strncmp (text, _ ("2T"), strlen (_ ("2T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("2T"));
	}
      return 57;
    }
  else if (len < strlen (_ ("2T"))
	   && strncmp (text, _ ("2T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("3T"))
      && strncmp (text, _ ("3T"), strlen (_ ("3T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("3T"));
	}
      return 58;
    }
  else if (len < strlen (_ ("3T"))
	   && strncmp (text, _ ("3T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("4T"))
      && strncmp (text, _ ("4T"), strlen (_ ("4T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("4T"));
	}
      return 59;
    }
  else if (len < strlen (_ ("4T"))
	   && strncmp (text, _ ("4T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("5T"))
      && strncmp (text, _ ("5T"), strlen (_ ("5T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("5T"));
	}
      return 60;
    }
  else if (len < strlen (_ ("5T"))
	   && strncmp (text, _ ("5T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("6T"))
      && strncmp (text, _ ("6T"), strlen (_ ("6T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("6T"));
	}
      return 61;
    }
  else if (len < strlen (_ ("6T"))
	   && strncmp (text, _ ("6T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("7T"))
      && strncmp (text, _ ("7T"), strlen (_ ("7T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("7T"));
	}
      return 62;
    }
  else if (len < strlen (_ ("7T"))
	   && strncmp (text, _ ("7T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("8T"))
      && strncmp (text, _ ("8T"), strlen (_ ("8T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("8T"));
	}
      return 63;
    }
  else if (len < strlen (_ ("8T"))
	   && strncmp (text, _ ("8T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("9T"))
      && strncmp (text, _ ("9T"), strlen (_ ("9T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("9T"));
	}
      return 64;
    }
  else if (len < strlen (_ ("9T"))
	   && strncmp (text, _ ("9T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("10T"))
      && strncmp (text, _ ("10T"), strlen (_ ("10T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("10T"));
	}
      return 65;
    }
  else if (len < strlen (_ ("10T"))
	   && strncmp (text, _ ("10T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("11T"))
      && strncmp (text, _ ("11T"), strlen (_ ("11T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("11T"));
	}
      return 66;
    }
  else if (len < strlen (_ ("11T"))
	   && strncmp (text, _ ("11T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("12T"))
      && strncmp (text, _ ("12T"), strlen (_ ("12T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("12T"));
	}
      return 67;
    }
  else if (len < strlen (_ ("12T"))
	   && strncmp (text, _ ("12T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("13T"))
      && strncmp (text, _ ("13T"), strlen (_ ("13T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("13T"));
	}
      return 68;
    }
  else if (len < strlen (_ ("13T"))
	   && strncmp (text, _ ("13T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("14T"))
      && strncmp (text, _ ("14T"), strlen (_ ("14T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("14T"));
	}
      return 69;
    }
  else if (len < strlen (_ ("14T"))
	   && strncmp (text, _ ("14T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("15T"))
      && strncmp (text, _ ("15T"), strlen (_ ("15T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("15T"));
	}
      return 70;
    }
  else if (len < strlen (_ ("15T"))
	   && strncmp (text, _ ("15T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("16T"))
      && strncmp (text, _ ("16T"), strlen (_ ("16T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("16T"));
	}
      return 71;
    }
  else if (len < strlen (_ ("16T"))
	   && strncmp (text, _ ("16T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("17T"))
      && strncmp (text, _ ("17T"), strlen (_ ("17T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("17T"));
	}
      return 72;
    }
  else if (len < strlen (_ ("17T"))
	   && strncmp (text, _ ("17T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("18T"))
      && strncmp (text, _ ("18T"), strlen (_ ("18T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("18T"));
	}
      return 73;
    }
  else if (len < strlen (_ ("18T"))
	   && strncmp (text, _ ("18T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("19T"))
      && strncmp (text, _ ("19T"), strlen (_ ("19T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("19T"));
	}
      return 74;
    }
  else if (len < strlen (_ ("19T"))
	   && strncmp (text, _ ("19T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("20T"))
      && strncmp (text, _ ("20T"), strlen (_ ("20T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("20T"));
	}
      return 75;
    }
  else if (len < strlen (_ ("20T"))
	   && strncmp (text, _ ("20T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("21T"))
      && strncmp (text, _ ("21T"), strlen (_ ("21T"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("21T"));
	}
      return 76;
    }
  else if (len < strlen (_ ("21T"))
	   && strncmp (text, _ ("21T"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen (_ ("EXC"))
      && strncmp (text, _ ("EXC"), strlen (_ ("EXC"))) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen (_ ("EXC"));
	}
      return 77;
    }
  else if (len < strlen (_ ("EXC"))
	   && strncmp (text, _ ("EXC"), len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (end != NULL)
    {
      *end = (char *) text;
    }
  return (TarotCard) (-1);
}

static inline TarotCard
card_parse_c (const char *text, char **end)
{
  size_t len = 0;
  len = strlen (text);
  
  if (len >= strlen ("AH")
      && strncmp (text, "AH", strlen ("AH")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("AH");
	}
      return 0;
    }
  else if (len < strlen ("AH")
	   && strncmp (text, "AH", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("2H")
      && strncmp (text, "2H", strlen ("2H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("2H");
	}
      return 1;
    }
  else if (len < strlen ("2H")
	   && strncmp (text, "2H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("3H")
      && strncmp (text, "3H", strlen ("3H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("3H");
	}
      return 2;
    }
  else if (len < strlen ("3H")
	   && strncmp (text, "3H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("4H")
      && strncmp (text, "4H", strlen ("4H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("4H");
	}
      return 3;
    }
  else if (len < strlen ("4H")
	   && strncmp (text, "4H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("5H")
      && strncmp (text, "5H", strlen ("5H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("5H");
	}
      return 4;
    }
  else if (len < strlen ("5H")
	   && strncmp (text, "5H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("6H")
      && strncmp (text, "6H", strlen ("6H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("6H");
	}
      return 5;
    }
  else if (len < strlen ("6H")
	   && strncmp (text, "6H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("7H")
      && strncmp (text, "7H", strlen ("7H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("7H");
	}
      return 6;
    }
  else if (len < strlen ("7H")
	   && strncmp (text, "7H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("8H")
      && strncmp (text, "8H", strlen ("8H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("8H");
	}
      return 7;
    }
  else if (len < strlen ("8H")
	   && strncmp (text, "8H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("9H")
      && strncmp (text, "9H", strlen ("9H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("9H");
	}
      return 8;
    }
  else if (len < strlen ("9H")
	   && strncmp (text, "9H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("10H")
      && strncmp (text, "10H", strlen ("10H")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("10H");
	}
      return 9;
    }
  else if (len < strlen ("10H")
	   && strncmp (text, "10H", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("JH")
      && strncmp (text, "JH", strlen ("JH")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("JH");
	}
      return 10;
    }
  else if (len < strlen ("JH")
	   && strncmp (text, "JH", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("CH")
      && strncmp (text, "CH", strlen ("CH")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("CH");
	}
      return 11;
    }
  else if (len < strlen ("CH")
	   && strncmp (text, "CH", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("QH")
      && strncmp (text, "QH", strlen ("QH")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("QH");
	}
      return 12;
    }
  else if (len < strlen ("QH")
	   && strncmp (text, "QH", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("KH")
      && strncmp (text, "KH", strlen ("KH")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("KH");
	}
      return 13;
    }
  else if (len < strlen ("KH")
	   && strncmp (text, "KH", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("AC")
      && strncmp (text, "AC", strlen ("AC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("AC");
	}
      return 14;
    }
  else if (len < strlen ("AC")
	   && strncmp (text, "AC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("2C")
      && strncmp (text, "2C", strlen ("2C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("2C");
	}
      return 15;
    }
  else if (len < strlen ("2C")
	   && strncmp (text, "2C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("3C")
      && strncmp (text, "3C", strlen ("3C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("3C");
	}
      return 16;
    }
  else if (len < strlen ("3C")
	   && strncmp (text, "3C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("4C")
      && strncmp (text, "4C", strlen ("4C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("4C");
	}
      return 17;
    }
  else if (len < strlen ("4C")
	   && strncmp (text, "4C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("5C")
      && strncmp (text, "5C", strlen ("5C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("5C");
	}
      return 18;
    }
  else if (len < strlen ("5C")
	   && strncmp (text, "5C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("6C")
      && strncmp (text, "6C", strlen ("6C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("6C");
	}
      return 19;
    }
  else if (len < strlen ("6C")
	   && strncmp (text, "6C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("7C")
      && strncmp (text, "7C", strlen ("7C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("7C");
	}
      return 20;
    }
  else if (len < strlen ("7C")
	   && strncmp (text, "7C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("8C")
      && strncmp (text, "8C", strlen ("8C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("8C");
	}
      return 21;
    }
  else if (len < strlen ("8C")
	   && strncmp (text, "8C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("9C")
      && strncmp (text, "9C", strlen ("9C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("9C");
	}
      return 22;
    }
  else if (len < strlen ("9C")
	   && strncmp (text, "9C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("10C")
      && strncmp (text, "10C", strlen ("10C")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("10C");
	}
      return 23;
    }
  else if (len < strlen ("10C")
	   && strncmp (text, "10C", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("JC")
      && strncmp (text, "JC", strlen ("JC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("JC");
	}
      return 24;
    }
  else if (len < strlen ("JC")
	   && strncmp (text, "JC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("CC")
      && strncmp (text, "CC", strlen ("CC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("CC");
	}
      return 25;
    }
  else if (len < strlen ("CC")
	   && strncmp (text, "CC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("QC")
      && strncmp (text, "QC", strlen ("QC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("QC");
	}
      return 26;
    }
  else if (len < strlen ("QC")
	   && strncmp (text, "QC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("KC")
      && strncmp (text, "KC", strlen ("KC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("KC");
	}
      return 27;
    }
  else if (len < strlen ("KC")
	   && strncmp (text, "KC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("AD")
      && strncmp (text, "AD", strlen ("AD")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("AD");
	}
      return 28;
    }
  else if (len < strlen ("AD")
	   && strncmp (text, "AD", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("2D")
      && strncmp (text, "2D", strlen ("2D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("2D");
	}
      return 29;
    }
  else if (len < strlen ("2D")
	   && strncmp (text, "2D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("3D")
      && strncmp (text, "3D", strlen ("3D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("3D");
	}
      return 30;
    }
  else if (len < strlen ("3D")
	   && strncmp (text, "3D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("4D")
      && strncmp (text, "4D", strlen ("4D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("4D");
	}
      return 31;
    }
  else if (len < strlen ("4D")
	   && strncmp (text, "4D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("5D")
      && strncmp (text, "5D", strlen ("5D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("5D");
	}
      return 32;
    }
  else if (len < strlen ("5D")
	   && strncmp (text, "5D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("6D")
      && strncmp (text, "6D", strlen ("6D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("6D");
	}
      return 33;
    }
  else if (len < strlen ("6D")
	   && strncmp (text, "6D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("7D")
      && strncmp (text, "7D", strlen ("7D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("7D");
	}
      return 34;
    }
  else if (len < strlen ("7D")
	   && strncmp (text, "7D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("8D")
      && strncmp (text, "8D", strlen ("8D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("8D");
	}
      return 35;
    }
  else if (len < strlen ("8D")
	   && strncmp (text, "8D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("9D")
      && strncmp (text, "9D", strlen ("9D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("9D");
	}
      return 36;
    }
  else if (len < strlen ("9D")
	   && strncmp (text, "9D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("10D")
      && strncmp (text, "10D", strlen ("10D")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("10D");
	}
      return 37;
    }
  else if (len < strlen ("10D")
	   && strncmp (text, "10D", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("JD")
      && strncmp (text, "JD", strlen ("JD")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("JD");
	}
      return 38;
    }
  else if (len < strlen ("JD")
	   && strncmp (text, "JD", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("CD")
      && strncmp (text, "CD", strlen ("CD")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("CD");
	}
      return 39;
    }
  else if (len < strlen ("CD")
	   && strncmp (text, "CD", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("QD")
      && strncmp (text, "QD", strlen ("QD")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("QD");
	}
      return 40;
    }
  else if (len < strlen ("QD")
	   && strncmp (text, "QD", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("KD")
      && strncmp (text, "KD", strlen ("KD")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("KD");
	}
      return 41;
    }
  else if (len < strlen ("KD")
	   && strncmp (text, "KD", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("AS")
      && strncmp (text, "AS", strlen ("AS")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("AS");
	}
      return 42;
    }
  else if (len < strlen ("AS")
	   && strncmp (text, "AS", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("2S")
      && strncmp (text, "2S", strlen ("2S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("2S");
	}
      return 43;
    }
  else if (len < strlen ("2S")
	   && strncmp (text, "2S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("3S")
      && strncmp (text, "3S", strlen ("3S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("3S");
	}
      return 44;
    }
  else if (len < strlen ("3S")
	   && strncmp (text, "3S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("4S")
      && strncmp (text, "4S", strlen ("4S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("4S");
	}
      return 45;
    }
  else if (len < strlen ("4S")
	   && strncmp (text, "4S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("5S")
      && strncmp (text, "5S", strlen ("5S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("5S");
	}
      return 46;
    }
  else if (len < strlen ("5S")
	   && strncmp (text, "5S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("6S")
      && strncmp (text, "6S", strlen ("6S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("6S");
	}
      return 47;
    }
  else if (len < strlen ("6S")
	   && strncmp (text, "6S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("7S")
      && strncmp (text, "7S", strlen ("7S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("7S");
	}
      return 48;
    }
  else if (len < strlen ("7S")
	   && strncmp (text, "7S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("8S")
      && strncmp (text, "8S", strlen ("8S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("8S");
	}
      return 49;
    }
  else if (len < strlen ("8S")
	   && strncmp (text, "8S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("9S")
      && strncmp (text, "9S", strlen ("9S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("9S");
	}
      return 50;
    }
  else if (len < strlen ("9S")
	   && strncmp (text, "9S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("10S")
      && strncmp (text, "10S", strlen ("10S")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("10S");
	}
      return 51;
    }
  else if (len < strlen ("10S")
	   && strncmp (text, "10S", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("JS")
      && strncmp (text, "JS", strlen ("JS")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("JS");
	}
      return 52;
    }
  else if (len < strlen ("JS")
	   && strncmp (text, "JS", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("CS")
      && strncmp (text, "CS", strlen ("CS")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("CS");
	}
      return 53;
    }
  else if (len < strlen ("CS")
	   && strncmp (text, "CS", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("QS")
      && strncmp (text, "QS", strlen ("QS")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("QS");
	}
      return 54;
    }
  else if (len < strlen ("QS")
	   && strncmp (text, "QS", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("KS")
      && strncmp (text, "KS", strlen ("KS")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("KS");
	}
      return 55;
    }
  else if (len < strlen ("KS")
	   && strncmp (text, "KS", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("1T")
      && strncmp (text, "1T", strlen ("1T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("1T");
	}
      return 56;
    }
  else if (len < strlen ("1T")
	   && strncmp (text, "1T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("2T")
      && strncmp (text, "2T", strlen ("2T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("2T");
	}
      return 57;
    }
  else if (len < strlen ("2T")
	   && strncmp (text, "2T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("3T")
      && strncmp (text, "3T", strlen ("3T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("3T");
	}
      return 58;
    }
  else if (len < strlen ("3T")
	   && strncmp (text, "3T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("4T")
      && strncmp (text, "4T", strlen ("4T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("4T");
	}
      return 59;
    }
  else if (len < strlen ("4T")
	   && strncmp (text, "4T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("5T")
      && strncmp (text, "5T", strlen ("5T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("5T");
	}
      return 60;
    }
  else if (len < strlen ("5T")
	   && strncmp (text, "5T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("6T")
      && strncmp (text, "6T", strlen ("6T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("6T");
	}
      return 61;
    }
  else if (len < strlen ("6T")
	   && strncmp (text, "6T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("7T")
      && strncmp (text, "7T", strlen ("7T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("7T");
	}
      return 62;
    }
  else if (len < strlen ("7T")
	   && strncmp (text, "7T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("8T")
      && strncmp (text, "8T", strlen ("8T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("8T");
	}
      return 63;
    }
  else if (len < strlen ("8T")
	   && strncmp (text, "8T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("9T")
      && strncmp (text, "9T", strlen ("9T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("9T");
	}
      return 64;
    }
  else if (len < strlen ("9T")
	   && strncmp (text, "9T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("10T")
      && strncmp (text, "10T", strlen ("10T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("10T");
	}
      return 65;
    }
  else if (len < strlen ("10T")
	   && strncmp (text, "10T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("11T")
      && strncmp (text, "11T", strlen ("11T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("11T");
	}
      return 66;
    }
  else if (len < strlen ("11T")
	   && strncmp (text, "11T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("12T")
      && strncmp (text, "12T", strlen ("12T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("12T");
	}
      return 67;
    }
  else if (len < strlen ("12T")
	   && strncmp (text, "12T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("13T")
      && strncmp (text, "13T", strlen ("13T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("13T");
	}
      return 68;
    }
  else if (len < strlen ("13T")
	   && strncmp (text, "13T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("14T")
      && strncmp (text, "14T", strlen ("14T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("14T");
	}
      return 69;
    }
  else if (len < strlen ("14T")
	   && strncmp (text, "14T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("15T")
      && strncmp (text, "15T", strlen ("15T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("15T");
	}
      return 70;
    }
  else if (len < strlen ("15T")
	   && strncmp (text, "15T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("16T")
      && strncmp (text, "16T", strlen ("16T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("16T");
	}
      return 71;
    }
  else if (len < strlen ("16T")
	   && strncmp (text, "16T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("17T")
      && strncmp (text, "17T", strlen ("17T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("17T");
	}
      return 72;
    }
  else if (len < strlen ("17T")
	   && strncmp (text, "17T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("18T")
      && strncmp (text, "18T", strlen ("18T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("18T");
	}
      return 73;
    }
  else if (len < strlen ("18T")
	   && strncmp (text, "18T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("19T")
      && strncmp (text, "19T", strlen ("19T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("19T");
	}
      return 74;
    }
  else if (len < strlen ("19T")
	   && strncmp (text, "19T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("20T")
      && strncmp (text, "20T", strlen ("20T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("20T");
	}
      return 75;
    }
  else if (len < strlen ("20T")
	   && strncmp (text, "20T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("21T")
      && strncmp (text, "21T", strlen ("21T")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("21T");
	}
      return 76;
    }
  else if (len < strlen ("21T")
	   && strncmp (text, "21T", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (len >= strlen ("EXC")
      && strncmp (text, "EXC", strlen ("EXC")) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + strlen ("EXC");
	}
      return 77;
    }
  else if (len < strlen ("EXC")
	   && strncmp (text, "EXC", len) == 0)
    {
      if (end != NULL)
	{
	  *end = (char *) text + len;
	  assert (**end == '\0');
	}
      return (TarotCard) (-1);
    }
  
  if (end != NULL)
    {
      *end = (char *) text;
    }
  return (TarotCard) (-1);
}

static inline size_t
card_to_string_c (TarotCard c, size_t max, char *dest)
{
    
    if (c == 0)
      {
	size_t required = strlen ("AH");
	if (max > required)
	  {
	    strncpy (dest, "AH", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "AH", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 1)
      {
	size_t required = strlen ("2H");
	if (max > required)
	  {
	    strncpy (dest, "2H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "2H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 2)
      {
	size_t required = strlen ("3H");
	if (max > required)
	  {
	    strncpy (dest, "3H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "3H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 3)
      {
	size_t required = strlen ("4H");
	if (max > required)
	  {
	    strncpy (dest, "4H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "4H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 4)
      {
	size_t required = strlen ("5H");
	if (max > required)
	  {
	    strncpy (dest, "5H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "5H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 5)
      {
	size_t required = strlen ("6H");
	if (max > required)
	  {
	    strncpy (dest, "6H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "6H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 6)
      {
	size_t required = strlen ("7H");
	if (max > required)
	  {
	    strncpy (dest, "7H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "7H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 7)
      {
	size_t required = strlen ("8H");
	if (max > required)
	  {
	    strncpy (dest, "8H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "8H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 8)
      {
	size_t required = strlen ("9H");
	if (max > required)
	  {
	    strncpy (dest, "9H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "9H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 9)
      {
	size_t required = strlen ("10H");
	if (max > required)
	  {
	    strncpy (dest, "10H", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "10H", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 10)
      {
	size_t required = strlen ("JH");
	if (max > required)
	  {
	    strncpy (dest, "JH", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "JH", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 11)
      {
	size_t required = strlen ("CH");
	if (max > required)
	  {
	    strncpy (dest, "CH", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "CH", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 12)
      {
	size_t required = strlen ("QH");
	if (max > required)
	  {
	    strncpy (dest, "QH", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "QH", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 13)
      {
	size_t required = strlen ("KH");
	if (max > required)
	  {
	    strncpy (dest, "KH", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "KH", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 14)
      {
	size_t required = strlen ("AC");
	if (max > required)
	  {
	    strncpy (dest, "AC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "AC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 15)
      {
	size_t required = strlen ("2C");
	if (max > required)
	  {
	    strncpy (dest, "2C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "2C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 16)
      {
	size_t required = strlen ("3C");
	if (max > required)
	  {
	    strncpy (dest, "3C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "3C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 17)
      {
	size_t required = strlen ("4C");
	if (max > required)
	  {
	    strncpy (dest, "4C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "4C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 18)
      {
	size_t required = strlen ("5C");
	if (max > required)
	  {
	    strncpy (dest, "5C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "5C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 19)
      {
	size_t required = strlen ("6C");
	if (max > required)
	  {
	    strncpy (dest, "6C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "6C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 20)
      {
	size_t required = strlen ("7C");
	if (max > required)
	  {
	    strncpy (dest, "7C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "7C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 21)
      {
	size_t required = strlen ("8C");
	if (max > required)
	  {
	    strncpy (dest, "8C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "8C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 22)
      {
	size_t required = strlen ("9C");
	if (max > required)
	  {
	    strncpy (dest, "9C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "9C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 23)
      {
	size_t required = strlen ("10C");
	if (max > required)
	  {
	    strncpy (dest, "10C", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "10C", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 24)
      {
	size_t required = strlen ("JC");
	if (max > required)
	  {
	    strncpy (dest, "JC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "JC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 25)
      {
	size_t required = strlen ("CC");
	if (max > required)
	  {
	    strncpy (dest, "CC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "CC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 26)
      {
	size_t required = strlen ("QC");
	if (max > required)
	  {
	    strncpy (dest, "QC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "QC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 27)
      {
	size_t required = strlen ("KC");
	if (max > required)
	  {
	    strncpy (dest, "KC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "KC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 28)
      {
	size_t required = strlen ("AD");
	if (max > required)
	  {
	    strncpy (dest, "AD", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "AD", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 29)
      {
	size_t required = strlen ("2D");
	if (max > required)
	  {
	    strncpy (dest, "2D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "2D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 30)
      {
	size_t required = strlen ("3D");
	if (max > required)
	  {
	    strncpy (dest, "3D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "3D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 31)
      {
	size_t required = strlen ("4D");
	if (max > required)
	  {
	    strncpy (dest, "4D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "4D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 32)
      {
	size_t required = strlen ("5D");
	if (max > required)
	  {
	    strncpy (dest, "5D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "5D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 33)
      {
	size_t required = strlen ("6D");
	if (max > required)
	  {
	    strncpy (dest, "6D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "6D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 34)
      {
	size_t required = strlen ("7D");
	if (max > required)
	  {
	    strncpy (dest, "7D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "7D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 35)
      {
	size_t required = strlen ("8D");
	if (max > required)
	  {
	    strncpy (dest, "8D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "8D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 36)
      {
	size_t required = strlen ("9D");
	if (max > required)
	  {
	    strncpy (dest, "9D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "9D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 37)
      {
	size_t required = strlen ("10D");
	if (max > required)
	  {
	    strncpy (dest, "10D", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "10D", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 38)
      {
	size_t required = strlen ("JD");
	if (max > required)
	  {
	    strncpy (dest, "JD", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "JD", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 39)
      {
	size_t required = strlen ("CD");
	if (max > required)
	  {
	    strncpy (dest, "CD", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "CD", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 40)
      {
	size_t required = strlen ("QD");
	if (max > required)
	  {
	    strncpy (dest, "QD", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "QD", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 41)
      {
	size_t required = strlen ("KD");
	if (max > required)
	  {
	    strncpy (dest, "KD", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "KD", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 42)
      {
	size_t required = strlen ("AS");
	if (max > required)
	  {
	    strncpy (dest, "AS", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "AS", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 43)
      {
	size_t required = strlen ("2S");
	if (max > required)
	  {
	    strncpy (dest, "2S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "2S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 44)
      {
	size_t required = strlen ("3S");
	if (max > required)
	  {
	    strncpy (dest, "3S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "3S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 45)
      {
	size_t required = strlen ("4S");
	if (max > required)
	  {
	    strncpy (dest, "4S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "4S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 46)
      {
	size_t required = strlen ("5S");
	if (max > required)
	  {
	    strncpy (dest, "5S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "5S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 47)
      {
	size_t required = strlen ("6S");
	if (max > required)
	  {
	    strncpy (dest, "6S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "6S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 48)
      {
	size_t required = strlen ("7S");
	if (max > required)
	  {
	    strncpy (dest, "7S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "7S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 49)
      {
	size_t required = strlen ("8S");
	if (max > required)
	  {
	    strncpy (dest, "8S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "8S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 50)
      {
	size_t required = strlen ("9S");
	if (max > required)
	  {
	    strncpy (dest, "9S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "9S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 51)
      {
	size_t required = strlen ("10S");
	if (max > required)
	  {
	    strncpy (dest, "10S", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "10S", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 52)
      {
	size_t required = strlen ("JS");
	if (max > required)
	  {
	    strncpy (dest, "JS", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "JS", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 53)
      {
	size_t required = strlen ("CS");
	if (max > required)
	  {
	    strncpy (dest, "CS", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "CS", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 54)
      {
	size_t required = strlen ("QS");
	if (max > required)
	  {
	    strncpy (dest, "QS", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "QS", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 55)
      {
	size_t required = strlen ("KS");
	if (max > required)
	  {
	    strncpy (dest, "KS", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "KS", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 56)
      {
	size_t required = strlen ("1T");
	if (max > required)
	  {
	    strncpy (dest, "1T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "1T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 57)
      {
	size_t required = strlen ("2T");
	if (max > required)
	  {
	    strncpy (dest, "2T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "2T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 58)
      {
	size_t required = strlen ("3T");
	if (max > required)
	  {
	    strncpy (dest, "3T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "3T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 59)
      {
	size_t required = strlen ("4T");
	if (max > required)
	  {
	    strncpy (dest, "4T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "4T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 60)
      {
	size_t required = strlen ("5T");
	if (max > required)
	  {
	    strncpy (dest, "5T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "5T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 61)
      {
	size_t required = strlen ("6T");
	if (max > required)
	  {
	    strncpy (dest, "6T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "6T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 62)
      {
	size_t required = strlen ("7T");
	if (max > required)
	  {
	    strncpy (dest, "7T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "7T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 63)
      {
	size_t required = strlen ("8T");
	if (max > required)
	  {
	    strncpy (dest, "8T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "8T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 64)
      {
	size_t required = strlen ("9T");
	if (max > required)
	  {
	    strncpy (dest, "9T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "9T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 65)
      {
	size_t required = strlen ("10T");
	if (max > required)
	  {
	    strncpy (dest, "10T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "10T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 66)
      {
	size_t required = strlen ("11T");
	if (max > required)
	  {
	    strncpy (dest, "11T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "11T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 67)
      {
	size_t required = strlen ("12T");
	if (max > required)
	  {
	    strncpy (dest, "12T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "12T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 68)
      {
	size_t required = strlen ("13T");
	if (max > required)
	  {
	    strncpy (dest, "13T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "13T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 69)
      {
	size_t required = strlen ("14T");
	if (max > required)
	  {
	    strncpy (dest, "14T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "14T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 70)
      {
	size_t required = strlen ("15T");
	if (max > required)
	  {
	    strncpy (dest, "15T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "15T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 71)
      {
	size_t required = strlen ("16T");
	if (max > required)
	  {
	    strncpy (dest, "16T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "16T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 72)
      {
	size_t required = strlen ("17T");
	if (max > required)
	  {
	    strncpy (dest, "17T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "17T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 73)
      {
	size_t required = strlen ("18T");
	if (max > required)
	  {
	    strncpy (dest, "18T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "18T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 74)
      {
	size_t required = strlen ("19T");
	if (max > required)
	  {
	    strncpy (dest, "19T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "19T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 75)
      {
	size_t required = strlen ("20T");
	if (max > required)
	  {
	    strncpy (dest, "20T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "20T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 76)
      {
	size_t required = strlen ("21T");
	if (max > required)
	  {
	    strncpy (dest, "21T", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "21T", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 77)
      {
	size_t required = strlen ("EXC");
	if (max > required)
	  {
	    strncpy (dest, "EXC", required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, "EXC", max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
  if (max != 0)
    {
      *dest = '\0';
    }
  return 0;
}

static inline size_t
card_to_string (TarotCard c, size_t max, char *dest)
{
    
    if (c == 0)
      {
	size_t required = strlen (_ ("AH"));
	if (max > required)
	  {
	    strncpy (dest, _ ("AH"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("AH"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 1)
      {
	size_t required = strlen (_ ("2H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("2H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("2H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 2)
      {
	size_t required = strlen (_ ("3H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("3H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("3H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 3)
      {
	size_t required = strlen (_ ("4H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("4H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("4H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 4)
      {
	size_t required = strlen (_ ("5H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("5H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("5H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 5)
      {
	size_t required = strlen (_ ("6H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("6H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("6H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 6)
      {
	size_t required = strlen (_ ("7H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("7H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("7H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 7)
      {
	size_t required = strlen (_ ("8H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("8H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("8H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 8)
      {
	size_t required = strlen (_ ("9H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("9H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("9H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 9)
      {
	size_t required = strlen (_ ("10H"));
	if (max > required)
	  {
	    strncpy (dest, _ ("10H"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("10H"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 10)
      {
	size_t required = strlen (_ ("JH"));
	if (max > required)
	  {
	    strncpy (dest, _ ("JH"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("JH"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 11)
      {
	size_t required = strlen (_ ("CH"));
	if (max > required)
	  {
	    strncpy (dest, _ ("CH"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("CH"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 12)
      {
	size_t required = strlen (_ ("QH"));
	if (max > required)
	  {
	    strncpy (dest, _ ("QH"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("QH"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 13)
      {
	size_t required = strlen (_ ("KH"));
	if (max > required)
	  {
	    strncpy (dest, _ ("KH"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("KH"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 14)
      {
	size_t required = strlen (_ ("AC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("AC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("AC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 15)
      {
	size_t required = strlen (_ ("2C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("2C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("2C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 16)
      {
	size_t required = strlen (_ ("3C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("3C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("3C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 17)
      {
	size_t required = strlen (_ ("4C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("4C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("4C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 18)
      {
	size_t required = strlen (_ ("5C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("5C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("5C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 19)
      {
	size_t required = strlen (_ ("6C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("6C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("6C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 20)
      {
	size_t required = strlen (_ ("7C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("7C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("7C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 21)
      {
	size_t required = strlen (_ ("8C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("8C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("8C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 22)
      {
	size_t required = strlen (_ ("9C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("9C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("9C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 23)
      {
	size_t required = strlen (_ ("10C"));
	if (max > required)
	  {
	    strncpy (dest, _ ("10C"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("10C"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 24)
      {
	size_t required = strlen (_ ("JC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("JC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("JC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 25)
      {
	size_t required = strlen (_ ("CC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("CC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("CC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 26)
      {
	size_t required = strlen (_ ("QC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("QC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("QC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 27)
      {
	size_t required = strlen (_ ("KC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("KC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("KC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 28)
      {
	size_t required = strlen (_ ("AD"));
	if (max > required)
	  {
	    strncpy (dest, _ ("AD"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("AD"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 29)
      {
	size_t required = strlen (_ ("2D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("2D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("2D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 30)
      {
	size_t required = strlen (_ ("3D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("3D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("3D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 31)
      {
	size_t required = strlen (_ ("4D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("4D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("4D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 32)
      {
	size_t required = strlen (_ ("5D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("5D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("5D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 33)
      {
	size_t required = strlen (_ ("6D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("6D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("6D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 34)
      {
	size_t required = strlen (_ ("7D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("7D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("7D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 35)
      {
	size_t required = strlen (_ ("8D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("8D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("8D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 36)
      {
	size_t required = strlen (_ ("9D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("9D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("9D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 37)
      {
	size_t required = strlen (_ ("10D"));
	if (max > required)
	  {
	    strncpy (dest, _ ("10D"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("10D"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 38)
      {
	size_t required = strlen (_ ("JD"));
	if (max > required)
	  {
	    strncpy (dest, _ ("JD"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("JD"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 39)
      {
	size_t required = strlen (_ ("CD"));
	if (max > required)
	  {
	    strncpy (dest, _ ("CD"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("CD"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 40)
      {
	size_t required = strlen (_ ("QD"));
	if (max > required)
	  {
	    strncpy (dest, _ ("QD"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("QD"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 41)
      {
	size_t required = strlen (_ ("KD"));
	if (max > required)
	  {
	    strncpy (dest, _ ("KD"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("KD"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 42)
      {
	size_t required = strlen (_ ("AS"));
	if (max > required)
	  {
	    strncpy (dest, _ ("AS"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("AS"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 43)
      {
	size_t required = strlen (_ ("2S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("2S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("2S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 44)
      {
	size_t required = strlen (_ ("3S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("3S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("3S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 45)
      {
	size_t required = strlen (_ ("4S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("4S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("4S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 46)
      {
	size_t required = strlen (_ ("5S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("5S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("5S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 47)
      {
	size_t required = strlen (_ ("6S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("6S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("6S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 48)
      {
	size_t required = strlen (_ ("7S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("7S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("7S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 49)
      {
	size_t required = strlen (_ ("8S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("8S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("8S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 50)
      {
	size_t required = strlen (_ ("9S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("9S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("9S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 51)
      {
	size_t required = strlen (_ ("10S"));
	if (max > required)
	  {
	    strncpy (dest, _ ("10S"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("10S"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 52)
      {
	size_t required = strlen (_ ("JS"));
	if (max > required)
	  {
	    strncpy (dest, _ ("JS"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("JS"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 53)
      {
	size_t required = strlen (_ ("CS"));
	if (max > required)
	  {
	    strncpy (dest, _ ("CS"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("CS"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 54)
      {
	size_t required = strlen (_ ("QS"));
	if (max > required)
	  {
	    strncpy (dest, _ ("QS"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("QS"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 55)
      {
	size_t required = strlen (_ ("KS"));
	if (max > required)
	  {
	    strncpy (dest, _ ("KS"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("KS"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 56)
      {
	size_t required = strlen (_ ("1T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("1T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("1T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 57)
      {
	size_t required = strlen (_ ("2T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("2T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("2T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 58)
      {
	size_t required = strlen (_ ("3T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("3T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("3T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 59)
      {
	size_t required = strlen (_ ("4T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("4T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("4T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 60)
      {
	size_t required = strlen (_ ("5T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("5T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("5T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 61)
      {
	size_t required = strlen (_ ("6T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("6T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("6T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 62)
      {
	size_t required = strlen (_ ("7T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("7T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("7T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 63)
      {
	size_t required = strlen (_ ("8T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("8T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("8T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 64)
      {
	size_t required = strlen (_ ("9T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("9T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("9T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 65)
      {
	size_t required = strlen (_ ("10T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("10T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("10T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 66)
      {
	size_t required = strlen (_ ("11T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("11T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("11T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 67)
      {
	size_t required = strlen (_ ("12T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("12T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("12T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 68)
      {
	size_t required = strlen (_ ("13T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("13T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("13T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 69)
      {
	size_t required = strlen (_ ("14T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("14T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("14T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 70)
      {
	size_t required = strlen (_ ("15T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("15T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("15T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 71)
      {
	size_t required = strlen (_ ("16T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("16T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("16T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 72)
      {
	size_t required = strlen (_ ("17T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("17T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("17T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 73)
      {
	size_t required = strlen (_ ("18T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("18T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("18T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 74)
      {
	size_t required = strlen (_ ("19T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("19T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("19T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 75)
      {
	size_t required = strlen (_ ("20T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("20T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("20T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 76)
      {
	size_t required = strlen (_ ("21T"));
	if (max > required)
	  {
	    strncpy (dest, _ ("21T"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("21T"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
    if (c == 77)
      {
	size_t required = strlen (_ ("EXC"));
	if (max > required)
	  {
	    strncpy (dest, _ ("EXC"), required);
	    dest[required] = '\0';
	  }
	else if (max != 0)
	  {
	    strncpy (dest, _ ("EXC"), max - 1);
	    dest[max - 1] = '\0';
	  }
	return required;
      }
    
  if (max != 0)
    {
      *dest = '\0';
    }
  return 0;
}

#endif /* not H_TAROT_CARDS_PRIVATE_IMPL_INCLUDED */

/* Local Variables: */
/* mode: c */
/* End: */
