#include <config.h>
/* application.c generated by valac 0.34.7, the Vala compiler
 * generated from application.vala, do not modify */

/* application.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include "tarot-gobject.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>


#define TAROT_TYPE_APPLICATION (tarot_application_get_type ())
#define TAROT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_APPLICATION, TarotApplication))
#define TAROT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_APPLICATION, TarotApplicationClass))
#define TAROT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_APPLICATION))
#define TAROT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_APPLICATION))
#define TAROT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_APPLICATION, TarotApplicationClass))

typedef struct _TarotApplication TarotApplication;
typedef struct _TarotApplicationClass TarotApplicationClass;
typedef struct _TarotApplicationPrivate TarotApplicationPrivate;

#define TAROT_TYPE_HISTORY (tarot_history_get_type ())
#define TAROT_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_HISTORY, TarotHistory))
#define TAROT_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_HISTORY, TarotHistoryClass))
#define TAROT_IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_HISTORY))
#define TAROT_IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_HISTORY))
#define TAROT_HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_HISTORY, TarotHistoryClass))

typedef struct _TarotHistory TarotHistory;
typedef struct _TarotHistoryClass TarotHistoryClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_TarotGameEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameEvent_free (var), NULL)))
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))
#define __vala_TarotGameIterator_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameIterator_free (var), NULL)))
#define __vala_TarotCounter_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotCounter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TAROT_TYPE_MCTS_PARAMS (tarot_mcts_params_get_type ())
typedef struct _TarotMctsParams TarotMctsParams;
#define __vala_TarotMcts_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotMcts_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotApplication {
	GObject parent_instance;
	TarotApplicationPrivate * priv;
};

struct _TarotApplicationClass {
	GObjectClass parent_class;
};

struct _TarotApplicationPrivate {
	TarotHistory* m_history;
};

struct _TarotMctsParams {
	const gchar* seed;
	gsize n_iterations;
	gdouble parameter;
	gdouble simulation_agreed;
	gdouble simulation_random;
};


static gpointer tarot_application_parent_class = NULL;

GType tarot_application_get_type (void) G_GNUC_CONST;
GType tarot_history_get_type (void) G_GNUC_CONST;
#define TAROT_APPLICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TAROT_TYPE_APPLICATION, TarotApplicationPrivate))
enum  {
	TAROT_APPLICATION_DUMMY_PROPERTY,
	TAROT_APPLICATION_HISTORY_CAPACITY,
	TAROT_APPLICATION_GAME,
	TAROT_APPLICATION_XML
};
TarotHistory* tarot_history_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
TarotHistory* tarot_history_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
static TarotGame* _vala_TarotGame_copy (TarotGame* self);
static void _vala_TarotGame_free (TarotGame* self);
static void tarot_application_added_event (TarotApplication* self, TarotGameEvent* e);
gconstpointer tarot_history_get_current (TarotHistory* self);
static void _vala_TarotGameEvent_free (TarotGameEvent* self);
void tarot_application_send_events (TarotApplication* self);
static void _vala_TarotGameIterator_free (TarotGameIterator* self);
gboolean tarot_application_load_from_xml (TarotApplication* self, const gchar* str);
void tarot_history_push (TarotHistory* self, gconstpointer data);
gboolean tarot_application_impute (TarotApplication* self, const gchar* seed, gint retry);
static void _vala_TarotCounter_free (TarotCounter* self);
GType tarot_mcts_params_get_type (void) G_GNUC_CONST;
TarotMctsParams* tarot_mcts_params_dup (const TarotMctsParams* self);
void tarot_mcts_params_free (TarotMctsParams* self);
gboolean tarot_application_mcts (TarotApplication* self, TarotMctsParams* mp);
static void _vala_TarotMcts_free (TarotMcts* self);
static TarotGameEvent* _vala_TarotGameEvent_copy (TarotGameEvent* self);
static gboolean tarot_application_autoreveal (TarotApplication* self, TarotGame* game, gboolean dispatch);
gboolean tarot_application_deal_random (TarotApplication* self, const gchar* seed, gint retry);
gboolean tarot_application_generate (TarotApplication* self, gsize n_players, gboolean with_call, TarotMctsParams* mp, gint retry);
gchar* tarot_application_mcts_tree_to_xml (TarotApplication* self, TarotMctsParams* mp);
gboolean tarot_application_new_game (TarotApplication* self, gsize n_players, gboolean with_call);
gboolean tarot_application_deal_to (TarotApplication* self, TarotPlayer whom, TarotCard* cards, int cards_length1);
gboolean tarot_application_deal_all (TarotApplication* self, TarotPlayer* owners, int owners_length1);
gboolean tarot_application_bid (TarotApplication* self, TarotBid bid);
gboolean tarot_application_decl (TarotApplication* self, gboolean decl);
gboolean tarot_application_call (TarotApplication* self, TarotCard call);
gboolean tarot_application_dog (TarotApplication* self, TarotCard* dog, int dog_length1);
gboolean tarot_application_discard (TarotApplication* self, TarotCard* discard, int discard_length1);
gboolean tarot_application_handful (TarotApplication* self, TarotCard* handful, int handful_length1);
gboolean tarot_application_play (TarotApplication* self, TarotCard play);
TarotApplication* tarot_application_new (void);
TarotApplication* tarot_application_construct (GType object_type);
gint tarot_application_get_history_capacity (TarotApplication* self);
gint tarot_history_get_capacity (TarotHistory* self);
void tarot_application_set_history_capacity (TarotApplication* self, gint value);
void tarot_history_set_capacity (TarotHistory* self, gint value);
TarotGame* tarot_application_get_game (TarotApplication* self);
gchar* tarot_application_get_xml (TarotApplication* self);
static void g_cclosure_user_marshal_VOID__BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void tarot_application_finalize (GObject* obj);
static void _vala_tarot_application_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tarot_application_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static TarotGame* _vala_TarotGame_copy (TarotGame* self) {
	return g_boxed_copy (tarot_game_get_type (), self);
}


static void _vala_TarotGame_free (TarotGame* self) {
	g_boxed_free (tarot_game_get_type (), self);
}


static void _vala_TarotGameEvent_free (TarotGameEvent* self) {
	g_boxed_free (tarot_game_event_get_type (), self);
}


static gpointer __vala_TarotGame_copy0 (gpointer self) {
	return self ? _vala_TarotGame_copy (self) : NULL;
}


static void tarot_application_added_event (TarotApplication* self, TarotGameEvent* e) {
	TarotGameEvent* _tmp0_ = NULL;
	TarotGameEventT _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	_tmp0_ = e;
	_tmp1_ = tarot_game_event_type (_tmp0_);
	switch (_tmp1_) {
		case TAROT_DEAL_EVENT:
		{
			TarotPlayer whom = 0U;
			TarotCard* cards = NULL;
			gint cards_length1 = 0;
			gint _cards_size_ = 0;
			TarotGameEvent* _tmp2_ = NULL;
			TarotPlayer _tmp3_ = 0U;
			TarotCard* _tmp4_ = NULL;
			gsize _tmp5_;
			TarotGameEventError _tmp6_ = 0;
			TarotGameEvent* _tmp7_ = NULL;
			TarotPlayer _tmp8_ = 0U;
			_tmp2_ = e;
			_tmp6_ = tarot_game_event_get_deal_alloc (_tmp2_, &_tmp3_, &_tmp5_, &_tmp4_);
			whom = _tmp3_;
			cards = (g_free (cards), NULL);
			cards = _tmp4_;
			cards_length1 = _tmp5_;
			_cards_size_ = cards_length1;
			if (_tmp6_ != TAROT_EVENT_OK) {
				_vala_assert (FALSE, "false");
			}
			_tmp7_ = e;
			_tmp8_ = whom;
			g_signal_emit_by_name (self, "unicast-event", _tmp7_, (gint) _tmp8_);
			cards = (g_free (cards), NULL);
			break;
		}
		case TAROT_DEAL_ALL_EVENT:
		{
			TarotPlayer* owners = NULL;
			gint owners_length1 = 0;
			gint _owners_size_ = 0;
			TarotGameEvent* _tmp9_ = NULL;
			TarotPlayer* _tmp10_ = NULL;
			gsize _tmp11_;
			TarotGameEventError _tmp12_ = 0;
			gint n_owners = 0;
			TarotPlayer* _tmp13_ = NULL;
			gint _tmp13__length1 = 0;
			gint _tmp14_ = 0;
			gsize n_players = 0UL;
			TarotHistory* _tmp15_ = NULL;
			gconstpointer _tmp16_ = NULL;
			TarotGame* _tmp17_ = NULL;
			gsize _tmp18_ = 0UL;
			_tmp9_ = e;
			_tmp12_ = tarot_game_event_get_deal_all_alloc (_tmp9_, &_tmp11_, &_tmp10_);
			owners = (g_free (owners), NULL);
			owners = _tmp10_;
			owners_length1 = _tmp11_;
			_owners_size_ = owners_length1;
			if (_tmp12_ != TAROT_EVENT_OK) {
				_vala_assert (FALSE, "false");
			}
			_tmp13_ = owners;
			_tmp13__length1 = owners_length1;
			n_owners = _tmp13__length1;
			_tmp14_ = n_owners;
			_vala_assert (_tmp14_ == 78, "n_owners == 78");
			_tmp15_ = self->priv->m_history;
			_tmp16_ = tarot_history_get_current (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = tarot_game_n_players ((TarotGame*) _tmp17_);
			n_players = _tmp18_;
			{
				TarotPlayer p = 0U;
				p = (TarotPlayer) 0;
				{
					gboolean _tmp19_ = FALSE;
					_tmp19_ = TRUE;
					while (TRUE) {
						TarotPlayer _tmp21_ = 0U;
						gsize _tmp22_ = 0UL;
						gsize n = 0UL;
						gsize _tmp32_ = 0UL;
						TarotCard* my_cards = NULL;
						gsize _tmp33_ = 0UL;
						TarotCard* _tmp34_ = NULL;
						gint my_cards_length1 = 0;
						gint _my_cards_size_ = 0;
						gsize i = 0UL;
						gsize _tmp47_ = 0UL;
						gsize _tmp48_ = 0UL;
						TarotGameEvent* personalized = NULL;
						TarotPlayer _tmp49_ = 0U;
						TarotCard* _tmp50_ = NULL;
						gint _tmp50__length1 = 0;
						TarotGameEvent* _tmp51_ = NULL;
						TarotGameEvent* _tmp52_ = NULL;
						TarotPlayer _tmp53_ = 0U;
						if (!_tmp19_) {
							TarotPlayer _tmp20_ = 0U;
							_tmp20_ = p;
							p = _tmp20_ + 1;
						}
						_tmp19_ = FALSE;
						_tmp21_ = p;
						_tmp22_ = n_players;
						if (!(((gsize) _tmp21_) < _tmp22_)) {
							break;
						}
						n = (gsize) 0;
						{
							gsize i = 0UL;
							i = (gsize) 0;
							{
								gboolean _tmp23_ = FALSE;
								_tmp23_ = TRUE;
								while (TRUE) {
									gsize _tmp25_ = 0UL;
									gint _tmp26_ = 0;
									TarotPlayer* _tmp27_ = NULL;
									gint _tmp27__length1 = 0;
									gsize _tmp28_ = 0UL;
									TarotPlayer _tmp29_ = 0U;
									TarotPlayer _tmp30_ = 0U;
									if (!_tmp23_) {
										gsize _tmp24_ = 0UL;
										_tmp24_ = i;
										i = _tmp24_ + 1;
									}
									_tmp23_ = FALSE;
									_tmp25_ = i;
									_tmp26_ = n_owners;
									if (!(_tmp25_ < ((gsize) _tmp26_))) {
										break;
									}
									_tmp27_ = owners;
									_tmp27__length1 = owners_length1;
									_tmp28_ = i;
									_tmp29_ = _tmp27_[_tmp28_];
									_tmp30_ = p;
									if (_tmp29_ == _tmp30_) {
										gsize _tmp31_ = 0UL;
										_tmp31_ = n;
										n = _tmp31_ + 1;
									}
								}
							}
						}
						_tmp32_ = n;
						_vala_assert (_tmp32_ != ((gsize) 0), "n != 0");
						_tmp33_ = n;
						_tmp34_ = g_new0 (TarotCard, _tmp33_);
						my_cards = _tmp34_;
						my_cards_length1 = _tmp33_;
						_my_cards_size_ = my_cards_length1;
						i = (gsize) 0;
						{
							TarotCard c = 0U;
							c = (TarotCard) 0;
							{
								gboolean _tmp35_ = FALSE;
								_tmp35_ = TRUE;
								while (TRUE) {
									TarotCard _tmp37_ = 0U;
									gint _tmp38_ = 0;
									TarotPlayer* _tmp39_ = NULL;
									gint _tmp39__length1 = 0;
									TarotCard _tmp40_ = 0U;
									TarotPlayer _tmp41_ = 0U;
									TarotPlayer _tmp42_ = 0U;
									if (!_tmp35_) {
										TarotCard _tmp36_ = 0U;
										_tmp36_ = c;
										c = _tmp36_ + 1;
									}
									_tmp35_ = FALSE;
									_tmp37_ = c;
									_tmp38_ = n_owners;
									if (!(_tmp37_ < ((TarotCard) _tmp38_))) {
										break;
									}
									_tmp39_ = owners;
									_tmp39__length1 = owners_length1;
									_tmp40_ = c;
									_tmp41_ = _tmp39_[_tmp40_];
									_tmp42_ = p;
									if (_tmp41_ == _tmp42_) {
										TarotCard* _tmp43_ = NULL;
										gint _tmp43__length1 = 0;
										gsize _tmp44_ = 0UL;
										TarotCard _tmp45_ = 0U;
										TarotCard _tmp46_ = 0U;
										_tmp43_ = my_cards;
										_tmp43__length1 = my_cards_length1;
										_tmp44_ = i;
										i = _tmp44_ + 1;
										_tmp45_ = c;
										_tmp43_[_tmp44_] = _tmp45_;
										_tmp46_ = _tmp43_[_tmp44_];
									}
								}
							}
						}
						_tmp47_ = i;
						_tmp48_ = n;
						_vala_assert (_tmp47_ == _tmp48_, "i == n");
						_tmp49_ = p;
						_tmp50_ = my_cards;
						_tmp50__length1 = my_cards_length1;
						_tmp51_ = tarot_game_event_alloc_deal (_tmp49_, _tmp50__length1, _tmp50_);
						personalized = _tmp51_;
						_tmp52_ = personalized;
						_tmp53_ = p;
						g_signal_emit_by_name (self, "unicast-event", _tmp52_, (gint) _tmp53_);
						__vala_TarotGameEvent_free0 (personalized);
						my_cards = (g_free (my_cards), NULL);
					}
				}
			}
			owners = (g_free (owners), NULL);
			break;
		}
		case TAROT_DISCARD_EVENT:
		{
			TarotGame* game = NULL;
			TarotHistory* _tmp54_ = NULL;
			gconstpointer _tmp55_ = NULL;
			TarotGame* _tmp56_ = NULL;
			TarotGame* _tmp57_ = NULL;
			gsize n_players = 0UL;
			TarotGame* _tmp58_ = NULL;
			gsize _tmp59_ = 0UL;
			TarotPlayer taker = 0U;
			gboolean has_taker = FALSE;
			TarotGame* _tmp60_ = NULL;
			TarotPlayer _tmp61_ = 0U;
			TarotGameError _tmp62_ = 0;
			gboolean _tmp63_ = FALSE;
			_tmp54_ = self->priv->m_history;
			_tmp55_ = tarot_history_get_current (_tmp54_);
			_tmp56_ = _tmp55_;
			_tmp57_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp56_);
			game = _tmp57_;
			_tmp58_ = game;
			_tmp59_ = tarot_game_n_players (_tmp58_);
			n_players = _tmp59_;
			_tmp60_ = game;
			_tmp62_ = tarot_game_get_taker (_tmp60_, &_tmp61_);
			taker = _tmp61_;
			has_taker = _tmp62_ == TAROT_GAME_OK;
			_tmp63_ = has_taker;
			_vala_assert (_tmp63_, "has_taker");
			{
				TarotPlayer p = 0U;
				p = (TarotPlayer) 0;
				{
					gboolean _tmp64_ = FALSE;
					_tmp64_ = TRUE;
					while (TRUE) {
						TarotPlayer _tmp66_ = 0U;
						gsize _tmp67_ = 0UL;
						TarotCard* cards = NULL;
						gint cards_length1 = 0;
						gint _cards_size_ = 0;
						TarotPlayer _tmp68_ = 0U;
						TarotPlayer _tmp69_ = 0U;
						TarotGameEvent* personalized = NULL;
						TarotCard* _tmp78_ = NULL;
						gint _tmp78__length1 = 0;
						TarotGameEvent* _tmp79_ = NULL;
						TarotGameEvent* _tmp80_ = NULL;
						TarotPlayer _tmp81_ = 0U;
						if (!_tmp64_) {
							TarotPlayer _tmp65_ = 0U;
							_tmp65_ = p;
							p = _tmp65_ + 1;
						}
						_tmp64_ = FALSE;
						_tmp66_ = p;
						_tmp67_ = n_players;
						if (!(((gsize) _tmp66_) < _tmp67_)) {
							break;
						}
						_tmp68_ = p;
						_tmp69_ = taker;
						if (_tmp68_ == _tmp69_) {
							TarotGame* _tmp70_ = NULL;
							TarotCard* _tmp71_ = NULL;
							gsize _tmp72_;
							TarotGameError _tmp73_ = 0;
							_tmp70_ = game;
							_tmp73_ = tarot_game_get_full_discard_alloc (_tmp70_, &_tmp72_, &_tmp71_);
							cards = (g_free (cards), NULL);
							cards = _tmp71_;
							cards_length1 = _tmp72_;
							_cards_size_ = cards_length1;
							if (_tmp73_ != TAROT_GAME_OK) {
								_vala_assert (FALSE, "false");
							}
						} else {
							TarotGame* _tmp74_ = NULL;
							TarotCard* _tmp75_ = NULL;
							gsize _tmp76_;
							TarotGameError _tmp77_ = 0;
							_tmp74_ = game;
							_tmp77_ = tarot_game_get_public_discard_alloc (_tmp74_, &_tmp76_, &_tmp75_);
							cards = (g_free (cards), NULL);
							cards = _tmp75_;
							cards_length1 = _tmp76_;
							_cards_size_ = cards_length1;
							if (_tmp77_ != TAROT_GAME_OK) {
								_vala_assert (FALSE, "false");
							}
						}
						_tmp78_ = cards;
						_tmp78__length1 = cards_length1;
						_tmp79_ = tarot_game_event_alloc_discard (_tmp78__length1, _tmp78_);
						personalized = _tmp79_;
						_tmp80_ = personalized;
						_tmp81_ = p;
						g_signal_emit_by_name (self, "unicast-event", _tmp80_, (gint) _tmp81_);
						__vala_TarotGameEvent_free0 (personalized);
						cards = (g_free (cards), NULL);
					}
				}
			}
			__vala_TarotGame_free0 (game);
			break;
		}
		default:
		{
			TarotGameEvent* _tmp82_ = NULL;
			_tmp82_ = e;
			g_signal_emit_by_name (self, "broadcast-event", _tmp82_);
			break;
		}
	}
}


static void _vala_TarotGameIterator_free (TarotGameIterator* self) {
	g_boxed_free (tarot_game_iterator_get_type (), self);
}


void tarot_application_send_events (TarotApplication* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "reset");
	{
		TarotGameIterator* _e_it = NULL;
		TarotHistory* _tmp0_ = NULL;
		gconstpointer _tmp1_ = NULL;
		TarotGame* _tmp2_ = NULL;
		TarotGameIterator* _tmp3_ = NULL;
		TarotGameEvent* e = NULL;
		_tmp0_ = self->priv->m_history;
		_tmp1_ = tarot_history_get_current (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = tarot_game_iterator ((TarotGame*) _tmp2_);
		_e_it = _tmp3_;
		while (TRUE) {
			TarotGameIterator* _tmp4_ = NULL;
			TarotGameEvent* _tmp5_ = NULL;
			TarotGameEvent* _tmp6_ = NULL;
			TarotGameEvent* _tmp7_ = NULL;
			_tmp4_ = _e_it;
			_tmp5_ = tarot_game_iterator_next_value (_tmp4_);
			e = _tmp5_;
			_tmp6_ = e;
			if (!(_tmp6_ != NULL)) {
				break;
			}
			_tmp7_ = e;
			tarot_application_added_event (self, _tmp7_);
		}
		__vala_TarotGameIterator_free0 (_e_it);
	}
}


gboolean tarot_application_load_from_xml (TarotApplication* self, const gchar* str) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotGame* _tmp0_ = NULL;
	TarotGame* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	TarotGameError _tmp3_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = tarot_game_alloc ();
	game = _tmp0_;
	_tmp1_ = game;
	_tmp2_ = str;
	_tmp3_ = tarot_game_load_from_xml (_tmp1_, _tmp2_);
	if (_tmp3_ == 0) {
		TarotHistory* _tmp4_ = NULL;
		TarotGame* _tmp5_ = NULL;
		_tmp4_ = self->priv->m_history;
		_tmp5_ = game;
		tarot_history_push (_tmp4_, _tmp5_);
		tarot_application_send_events (self);
		result = TRUE;
		__vala_TarotGame_free0 (game);
		return result;
	} else {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	__vala_TarotGame_free0 (game);
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static void _vala_TarotCounter_free (TarotCounter* self) {
	g_boxed_free (tarot_counter_get_type (), self);
}


gboolean tarot_application_impute (TarotApplication* self, const gchar* seed, gint retry) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (seed != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				gint _tmp3_ = 0;
				TarotGame* game = NULL;
				TarotHistory* _tmp4_ = NULL;
				gconstpointer _tmp5_ = NULL;
				TarotGame* _tmp6_ = NULL;
				TarotGame* _tmp7_ = NULL;
				TarotGame* _tmp8_ = NULL;
				gchar* current_seed = NULL;
				const gchar* _tmp9_ = NULL;
				gint _tmp10_ = 0;
				gchar* _tmp11_ = NULL;
				gchar* seed_bytes = NULL;
				const gchar* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gint seed_bytes_length1 = 0;
				gint _seed_bytes_size_ = 0;
				TarotCounter* counter = NULL;
				TarotCounter* _tmp28_ = NULL;
				TarotCounter* _tmp29_ = NULL;
				TarotGame* _tmp30_ = NULL;
				TarotCounter* _tmp31_ = NULL;
				TarotGame* _tmp32_ = NULL;
				gchar* _tmp33_ = NULL;
				gint _tmp33__length1 = 0;
				TarotImputationError _tmp34_ = 0;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = retry;
				if (!(_tmp2_ <= _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->m_history;
				_tmp5_ = tarot_history_get_current (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp6_);
				game = _tmp7_;
				_tmp8_ = game;
				if (_tmp8_ == NULL) {
					result = FALSE;
					__vala_TarotGame_free0 (game);
					return result;
				}
				_tmp9_ = seed;
				_tmp10_ = retry;
				_tmp11_ = g_strdup_printf ("%s (%d)", _tmp9_, _tmp10_);
				current_seed = _tmp11_;
				_tmp12_ = current_seed;
				_tmp13_ = strlen (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_new0 (gchar, _tmp14_);
				seed_bytes = _tmp15_;
				seed_bytes_length1 = _tmp14_;
				_seed_bytes_size_ = seed_bytes_length1;
				{
					glong j = 0L;
					j = (glong) 0;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							glong _tmp18_ = 0L;
							const gchar* _tmp19_ = NULL;
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							gchar* _tmp22_ = NULL;
							gint _tmp22__length1 = 0;
							glong _tmp23_ = 0L;
							const gchar* _tmp24_ = NULL;
							glong _tmp25_ = 0L;
							gchar _tmp26_ = '\0';
							gchar _tmp27_ = '\0';
							if (!_tmp16_) {
								glong _tmp17_ = 0L;
								_tmp17_ = j;
								j = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							_tmp18_ = j;
							_tmp19_ = current_seed;
							_tmp20_ = strlen (_tmp19_);
							_tmp21_ = _tmp20_;
							if (!(_tmp18_ < ((glong) _tmp21_))) {
								break;
							}
							_tmp22_ = seed_bytes;
							_tmp22__length1 = seed_bytes_length1;
							_tmp23_ = j;
							_tmp24_ = current_seed;
							_tmp25_ = j;
							_tmp26_ = string_get (_tmp24_, _tmp25_);
							_tmp22_[_tmp23_] = _tmp26_;
							_tmp27_ = _tmp22_[_tmp23_];
						}
					}
				}
				_tmp28_ = tarot_counter_alloc ();
				counter = _tmp28_;
				_tmp29_ = counter;
				_tmp30_ = game;
				tarot_counter_load_from_game (_tmp29_, _tmp30_);
				_tmp31_ = counter;
				_tmp32_ = game;
				_tmp33_ = seed_bytes;
				_tmp33__length1 = seed_bytes_length1;
				_tmp34_ = tarot_counter_and_game_impute (_tmp31_, _tmp32_, (gsize) _tmp33__length1, _tmp33_);
				if (_tmp34_ == 0) {
					TarotHistory* _tmp35_ = NULL;
					TarotGame* _tmp36_ = NULL;
					_tmp35_ = self->priv->m_history;
					_tmp36_ = game;
					tarot_history_push (_tmp35_, _tmp36_);
					tarot_application_send_events (self);
					result = TRUE;
					__vala_TarotCounter_free0 (counter);
					seed_bytes = (g_free (seed_bytes), NULL);
					_g_free0 (current_seed);
					__vala_TarotGame_free0 (game);
					return result;
				}
				__vala_TarotCounter_free0 (counter);
				seed_bytes = (g_free (seed_bytes), NULL);
				_g_free0 (current_seed);
				__vala_TarotGame_free0 (game);
			}
		}
	}
	result = FALSE;
	return result;
}


static void _vala_TarotMcts_free (TarotMcts* self) {
	g_boxed_free (tarot_mcts_get_type (), self);
}


static TarotGameEvent* _vala_TarotGameEvent_copy (TarotGameEvent* self) {
	return g_boxed_copy (tarot_game_event_get_type (), self);
}


static gpointer __vala_TarotGameEvent_copy0 (gpointer self) {
	return self ? _vala_TarotGameEvent_copy (self) : NULL;
}


gboolean tarot_application_mcts (TarotApplication* self, TarotMctsParams* mp) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	gchar* current_seed = NULL;
	TarotMctsParams _tmp6_ = {0};
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* seed_bytes = NULL;
	const gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	gint seed_bytes_length1 = 0;
	gint _seed_bytes_size_ = 0;
	TarotMcts* mcts = NULL;
	TarotMcts* _tmp25_ = NULL;
	TarotMcts* _tmp26_ = NULL;
	TarotGame* _tmp27_ = NULL;
	TarotMctsError _tmp28_ = 0;
	TarotMcts* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	TarotMctsParams _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	TarotMctsParams _tmp37_ = {0};
	gdouble _tmp38_ = 0.0;
	TarotMctsParams _tmp42_ = {0};
	gdouble _tmp43_ = 0.0;
	TarotMcts* _tmp47_ = NULL;
	TarotMctsParams _tmp48_ = {0};
	gsize _tmp49_ = 0UL;
	TarotMctsError _tmp50_ = 0;
	TarotGameEvent* e = NULL;
	TarotMcts* _tmp52_ = NULL;
	TarotGameEvent* _tmp53_ = NULL;
	TarotGameEvent* _tmp54_ = NULL;
	TarotGameEvent* _tmp55_ = NULL;
	TarotGame* _tmp56_ = NULL;
	TarotGameEvent* _tmp57_ = NULL;
	TarotGameError _tmp58_ = 0;
	TarotHistory* _tmp60_ = NULL;
	TarotGame* _tmp61_ = NULL;
	TarotGameEvent* _tmp62_ = NULL;
	TarotGame* _tmp63_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (mp != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		FILE* _tmp5_ = NULL;
		_tmp5_ = stderr;
		fprintf (_tmp5_, "No game.\n");
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp6_ = *mp;
	_tmp7_ = _tmp6_.seed;
	_tmp8_ = g_strdup (_tmp7_);
	current_seed = _tmp8_;
	_tmp9_ = current_seed;
	_tmp10_ = strlen (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_new0 (gchar, _tmp11_);
	seed_bytes = _tmp12_;
	seed_bytes_length1 = _tmp11_;
	_seed_bytes_size_ = seed_bytes_length1;
	{
		glong j = 0L;
		j = (glong) 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				glong _tmp15_ = 0L;
				const gchar* _tmp16_ = NULL;
				gint _tmp17_ = 0;
				gint _tmp18_ = 0;
				gchar* _tmp19_ = NULL;
				gint _tmp19__length1 = 0;
				glong _tmp20_ = 0L;
				const gchar* _tmp21_ = NULL;
				glong _tmp22_ = 0L;
				gchar _tmp23_ = '\0';
				gchar _tmp24_ = '\0';
				if (!_tmp13_) {
					glong _tmp14_ = 0L;
					_tmp14_ = j;
					j = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp15_ = j;
				_tmp16_ = current_seed;
				_tmp17_ = strlen (_tmp16_);
				_tmp18_ = _tmp17_;
				if (!(_tmp15_ < ((glong) _tmp18_))) {
					break;
				}
				_tmp19_ = seed_bytes;
				_tmp19__length1 = seed_bytes_length1;
				_tmp20_ = j;
				_tmp21_ = current_seed;
				_tmp22_ = j;
				_tmp23_ = string_get (_tmp21_, _tmp22_);
				_tmp19_[_tmp20_] = _tmp23_;
				_tmp24_ = _tmp19_[_tmp20_];
			}
		}
	}
	_tmp25_ = tarot_mcts_alloc ((gsize) ((2 * 1024) * 1024));
	mcts = _tmp25_;
	_tmp26_ = mcts;
	_tmp27_ = game;
	_tmp28_ = tarot_mcts_set_base (_tmp26_, _tmp27_);
	if (_tmp28_ != 0) {
		FILE* _tmp29_ = NULL;
		_tmp29_ = stderr;
		fprintf (_tmp29_, "Invalid base.\n");
		result = FALSE;
		__vala_TarotMcts_free0 (mcts);
		seed_bytes = (g_free (seed_bytes), NULL);
		_g_free0 (current_seed);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp30_ = mcts;
	_tmp31_ = seed_bytes;
	_tmp31__length1 = seed_bytes_length1;
	tarot_mcts_seed (_tmp30_, (gsize) _tmp31__length1, _tmp31_);
	_tmp32_ = *mp;
	_tmp33_ = _tmp32_.parameter;
	if (_tmp33_ >= ((gdouble) 0)) {
		TarotMcts* _tmp34_ = NULL;
		TarotMctsParams _tmp35_ = {0};
		gdouble _tmp36_ = 0.0;
		_tmp34_ = mcts;
		_tmp35_ = *mp;
		_tmp36_ = _tmp35_.parameter;
		tarot_mcts_set_parameter (_tmp34_, _tmp36_);
	}
	_tmp37_ = *mp;
	_tmp38_ = _tmp37_.simulation_agreed;
	if (_tmp38_ >= ((gdouble) 0)) {
		TarotMcts* _tmp39_ = NULL;
		TarotMctsParams _tmp40_ = {0};
		gdouble _tmp41_ = 0.0;
		_tmp39_ = mcts;
		_tmp40_ = *mp;
		_tmp41_ = _tmp40_.simulation_agreed;
		tarot_mcts_set_simulation_agreed (_tmp39_, _tmp41_);
	}
	_tmp42_ = *mp;
	_tmp43_ = _tmp42_.simulation_random;
	if (_tmp43_ >= ((gdouble) 0)) {
		TarotMcts* _tmp44_ = NULL;
		TarotMctsParams _tmp45_ = {0};
		gdouble _tmp46_ = 0.0;
		_tmp44_ = mcts;
		_tmp45_ = *mp;
		_tmp46_ = _tmp45_.simulation_random;
		tarot_mcts_set_simulation_random (_tmp44_, _tmp46_);
	}
	_tmp47_ = mcts;
	_tmp48_ = *mp;
	_tmp49_ = _tmp48_.n_iterations;
	_tmp50_ = tarot_mcts_run (_tmp47_, _tmp49_);
	if (_tmp50_ != 0) {
		FILE* _tmp51_ = NULL;
		_tmp51_ = stderr;
		fprintf (_tmp51_, "Could not run.\n");
		result = FALSE;
		__vala_TarotMcts_free0 (mcts);
		seed_bytes = (g_free (seed_bytes), NULL);
		_g_free0 (current_seed);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp52_ = mcts;
	_tmp53_ = tarot_mcts_get_best (_tmp52_);
	_tmp54_ = __vala_TarotGameEvent_copy0 (_tmp53_);
	e = _tmp54_;
	_tmp55_ = e;
	_vala_assert (_tmp55_ != NULL, "e != null");
	_tmp56_ = game;
	_tmp57_ = e;
	_tmp58_ = tarot_game_add_event (_tmp56_, _tmp57_);
	if (_tmp58_ != 0) {
		FILE* _tmp59_ = NULL;
		_tmp59_ = stderr;
		fprintf (_tmp59_, "Invalid outcome.\n");
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotMcts_free0 (mcts);
		seed_bytes = (g_free (seed_bytes), NULL);
		_g_free0 (current_seed);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp60_ = self->priv->m_history;
	_tmp61_ = game;
	tarot_history_push (_tmp60_, _tmp61_);
	_tmp62_ = e;
	tarot_application_added_event (self, _tmp62_);
	_tmp63_ = game;
	tarot_application_autoreveal (self, _tmp63_, TRUE);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotMcts_free0 (mcts);
	seed_bytes = (g_free (seed_bytes), NULL);
	_g_free0 (current_seed);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_deal_random (TarotApplication* self, const gchar* seed, gint retry) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (seed != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				gint _tmp3_ = 0;
				TarotGame* game = NULL;
				TarotHistory* _tmp4_ = NULL;
				gconstpointer _tmp5_ = NULL;
				TarotGame* _tmp6_ = NULL;
				TarotGame* _tmp7_ = NULL;
				TarotGame* _tmp8_ = NULL;
				gchar* current_seed = NULL;
				const gchar* _tmp9_ = NULL;
				gint _tmp10_ = 0;
				gchar* _tmp11_ = NULL;
				gchar* seed_bytes = NULL;
				const gchar* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gint seed_bytes_length1 = 0;
				gint _seed_bytes_size_ = 0;
				TarotGameEvent* e = NULL;
				TarotGame* _tmp28_ = NULL;
				gsize _tmp29_ = 0UL;
				gchar* _tmp30_ = NULL;
				gint _tmp30__length1 = 0;
				TarotGameEvent* _tmp31_ = NULL;
				TarotGame* _tmp32_ = NULL;
				TarotGameEvent* _tmp33_ = NULL;
				TarotGameError _tmp34_ = 0;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = retry;
				if (!(_tmp2_ <= _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->m_history;
				_tmp5_ = tarot_history_get_current (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp6_);
				game = _tmp7_;
				_tmp8_ = game;
				if (_tmp8_ == NULL) {
					result = FALSE;
					__vala_TarotGame_free0 (game);
					return result;
				}
				_tmp9_ = seed;
				_tmp10_ = retry;
				_tmp11_ = g_strdup_printf ("%s (%d)", _tmp9_, _tmp10_);
				current_seed = _tmp11_;
				_tmp12_ = current_seed;
				_tmp13_ = strlen (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_new0 (gchar, _tmp14_);
				seed_bytes = _tmp15_;
				seed_bytes_length1 = _tmp14_;
				_seed_bytes_size_ = seed_bytes_length1;
				{
					glong j = 0L;
					j = (glong) 0;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							glong _tmp18_ = 0L;
							const gchar* _tmp19_ = NULL;
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							gchar* _tmp22_ = NULL;
							gint _tmp22__length1 = 0;
							glong _tmp23_ = 0L;
							const gchar* _tmp24_ = NULL;
							glong _tmp25_ = 0L;
							gchar _tmp26_ = '\0';
							gchar _tmp27_ = '\0';
							if (!_tmp16_) {
								glong _tmp17_ = 0L;
								_tmp17_ = j;
								j = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							_tmp18_ = j;
							_tmp19_ = current_seed;
							_tmp20_ = strlen (_tmp19_);
							_tmp21_ = _tmp20_;
							if (!(_tmp18_ < ((glong) _tmp21_))) {
								break;
							}
							_tmp22_ = seed_bytes;
							_tmp22__length1 = seed_bytes_length1;
							_tmp23_ = j;
							_tmp24_ = current_seed;
							_tmp25_ = j;
							_tmp26_ = string_get (_tmp24_, _tmp25_);
							_tmp22_[_tmp23_] = _tmp26_;
							_tmp27_ = _tmp22_[_tmp23_];
						}
					}
				}
				_tmp28_ = game;
				_tmp29_ = tarot_game_n_players (_tmp28_);
				_tmp30_ = seed_bytes;
				_tmp30__length1 = seed_bytes_length1;
				_tmp31_ = tarot_game_event_alloc_deal_all_random (_tmp29_, _tmp30__length1, _tmp30_);
				e = _tmp31_;
				_tmp32_ = game;
				_tmp33_ = e;
				_tmp34_ = tarot_game_add_event (_tmp32_, _tmp33_);
				if (_tmp34_ == TAROT_GAME_OK) {
					TarotHistory* _tmp35_ = NULL;
					TarotGame* _tmp36_ = NULL;
					TarotGameEvent* _tmp37_ = NULL;
					_tmp35_ = self->priv->m_history;
					_tmp36_ = game;
					tarot_history_push (_tmp35_, _tmp36_);
					_tmp37_ = e;
					tarot_application_added_event (self, _tmp37_);
					result = TRUE;
					__vala_TarotGameEvent_free0 (e);
					seed_bytes = (g_free (seed_bytes), NULL);
					_g_free0 (current_seed);
					__vala_TarotGame_free0 (game);
					return result;
				}
				__vala_TarotGameEvent_free0 (e);
				seed_bytes = (g_free (seed_bytes), NULL);
				_g_free0 (current_seed);
				__vala_TarotGame_free0 (game);
			}
		}
	}
	result = FALSE;
	return result;
}


static gboolean tarot_application_autoreveal (TarotApplication* self, TarotGame* game, gboolean dispatch) {
	gboolean result = FALSE;
	TarotCard* dog = NULL;
	gint dog_length1 = 0;
	gint _dog_size_ = 0;
	TarotGame* _tmp0_ = NULL;
	TarotCard* _tmp1_ = NULL;
	gsize _tmp2_;
	gboolean _tmp3_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (game != NULL, FALSE);
	_tmp0_ = game;
	_tmp3_ = tarot_game_can_autoreveal_alloc (_tmp0_, &_tmp2_, &_tmp1_);
	dog = (g_free (dog), NULL);
	dog = _tmp1_;
	dog_length1 = _tmp2_;
	_dog_size_ = dog_length1;
	if (_tmp3_) {
		TarotGameEvent* e = NULL;
		TarotCard* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		TarotGameEvent* _tmp5_ = NULL;
		TarotGame* _tmp6_ = NULL;
		TarotGameEvent* _tmp7_ = NULL;
		TarotGameError _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		_tmp4_ = dog;
		_tmp4__length1 = dog_length1;
		_tmp5_ = tarot_game_event_alloc_dog (_tmp4__length1, _tmp4_);
		e = _tmp5_;
		_tmp6_ = game;
		_tmp7_ = e;
		_tmp8_ = tarot_game_add_event (_tmp6_, _tmp7_);
		if (_tmp8_ != TAROT_GAME_OK) {
			_vala_assert (FALSE, "false");
		}
		_tmp9_ = dispatch;
		if (_tmp9_) {
			TarotGameEvent* _tmp10_ = NULL;
			TarotHistory* _tmp11_ = NULL;
			TarotGame* _tmp12_ = NULL;
			_tmp10_ = e;
			g_signal_emit_by_name (self, "broadcast-event", _tmp10_);
			_tmp11_ = self->priv->m_history;
			_tmp12_ = game;
			tarot_history_push (_tmp11_, _tmp12_);
		}
		result = TRUE;
		__vala_TarotGameEvent_free0 (e);
		dog = (g_free (dog), NULL);
		return result;
	}
	result = FALSE;
	dog = (g_free (dog), NULL);
	return result;
}


gboolean tarot_application_generate (TarotApplication* self, gsize n_players, gboolean with_call, TarotMctsParams* mp, gint retry) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotGame* _tmp0_ = NULL;
	TarotGameEvent* e = NULL;
	gsize _tmp1_ = 0UL;
	gboolean _tmp2_ = FALSE;
	TarotGameEvent* _tmp3_ = NULL;
	gchar* seed_bytes = NULL;
	TarotMctsParams _tmp4_ = {0};
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
	gint seed_bytes_length1 = 0;
	gint _seed_bytes_size_ = 0;
	TarotGame* _tmp23_ = NULL;
	TarotGameEvent* _tmp24_ = NULL;
	TarotGameError _tmp25_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (mp != NULL, FALSE);
	_tmp0_ = tarot_game_alloc ();
	game = _tmp0_;
	_tmp1_ = n_players;
	_tmp2_ = with_call;
	_tmp3_ = tarot_game_event_alloc_setup (_tmp1_, _tmp2_);
	e = _tmp3_;
	_tmp4_ = *mp;
	_tmp5_ = _tmp4_.seed;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_new0 (gchar, _tmp7_);
	seed_bytes = _tmp8_;
	seed_bytes_length1 = _tmp7_;
	_seed_bytes_size_ = seed_bytes_length1;
	{
		glong i = 0L;
		i = (glong) 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				glong _tmp11_ = 0L;
				TarotMctsParams _tmp12_ = {0};
				const gchar* _tmp13_ = NULL;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				gchar* _tmp16_ = NULL;
				gint _tmp16__length1 = 0;
				glong _tmp17_ = 0L;
				TarotMctsParams _tmp18_ = {0};
				const gchar* _tmp19_ = NULL;
				glong _tmp20_ = 0L;
				gchar _tmp21_ = '\0';
				gchar _tmp22_ = '\0';
				if (!_tmp9_) {
					glong _tmp10_ = 0L;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = i;
				_tmp12_ = *mp;
				_tmp13_ = _tmp12_.seed;
				_tmp14_ = strlen (_tmp13_);
				_tmp15_ = _tmp14_;
				if (!(_tmp11_ < ((glong) _tmp15_))) {
					break;
				}
				_tmp16_ = seed_bytes;
				_tmp16__length1 = seed_bytes_length1;
				_tmp17_ = i;
				_tmp18_ = *mp;
				_tmp19_ = _tmp18_.seed;
				_tmp20_ = i;
				_tmp21_ = string_get (_tmp19_, _tmp20_);
				_tmp16_[_tmp17_] = _tmp21_;
				_tmp22_ = _tmp16_[_tmp17_];
			}
		}
	}
	_tmp23_ = game;
	_tmp24_ = e;
	_tmp25_ = tarot_game_add_event (_tmp23_, _tmp24_);
	if (_tmp25_ != 0) {
		_vala_assert (FALSE, "false");
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				gint _tmp28_ = 0;
				gint _tmp29_ = 0;
				gchar* deal_current_seed = NULL;
				TarotMctsParams _tmp30_ = {0};
				const gchar* _tmp31_ = NULL;
				gint _tmp32_ = 0;
				gchar* _tmp33_ = NULL;
				gchar* deal_seed_bytes = NULL;
				const gchar* _tmp34_ = NULL;
				gint _tmp35_ = 0;
				gint _tmp36_ = 0;
				gchar* _tmp37_ = NULL;
				gint deal_seed_bytes_length1 = 0;
				gint _deal_seed_bytes_size_ = 0;
				TarotGame* _tmp50_ = NULL;
				gsize _tmp51_ = 0UL;
				gchar* _tmp52_ = NULL;
				gint _tmp52__length1 = 0;
				TarotGameEvent* _tmp53_ = NULL;
				TarotGame* _tmp54_ = NULL;
				TarotGameEvent* _tmp55_ = NULL;
				TarotGameError _tmp56_ = 0;
				if (!_tmp26_) {
					gint _tmp27_ = 0;
					_tmp27_ = i;
					i = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				_tmp28_ = i;
				_tmp29_ = retry;
				if (!(_tmp28_ <= _tmp29_)) {
					break;
				}
				_tmp30_ = *mp;
				_tmp31_ = _tmp30_.seed;
				_tmp32_ = retry;
				_tmp33_ = g_strdup_printf ("%s (%d)", _tmp31_, _tmp32_);
				deal_current_seed = _tmp33_;
				_tmp34_ = deal_current_seed;
				_tmp35_ = strlen (_tmp34_);
				_tmp36_ = _tmp35_;
				_tmp37_ = g_new0 (gchar, _tmp36_);
				deal_seed_bytes = _tmp37_;
				deal_seed_bytes_length1 = _tmp36_;
				_deal_seed_bytes_size_ = deal_seed_bytes_length1;
				{
					glong j = 0L;
					j = (glong) 0;
					{
						gboolean _tmp38_ = FALSE;
						_tmp38_ = TRUE;
						while (TRUE) {
							glong _tmp40_ = 0L;
							const gchar* _tmp41_ = NULL;
							gint _tmp42_ = 0;
							gint _tmp43_ = 0;
							gchar* _tmp44_ = NULL;
							gint _tmp44__length1 = 0;
							glong _tmp45_ = 0L;
							const gchar* _tmp46_ = NULL;
							glong _tmp47_ = 0L;
							gchar _tmp48_ = '\0';
							gchar _tmp49_ = '\0';
							if (!_tmp38_) {
								glong _tmp39_ = 0L;
								_tmp39_ = j;
								j = _tmp39_ + 1;
							}
							_tmp38_ = FALSE;
							_tmp40_ = j;
							_tmp41_ = deal_current_seed;
							_tmp42_ = strlen (_tmp41_);
							_tmp43_ = _tmp42_;
							if (!(_tmp40_ < ((glong) _tmp43_))) {
								break;
							}
							_tmp44_ = deal_seed_bytes;
							_tmp44__length1 = deal_seed_bytes_length1;
							_tmp45_ = j;
							_tmp46_ = deal_current_seed;
							_tmp47_ = j;
							_tmp48_ = string_get (_tmp46_, _tmp47_);
							_tmp44_[_tmp45_] = _tmp48_;
							_tmp49_ = _tmp44_[_tmp45_];
						}
					}
				}
				_tmp50_ = game;
				_tmp51_ = tarot_game_n_players (_tmp50_);
				_tmp52_ = deal_seed_bytes;
				_tmp52__length1 = deal_seed_bytes_length1;
				_tmp53_ = tarot_game_event_alloc_deal_all_random (_tmp51_, _tmp52__length1, _tmp52_);
				__vala_TarotGameEvent_free0 (e);
				e = _tmp53_;
				_tmp54_ = game;
				_tmp55_ = e;
				_tmp56_ = tarot_game_add_event (_tmp54_, _tmp55_);
				if (_tmp56_ == 0) {
					TarotMcts* mcts = NULL;
					TarotMcts* _tmp57_ = NULL;
					TarotMctsParams _tmp58_ = {0};
					gdouble _tmp59_ = 0.0;
					TarotMctsParams _tmp63_ = {0};
					gdouble _tmp64_ = 0.0;
					TarotMctsParams _tmp68_ = {0};
					gdouble _tmp69_ = 0.0;
					TarotGame* _tmp73_ = NULL;
					TarotHistory* _tmp101_ = NULL;
					TarotGame* _tmp102_ = NULL;
					_tmp57_ = tarot_mcts_alloc ((gsize) ((2 * 1024) * 1024));
					mcts = _tmp57_;
					_tmp58_ = *mp;
					_tmp59_ = _tmp58_.parameter;
					if (_tmp59_ >= ((gdouble) 0)) {
						TarotMcts* _tmp60_ = NULL;
						TarotMctsParams _tmp61_ = {0};
						gdouble _tmp62_ = 0.0;
						_tmp60_ = mcts;
						_tmp61_ = *mp;
						_tmp62_ = _tmp61_.parameter;
						tarot_mcts_set_parameter (_tmp60_, _tmp62_);
					}
					_tmp63_ = *mp;
					_tmp64_ = _tmp63_.simulation_agreed;
					if (_tmp64_ >= ((gdouble) 0)) {
						TarotMcts* _tmp65_ = NULL;
						TarotMctsParams _tmp66_ = {0};
						gdouble _tmp67_ = 0.0;
						_tmp65_ = mcts;
						_tmp66_ = *mp;
						_tmp67_ = _tmp66_.simulation_agreed;
						tarot_mcts_set_simulation_agreed (_tmp65_, _tmp67_);
					}
					_tmp68_ = *mp;
					_tmp69_ = _tmp68_.simulation_random;
					if (_tmp69_ >= ((gdouble) 0)) {
						TarotMcts* _tmp70_ = NULL;
						TarotMctsParams _tmp71_ = {0};
						gdouble _tmp72_ = 0.0;
						_tmp70_ = mcts;
						_tmp71_ = *mp;
						_tmp72_ = _tmp71_.simulation_random;
						tarot_mcts_set_simulation_random (_tmp70_, _tmp72_);
					}
					_tmp73_ = game;
					tarot_application_autoreveal (self, _tmp73_, FALSE);
					while (TRUE) {
						TarotGame* _tmp74_ = NULL;
						TarotStep _tmp75_ = 0;
						TarotMcts* _tmp76_ = NULL;
						TarotGame* _tmp77_ = NULL;
						TarotMctsError _tmp78_ = 0;
						TarotMcts* _tmp81_ = NULL;
						gchar* _tmp82_ = NULL;
						gint _tmp82__length1 = 0;
						TarotMcts* _tmp83_ = NULL;
						TarotMctsParams _tmp84_ = {0};
						gsize _tmp85_ = 0UL;
						TarotMctsError _tmp86_ = 0;
						TarotMcts* _tmp89_ = NULL;
						TarotGameEvent* _tmp90_ = NULL;
						TarotGameEvent* _tmp91_ = NULL;
						TarotGameEvent* _tmp92_ = NULL;
						TarotGame* _tmp95_ = NULL;
						TarotGameEvent* _tmp96_ = NULL;
						TarotGameError _tmp97_ = 0;
						TarotGame* _tmp100_ = NULL;
						_tmp74_ = game;
						_tmp75_ = tarot_game_step (_tmp74_);
						if (!(_tmp75_ != TAROT_END)) {
							break;
						}
						_tmp76_ = mcts;
						_tmp77_ = game;
						_tmp78_ = tarot_mcts_set_base (_tmp76_, _tmp77_);
						if (_tmp78_ != 0) {
							FILE* _tmp79_ = NULL;
							const gchar* _tmp80_ = NULL;
							_tmp79_ = stderr;
							_tmp80_ = _ ("Could not set up the MCTS.\n");
							fprintf (_tmp79_, "%s", _tmp80_);
							abort ();
						}
						_tmp81_ = mcts;
						_tmp82_ = seed_bytes;
						_tmp82__length1 = seed_bytes_length1;
						tarot_mcts_seed (_tmp81_, (gsize) _tmp82__length1, _tmp82_);
						_tmp83_ = mcts;
						_tmp84_ = *mp;
						_tmp85_ = _tmp84_.n_iterations;
						_tmp86_ = tarot_mcts_run (_tmp83_, _tmp85_);
						if (_tmp86_ != 0) {
							FILE* _tmp87_ = NULL;
							const gchar* _tmp88_ = NULL;
							_tmp87_ = stderr;
							_tmp88_ = _ ("Could not explore this game.\n");
							fprintf (_tmp87_, "%s", _tmp88_);
							abort ();
						}
						_tmp89_ = mcts;
						_tmp90_ = tarot_mcts_get_best (_tmp89_);
						_tmp91_ = __vala_TarotGameEvent_copy0 (_tmp90_);
						__vala_TarotGameEvent_free0 (e);
						e = _tmp91_;
						_tmp92_ = e;
						if (_tmp92_ == NULL) {
							FILE* _tmp93_ = NULL;
							const gchar* _tmp94_ = NULL;
							_tmp93_ = stderr;
							_tmp94_ = _ ("No exploration has been performed.\n");
							fprintf (_tmp93_, "%s", _tmp94_);
							abort ();
						}
						_tmp95_ = game;
						_tmp96_ = e;
						_tmp97_ = tarot_game_add_event (_tmp95_, _tmp96_);
						if (_tmp97_ != 0) {
							FILE* _tmp98_ = NULL;
							const gchar* _tmp99_ = NULL;
							_tmp98_ = stderr;
							_tmp99_ = _ ("ERROR: the MCTS is not coherent.\n");
							fprintf (_tmp98_, "%s", _tmp99_);
							abort ();
						}
						_tmp100_ = game;
						tarot_application_autoreveal (self, _tmp100_, FALSE);
					}
					_tmp101_ = self->priv->m_history;
					_tmp102_ = game;
					tarot_history_push (_tmp101_, _tmp102_);
					g_signal_emit_by_name (self, "reset");
					tarot_application_send_events (self);
					result = TRUE;
					__vala_TarotMcts_free0 (mcts);
					deal_seed_bytes = (g_free (deal_seed_bytes), NULL);
					_g_free0 (deal_current_seed);
					seed_bytes = (g_free (seed_bytes), NULL);
					__vala_TarotGameEvent_free0 (e);
					__vala_TarotGame_free0 (game);
					return result;
				}
				deal_seed_bytes = (g_free (deal_seed_bytes), NULL);
				_g_free0 (deal_current_seed);
			}
		}
	}
	result = FALSE;
	seed_bytes = (g_free (seed_bytes), NULL);
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gchar* tarot_application_mcts_tree_to_xml (TarotApplication* self, TarotMctsParams* mp) {
	gchar* result = NULL;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotMcts* mcts = NULL;
	TarotMcts* _tmp5_ = NULL;
	TarotMctsParams _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	TarotMctsParams _tmp11_ = {0};
	gdouble _tmp12_ = 0.0;
	TarotMctsParams _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	TarotMcts* _tmp21_ = NULL;
	TarotGame* _tmp22_ = NULL;
	TarotMctsError _tmp23_ = 0;
	gchar* seed_bytes = NULL;
	TarotMctsParams _tmp24_ = {0};
	const gchar* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gchar* _tmp28_ = NULL;
	gint seed_bytes_length1 = 0;
	gint _seed_bytes_size_ = 0;
	TarotMcts* _tmp43_ = NULL;
	gchar* _tmp44_ = NULL;
	gint _tmp44__length1 = 0;
	TarotMcts* _tmp45_ = NULL;
	TarotMctsParams _tmp46_ = {0};
	gsize _tmp47_ = 0UL;
	TarotMctsError _tmp48_ = 0;
	TarotMcts* _tmp49_ = NULL;
	gchar* _tmp50_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (mp != NULL, NULL);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = NULL;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = tarot_mcts_alloc ((gsize) ((2 * 1024) * 1024));
	mcts = _tmp5_;
	_tmp6_ = *mp;
	_tmp7_ = _tmp6_.parameter;
	if (_tmp7_ >= ((gdouble) 0)) {
		TarotMcts* _tmp8_ = NULL;
		TarotMctsParams _tmp9_ = {0};
		gdouble _tmp10_ = 0.0;
		_tmp8_ = mcts;
		_tmp9_ = *mp;
		_tmp10_ = _tmp9_.parameter;
		tarot_mcts_set_parameter (_tmp8_, _tmp10_);
	}
	_tmp11_ = *mp;
	_tmp12_ = _tmp11_.simulation_agreed;
	if (_tmp12_ >= ((gdouble) 0)) {
		TarotMcts* _tmp13_ = NULL;
		TarotMctsParams _tmp14_ = {0};
		gdouble _tmp15_ = 0.0;
		_tmp13_ = mcts;
		_tmp14_ = *mp;
		_tmp15_ = _tmp14_.simulation_agreed;
		tarot_mcts_set_simulation_agreed (_tmp13_, _tmp15_);
	}
	_tmp16_ = *mp;
	_tmp17_ = _tmp16_.simulation_random;
	if (_tmp17_ >= ((gdouble) 0)) {
		TarotMcts* _tmp18_ = NULL;
		TarotMctsParams _tmp19_ = {0};
		gdouble _tmp20_ = 0.0;
		_tmp18_ = mcts;
		_tmp19_ = *mp;
		_tmp20_ = _tmp19_.simulation_random;
		tarot_mcts_set_simulation_random (_tmp18_, _tmp20_);
	}
	_tmp21_ = mcts;
	_tmp22_ = game;
	_tmp23_ = tarot_mcts_set_base (_tmp21_, _tmp22_);
	if (_tmp23_ != 0) {
		result = NULL;
		__vala_TarotMcts_free0 (mcts);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp24_ = *mp;
	_tmp25_ = _tmp24_.seed;
	_tmp26_ = strlen (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_new0 (gchar, _tmp27_);
	seed_bytes = _tmp28_;
	seed_bytes_length1 = _tmp27_;
	_seed_bytes_size_ = seed_bytes_length1;
	{
		glong i = 0L;
		i = (glong) 0;
		{
			gboolean _tmp29_ = FALSE;
			_tmp29_ = TRUE;
			while (TRUE) {
				glong _tmp31_ = 0L;
				TarotMctsParams _tmp32_ = {0};
				const gchar* _tmp33_ = NULL;
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				gchar* _tmp36_ = NULL;
				gint _tmp36__length1 = 0;
				glong _tmp37_ = 0L;
				TarotMctsParams _tmp38_ = {0};
				const gchar* _tmp39_ = NULL;
				glong _tmp40_ = 0L;
				gchar _tmp41_ = '\0';
				gchar _tmp42_ = '\0';
				if (!_tmp29_) {
					glong _tmp30_ = 0L;
					_tmp30_ = i;
					i = _tmp30_ + 1;
				}
				_tmp29_ = FALSE;
				_tmp31_ = i;
				_tmp32_ = *mp;
				_tmp33_ = _tmp32_.seed;
				_tmp34_ = strlen (_tmp33_);
				_tmp35_ = _tmp34_;
				if (!(_tmp31_ < ((glong) _tmp35_))) {
					break;
				}
				_tmp36_ = seed_bytes;
				_tmp36__length1 = seed_bytes_length1;
				_tmp37_ = i;
				_tmp38_ = *mp;
				_tmp39_ = _tmp38_.seed;
				_tmp40_ = i;
				_tmp41_ = string_get (_tmp39_, _tmp40_);
				_tmp36_[_tmp37_] = _tmp41_;
				_tmp42_ = _tmp36_[_tmp37_];
			}
		}
	}
	_tmp43_ = mcts;
	_tmp44_ = seed_bytes;
	_tmp44__length1 = seed_bytes_length1;
	tarot_mcts_seed (_tmp43_, (gsize) _tmp44__length1, _tmp44_);
	_tmp45_ = mcts;
	_tmp46_ = *mp;
	_tmp47_ = _tmp46_.n_iterations;
	_tmp48_ = tarot_mcts_run (_tmp45_, _tmp47_);
	if (_tmp48_ != 0) {
		result = NULL;
		seed_bytes = (g_free (seed_bytes), NULL);
		__vala_TarotMcts_free0 (mcts);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp49_ = mcts;
	_tmp50_ = tarot_mcts_save_to_xml_alloc (_tmp49_);
	result = _tmp50_;
	seed_bytes = (g_free (seed_bytes), NULL);
	__vala_TarotMcts_free0 (mcts);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_new_game (TarotApplication* self, gsize n_players, gboolean with_call) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotGame* _tmp0_ = NULL;
	TarotGameEvent* e = NULL;
	gsize _tmp1_ = 0UL;
	gboolean _tmp2_ = FALSE;
	TarotGameEvent* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* _tmp5_ = NULL;
	TarotGameError _tmp6_ = 0;
	TarotHistory* _tmp7_ = NULL;
	TarotGame* _tmp8_ = NULL;
	TarotGameEvent* _tmp9_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = tarot_game_alloc ();
	game = _tmp0_;
	_tmp1_ = n_players;
	_tmp2_ = with_call;
	_tmp3_ = tarot_game_event_alloc_setup (_tmp1_, _tmp2_);
	e = _tmp3_;
	_tmp4_ = game;
	_tmp5_ = e;
	_tmp6_ = tarot_game_add_event (_tmp4_, _tmp5_);
	if (_tmp6_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp7_ = self->priv->m_history;
	_tmp8_ = game;
	tarot_history_push (_tmp7_, _tmp8_);
	g_signal_emit_by_name (self, "reset");
	_tmp9_ = e;
	tarot_application_added_event (self, _tmp9_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_deal_to (TarotApplication* self, TarotPlayer whom, TarotCard* cards, int cards_length1) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotPlayer _tmp5_ = 0U;
	TarotCard* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	TarotGameEvent* _tmp7_ = NULL;
	TarotGame* _tmp8_ = NULL;
	TarotGameEvent* _tmp9_ = NULL;
	TarotGameError _tmp10_ = 0;
	TarotHistory* _tmp11_ = NULL;
	TarotGame* _tmp12_ = NULL;
	TarotGameEvent* _tmp13_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = whom;
	_tmp6_ = cards;
	_tmp6__length1 = cards_length1;
	_tmp7_ = tarot_game_event_alloc_deal (_tmp5_, _tmp6__length1, _tmp6_);
	e = _tmp7_;
	_tmp8_ = game;
	_tmp9_ = e;
	_tmp10_ = tarot_game_add_event (_tmp8_, _tmp9_);
	if (_tmp10_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp11_ = self->priv->m_history;
	_tmp12_ = game;
	tarot_history_push (_tmp11_, _tmp12_);
	_tmp13_ = e;
	tarot_application_added_event (self, _tmp13_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_deal_all (TarotApplication* self, TarotPlayer* owners, int owners_length1) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotPlayer* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = owners;
	_tmp5__length1 = owners_length1;
	_tmp6_ = tarot_game_event_alloc_deal_all (_tmp5__length1, _tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_bid (TarotApplication* self, TarotBid bid) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotBid _tmp5_ = 0;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = bid;
	_tmp6_ = tarot_game_event_alloc_bid (_tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_decl (TarotApplication* self, gboolean decl) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	gboolean _tmp5_ = FALSE;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	TarotGame* _tmp13_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = decl;
	_tmp6_ = tarot_game_event_alloc_decl (_tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	_tmp13_ = game;
	tarot_application_autoreveal (self, _tmp13_, TRUE);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_call (TarotApplication* self, TarotCard call) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotCard _tmp5_ = 0U;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	TarotGame* _tmp13_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = call;
	_tmp6_ = tarot_game_event_alloc_call (_tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	_tmp13_ = game;
	tarot_application_autoreveal (self, _tmp13_, TRUE);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_dog (TarotApplication* self, TarotCard* dog, int dog_length1) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotCard* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = dog;
	_tmp5__length1 = dog_length1;
	_tmp6_ = tarot_game_event_alloc_dog (_tmp5__length1, _tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_discard (TarotApplication* self, TarotCard* discard, int discard_length1) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotCard* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = discard;
	_tmp5__length1 = discard_length1;
	_tmp6_ = tarot_game_event_alloc_discard (_tmp5__length1, _tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_handful (TarotApplication* self, TarotCard* handful, int handful_length1) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotCard* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = handful;
	_tmp5__length1 = handful_length1;
	_tmp6_ = tarot_game_event_alloc_handful (_tmp5__length1, _tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


gboolean tarot_application_play (TarotApplication* self, TarotCard play) {
	gboolean result = FALSE;
	TarotGame* game = NULL;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	TarotGame* _tmp4_ = NULL;
	TarotGameEvent* e = NULL;
	TarotCard _tmp5_ = 0U;
	TarotGameEvent* _tmp6_ = NULL;
	TarotGame* _tmp7_ = NULL;
	TarotGameEvent* _tmp8_ = NULL;
	TarotGameError _tmp9_ = 0;
	TarotHistory* _tmp10_ = NULL;
	TarotGame* _tmp11_ = NULL;
	TarotGameEvent* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = __vala_TarotGame_copy0 ((TarotGame*) _tmp2_);
	game = _tmp3_;
	_tmp4_ = game;
	if (_tmp4_ == NULL) {
		result = FALSE;
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp5_ = play;
	_tmp6_ = tarot_game_event_alloc_card (_tmp5_);
	e = _tmp6_;
	_tmp7_ = game;
	_tmp8_ = e;
	_tmp9_ = tarot_game_add_event (_tmp7_, _tmp8_);
	if (_tmp9_ != 0) {
		result = FALSE;
		__vala_TarotGameEvent_free0 (e);
		__vala_TarotGame_free0 (game);
		return result;
	}
	_tmp10_ = self->priv->m_history;
	_tmp11_ = game;
	tarot_history_push (_tmp10_, _tmp11_);
	_tmp12_ = e;
	tarot_application_added_event (self, _tmp12_);
	result = TRUE;
	__vala_TarotGameEvent_free0 (e);
	__vala_TarotGame_free0 (game);
	return result;
}


TarotApplication* tarot_application_construct (GType object_type) {
	TarotApplication * self = NULL;
	TarotHistory* _tmp0_ = NULL;
	TarotGame* _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	self = (TarotApplication*) g_object_new (object_type, NULL);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_game_alloc ();
	_tmp2_ = _tmp1_;
	tarot_history_push (_tmp0_, _tmp2_);
	__vala_TarotGame_free0 (_tmp2_);
	return self;
}


TarotApplication* tarot_application_new (void) {
	return tarot_application_construct (TAROT_TYPE_APPLICATION);
}


gint tarot_application_get_history_capacity (TarotApplication* self) {
	gint result;
	TarotHistory* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_capacity (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void tarot_application_set_history_capacity (TarotApplication* self, gint value) {
	TarotHistory* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = value;
	tarot_history_set_capacity (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "history-capacity");
}


TarotGame* tarot_application_get_game (TarotApplication* self) {
	TarotGame* result;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotGame* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = tarot_game_dup ((TarotGame*) _tmp2_);
	result = _tmp3_;
	return result;
}


gchar* tarot_application_get_xml (TarotApplication* self) {
	gchar* result;
	TarotHistory* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->m_history;
	_tmp1_ = tarot_history_get_current (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = tarot_game_save_to_xml_alloc ((TarotGame*) _tmp2_);
	result = _tmp3_;
	return result;
}


static void g_cclosure_user_marshal_VOID__BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void tarot_application_class_init (TarotApplicationClass * klass) {
	tarot_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TarotApplicationPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_application_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tarot_application_set_property;
	G_OBJECT_CLASS (klass)->finalize = tarot_application_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_APPLICATION_HISTORY_CAPACITY, g_param_spec_int ("history-capacity", "history-capacity", "history-capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_APPLICATION_GAME, g_param_spec_boxed ("game", "game", "game", tarot_game_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_APPLICATION_XML, g_param_spec_string ("xml", "xml", "xml", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("broadcast_event", TAROT_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, tarot_game_event_get_type ());
	g_signal_new ("unicast_event", TAROT_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_INT, G_TYPE_NONE, 2, tarot_game_event_get_type (), G_TYPE_INT);
	g_signal_new ("reset", TAROT_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void tarot_application_instance_init (TarotApplication * self) {
	TarotHistory* _tmp0_ = NULL;
	self->priv = TAROT_APPLICATION_GET_PRIVATE (self);
	_tmp0_ = tarot_history_new (tarot_game_get_type (), (GBoxedCopyFunc) _vala_TarotGame_copy, (GDestroyNotify) _vala_TarotGame_free);
	self->priv->m_history = _tmp0_;
}


static void tarot_application_finalize (GObject* obj) {
	TarotApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_APPLICATION, TarotApplication);
	_g_object_unref0 (self->priv->m_history);
	G_OBJECT_CLASS (tarot_application_parent_class)->finalize (obj);
}


GType tarot_application_get_type (void) {
	static volatile gsize tarot_application_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotApplication), 0, (GInstanceInitFunc) tarot_application_instance_init, NULL };
		GType tarot_application_type_id;
		tarot_application_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotApplication", &g_define_type_info, 0);
		g_once_init_leave (&tarot_application_type_id__volatile, tarot_application_type_id);
	}
	return tarot_application_type_id__volatile;
}


static void _vala_tarot_application_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TarotApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_APPLICATION, TarotApplication);
	switch (property_id) {
		case TAROT_APPLICATION_HISTORY_CAPACITY:
		g_value_set_int (value, tarot_application_get_history_capacity (self));
		break;
		case TAROT_APPLICATION_GAME:
		g_value_take_boxed (value, tarot_application_get_game (self));
		break;
		case TAROT_APPLICATION_XML:
		g_value_take_string (value, tarot_application_get_xml (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_tarot_application_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TarotApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_APPLICATION, TarotApplication);
	switch (property_id) {
		case TAROT_APPLICATION_HISTORY_CAPACITY:
		tarot_application_set_history_capacity (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



