#include <config.h>
/* card_painter_default.c generated by valac 0.34.7, the Vala compiler
 * generated from card_painter_default.vala, do not modify */

/* file card_painter_default.vala*/
/**/
/* Copyright (C) 2017, 2018 Vivien Kraus <vivien@planete-kraus.eu>*/
/**/
/* This program is free software: you can redistribute it and/or*/
/* modify it under the terms of the GNU General Public License as*/
/* published by the Free Software Foundation, either version 3 of the*/
/* License, or (at your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see*/
/* <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include "tarot-gobject.h"
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TAROT_CAIRO_TYPE_CARD_PAINTER (tarot_cairo_card_painter_get_type ())
#define TAROT_CAIRO_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainter))
#define TAROT_CAIRO_IS_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER))
#define TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainterIface))

typedef struct _TarotCairoCardPainter TarotCairoCardPainter;
typedef struct _TarotCairoCardPainterIface TarotCairoCardPainterIface;

#define TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER (tarot_cairo_default_card_painter_get_type ())
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter))
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainterClass))
#define TAROT_CAIRO_IS_DEFAULT_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER))
#define TAROT_CAIRO_IS_DEFAULT_CARD_PAINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER))
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainterClass))

typedef struct _TarotCairoDefaultCardPainter TarotCairoDefaultCardPainter;
typedef struct _TarotCairoDefaultCardPainterClass TarotCairoDefaultCardPainterClass;
typedef struct _TarotCairoDefaultCardPainterPrivate TarotCairoDefaultCardPainterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TarotCairoCardPainterIface {
	GTypeInterface parent_iface;
	void (*paint_card) (TarotCairoCardPainter* self, TarotCard card, gboolean is_selected, cairo_t* context);
	gdouble (*get_card_width) (TarotCairoCardPainter* self);
	gdouble (*get_card_height) (TarotCairoCardPainter* self);
};

struct _TarotCairoDefaultCardPainter {
	GObject parent_instance;
	TarotCairoDefaultCardPainterPrivate * priv;
	gdouble border_width;
};

struct _TarotCairoDefaultCardPainterClass {
	GObjectClass parent_class;
};

struct _TarotCairoDefaultCardPainterPrivate {
	gdouble _card_width;
	gdouble _card_height;
};


static gpointer tarot_cairo_default_card_painter_parent_class = NULL;
static TarotCairoCardPainterIface* tarot_cairo_default_card_painter_tarot_cairo_card_painter_parent_iface = NULL;

GType tarot_cairo_card_painter_get_type (void) G_GNUC_CONST;
GType tarot_cairo_default_card_painter_get_type (void) G_GNUC_CONST;
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainterPrivate))
enum  {
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_DUMMY_PROPERTY,
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH,
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT
};
static void tarot_cairo_default_card_painter_paint_border (TarotCairoDefaultCardPainter* self, gboolean selected, cairo_t* context);
gdouble tarot_cairo_card_painter_get_card_width (TarotCairoCardPainter* self);
gdouble tarot_cairo_card_painter_get_card_height (TarotCairoCardPainter* self);
static void tarot_cairo_default_card_painter_paint_back (TarotCairoDefaultCardPainter* self, cairo_t* context);
static void tarot_cairo_default_card_painter_paint_number_and_suit (TarotCairoDefaultCardPainter* self, cairo_t* context, const gchar* number, const gchar* suit, gint color);
static void tarot_cairo_default_card_painter_real_paint_card (TarotCairoCardPainter* base, TarotCard card, gboolean selected, cairo_t* context);
TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_new (void);
TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_construct (GType object_type);
static void tarot_cairo_default_card_painter_finalize (GObject* obj);
static void _vala_tarot_cairo_default_card_painter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static void tarot_cairo_default_card_painter_paint_border (TarotCairoDefaultCardPainter* self, gboolean selected, cairo_t* context) {
	cairo_t* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	cairo_t* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	cairo_t* _tmp10_ = NULL;
	gdouble _tmp11_ = 0.0;
	gboolean _tmp12_ = FALSE;
	cairo_t* _tmp15_ = NULL;
	cairo_t* _tmp16_ = NULL;
	cairo_t* _tmp17_ = NULL;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	cairo_t* _tmp20_ = NULL;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	cairo_t* _tmp25_ = NULL;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	cairo_t* _tmp28_ = NULL;
	cairo_t* _tmp29_ = NULL;
	cairo_t* _tmp30_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp4_ = _tmp3_;
	cairo_translate (_tmp0_, (-_tmp2_) / 2, (-_tmp4_) / 2);
	_tmp5_ = context;
	_tmp6_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp7_ = _tmp6_;
	_tmp8_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp9_ = _tmp8_;
	cairo_rectangle (_tmp5_, (gdouble) 0, (gdouble) 0, _tmp7_, _tmp9_);
	_tmp10_ = context;
	_tmp11_ = self->border_width;
	cairo_set_line_width (_tmp10_, _tmp11_);
	_tmp12_ = selected;
	if (_tmp12_) {
		cairo_t* _tmp13_ = NULL;
		_tmp13_ = context;
		cairo_set_source_rgb (_tmp13_, 0.988, 0.914, 0.31);
	} else {
		cairo_t* _tmp14_ = NULL;
		_tmp14_ = context;
		cairo_set_source_rgb (_tmp14_, 0.933, 0.933, 0.925);
	}
	_tmp15_ = context;
	cairo_fill (_tmp15_);
	_tmp16_ = context;
	cairo_move_to (_tmp16_, (gdouble) 0, (gdouble) 0);
	_tmp17_ = context;
	_tmp18_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp19_ = _tmp18_;
	cairo_line_to (_tmp17_, (gdouble) 0, _tmp19_);
	_tmp20_ = context;
	_tmp21_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp22_ = _tmp21_;
	_tmp23_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp24_ = _tmp23_;
	cairo_line_to (_tmp20_, _tmp22_, _tmp24_);
	_tmp25_ = context;
	_tmp26_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp27_ = _tmp26_;
	cairo_line_to (_tmp25_, _tmp27_, (gdouble) 0);
	_tmp28_ = context;
	cairo_line_to (_tmp28_, (gdouble) 0, (gdouble) 0);
	_tmp29_ = context;
	cairo_set_source_rgb (_tmp29_, 0.18, 0.204, 0.212);
	_tmp30_ = context;
	cairo_stroke (_tmp30_);
}


static void tarot_cairo_default_card_painter_paint_back (TarotCairoDefaultCardPainter* self, cairo_t* context) {
	cairo_t* _tmp0_ = NULL;
	cairo_t* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	cairo_t* _tmp6_ = NULL;
	cairo_t* _tmp7_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	tarot_cairo_default_card_painter_paint_border (self, FALSE, _tmp0_);
	_tmp1_ = context;
	_tmp2_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp5_ = _tmp4_;
	cairo_rectangle (_tmp1_, (gdouble) 0, (gdouble) 0, _tmp3_, _tmp5_);
	_tmp6_ = context;
	cairo_set_source_rgb (_tmp6_, 0.333, 0.341, 0.325);
	_tmp7_ = context;
	cairo_fill (_tmp7_);
}


static void tarot_cairo_default_card_painter_paint_number_and_suit (TarotCairoDefaultCardPainter* self, cairo_t* context, const gchar* number, const gchar* suit, gint color) {
	gint _tmp0_ = 0;
	gint font_size = 0;
	cairo_t* _tmp4_ = NULL;
	cairo_t* _tmp5_ = NULL;
	cairo_t* _tmp6_ = NULL;
	cairo_t* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	cairo_t* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	cairo_t* _tmp12_ = NULL;
	cairo_t* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	cairo_t* _tmp15_ = NULL;
	cairo_t* _tmp16_ = NULL;
	cairo_t* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	cairo_t* _tmp19_ = NULL;
	cairo_t* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (number != NULL);
	g_return_if_fail (suit != NULL);
	_tmp0_ = color;
	switch (_tmp0_) {
		case 0:
		{
			cairo_t* _tmp1_ = NULL;
			_tmp1_ = context;
			cairo_set_source_rgb (_tmp1_, 0.18, 0.204, 0.212);
			break;
		}
		case 1:
		{
			cairo_t* _tmp2_ = NULL;
			_tmp2_ = context;
			cairo_set_source_rgb (_tmp2_, 0.643, (gdouble) 0, (gdouble) 0);
			break;
		}
		case 2:
		{
			cairo_t* _tmp3_ = NULL;
			_tmp3_ = context;
			cairo_set_source_rgb (_tmp3_, 0.125, 0.29, 0.529);
			break;
		}
		default:
		break;
	}
	font_size = 4;
	_tmp4_ = context;
	cairo_select_font_face (_tmp4_, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	_tmp5_ = context;
	cairo_set_font_size (_tmp5_, (gdouble) font_size);
	_tmp6_ = context;
	cairo_scale (_tmp6_, (gdouble) 1, (gdouble) -1);
	_tmp7_ = context;
	_tmp8_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp9_ = _tmp8_;
	cairo_translate (_tmp7_, (gdouble) 1, (-_tmp9_) + font_size);
	_tmp10_ = context;
	_tmp11_ = number;
	cairo_show_text (_tmp10_, _tmp11_);
	_tmp12_ = context;
	cairo_move_to (_tmp12_, (gdouble) 0, (gdouble) font_size);
	_tmp13_ = context;
	_tmp14_ = suit;
	cairo_show_text (_tmp13_, _tmp14_);
	_tmp15_ = context;
	cairo_move_to (_tmp15_, (gdouble) 6, (gdouble) 12);
	_tmp16_ = context;
	cairo_set_font_size (_tmp16_, (gdouble) 14);
	_tmp17_ = context;
	_tmp18_ = number;
	cairo_show_text (_tmp17_, _tmp18_);
	_tmp19_ = context;
	cairo_move_to (_tmp19_, (gdouble) 6, (gdouble) 32);
	_tmp20_ = context;
	_tmp21_ = suit;
	cairo_show_text (_tmp20_, _tmp21_);
}


static void tarot_cairo_default_card_painter_real_paint_card (TarotCairoCardPainter* base, TarotCard card, gboolean selected, cairo_t* context) {
	TarotCairoDefaultCardPainter * self;
	TarotCard _tmp0_ = 0U;
	self = (TarotCairoDefaultCardPainter*) base;
	g_return_if_fail (context != NULL);
	_tmp0_ = card;
	if (_tmp0_ < ((TarotCard) 78)) {
		gboolean _tmp1_ = FALSE;
		cairo_t* _tmp2_ = NULL;
		TarotNumber n = 0U;
		TarotSuit s = 0;
		gchar* number = NULL;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* suit = NULL;
		gchar* _tmp5_ = NULL;
		gint color = 0;
		TarotCard _tmp6_ = 0U;
		TarotNumber _tmp7_ = 0U;
		TarotSuit _tmp8_ = 0;
		gint _tmp9_ = 0;
		cairo_t* _tmp30_ = NULL;
		const gchar* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		gint _tmp33_ = 0;
		_tmp1_ = selected;
		_tmp2_ = context;
		tarot_cairo_default_card_painter_paint_border (self, _tmp1_, _tmp2_);
		_tmp3_ = _ ("EXC");
		_tmp4_ = g_strdup (_tmp3_);
		number = _tmp4_;
		_tmp5_ = g_strdup ("*");
		suit = _tmp5_;
		color = 2;
		_tmp6_ = card;
		_tmp9_ = tarot_decompose (_tmp6_, &_tmp7_, &_tmp8_);
		n = _tmp7_;
		s = _tmp8_;
		if (_tmp9_ == 0) {
			TarotSuit _tmp10_ = 0;
			_tmp10_ = s;
			if (_tmp10_ == TAROT_TRUMPS) {
				gchar* _tmp11_ = NULL;
				TarotNumber _tmp12_ = 0U;
				gchar* _tmp13_ = NULL;
				_tmp11_ = g_strdup ("#");
				_g_free0 (suit);
				suit = _tmp11_;
				color = 2;
				_tmp12_ = n;
				_tmp13_ = g_strdup_printf ("%u", (guint) _tmp12_);
				_g_free0 (number);
				number = _tmp13_;
			} else {
				TarotSuit _tmp14_ = 0;
				TarotNumber _tmp19_ = 0U;
				gchar* _tmp20_ = NULL;
				TarotNumber _tmp21_ = 0U;
				_tmp14_ = s;
				switch (_tmp14_) {
					case TAROT_HEARTS:
					{
						gchar* _tmp15_ = NULL;
						_tmp15_ = g_strdup ("♥");
						_g_free0 (suit);
						suit = _tmp15_;
						color = 1;
						break;
					}
					case TAROT_CLUBS:
					{
						gchar* _tmp16_ = NULL;
						_tmp16_ = g_strdup ("♣");
						_g_free0 (suit);
						suit = _tmp16_;
						color = 0;
						break;
					}
					case TAROT_DIAMONDS:
					{
						gchar* _tmp17_ = NULL;
						_tmp17_ = g_strdup ("♦");
						_g_free0 (suit);
						suit = _tmp17_;
						color = 1;
						break;
					}
					case TAROT_SPADES:
					{
						gchar* _tmp18_ = NULL;
						_tmp18_ = g_strdup ("♠");
						_g_free0 (suit);
						suit = _tmp18_;
						color = 0;
						break;
					}
					default:
					break;
				}
				_tmp19_ = n;
				_tmp20_ = g_strdup_printf ("%u", (guint) _tmp19_);
				_g_free0 (number);
				number = _tmp20_;
				_tmp21_ = n;
				switch (_tmp21_) {
					case 11:
					{
						const gchar* _tmp22_ = NULL;
						gchar* _tmp23_ = NULL;
						_tmp22_ = _ ("J");
						_tmp23_ = g_strdup (_tmp22_);
						_g_free0 (number);
						number = _tmp23_;
						break;
					}
					case 12:
					{
						const gchar* _tmp24_ = NULL;
						gchar* _tmp25_ = NULL;
						_tmp24_ = _ ("C");
						_tmp25_ = g_strdup (_tmp24_);
						_g_free0 (number);
						number = _tmp25_;
						break;
					}
					case 13:
					{
						const gchar* _tmp26_ = NULL;
						gchar* _tmp27_ = NULL;
						_tmp26_ = _ ("Q");
						_tmp27_ = g_strdup (_tmp26_);
						_g_free0 (number);
						number = _tmp27_;
						break;
					}
					case 14:
					{
						const gchar* _tmp28_ = NULL;
						gchar* _tmp29_ = NULL;
						_tmp28_ = _ ("K");
						_tmp29_ = g_strdup (_tmp28_);
						_g_free0 (number);
						number = _tmp29_;
						break;
					}
					default:
					break;
				}
			}
		}
		_tmp30_ = context;
		_tmp31_ = number;
		_tmp32_ = suit;
		_tmp33_ = color;
		tarot_cairo_default_card_painter_paint_number_and_suit (self, _tmp30_, _tmp31_, _tmp32_, _tmp33_);
		_g_free0 (suit);
		_g_free0 (number);
	} else {
		TarotCard _tmp34_ = 0U;
		_tmp34_ = card;
		if (_tmp34_ == ((TarotCard) 78)) {
			cairo_t* _tmp35_ = NULL;
			_tmp35_ = context;
			tarot_cairo_default_card_painter_paint_back (self, _tmp35_);
		}
	}
}


TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_construct (GType object_type) {
	TarotCairoDefaultCardPainter * self = NULL;
	self = (TarotCairoDefaultCardPainter*) g_object_new (object_type, NULL);
	return self;
}


TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_new (void) {
	return tarot_cairo_default_card_painter_construct (TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER);
}


static gdouble tarot_cairo_default_card_painter_real_get_card_width (TarotCairoCardPainter* base) {
	gdouble result;
	TarotCairoDefaultCardPainter* self;
	gdouble _tmp0_ = 0.0;
	self = (TarotCairoDefaultCardPainter*) base;
	_tmp0_ = self->priv->_card_width;
	result = _tmp0_;
	return result;
}


static gdouble tarot_cairo_default_card_painter_real_get_card_height (TarotCairoCardPainter* base) {
	gdouble result;
	TarotCairoDefaultCardPainter* self;
	gdouble _tmp0_ = 0.0;
	self = (TarotCairoDefaultCardPainter*) base;
	_tmp0_ = self->priv->_card_height;
	result = _tmp0_;
	return result;
}


static void tarot_cairo_default_card_painter_class_init (TarotCairoDefaultCardPainterClass * klass) {
	tarot_cairo_default_card_painter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TarotCairoDefaultCardPainterPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_cairo_default_card_painter_get_property;
	G_OBJECT_CLASS (klass)->finalize = tarot_cairo_default_card_painter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH, g_param_spec_double ("card-width", "card-width", "card-width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT, g_param_spec_double ("card-height", "card-height", "card-height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void tarot_cairo_default_card_painter_tarot_cairo_card_painter_interface_init (TarotCairoCardPainterIface * iface) {
	tarot_cairo_default_card_painter_tarot_cairo_card_painter_parent_iface = g_type_interface_peek_parent (iface);
	iface->paint_card = (void (*)(TarotCairoCardPainter*, TarotCard, gboolean, cairo_t*)) tarot_cairo_default_card_painter_real_paint_card;
	iface->get_card_width = tarot_cairo_default_card_painter_real_get_card_width;
	iface->get_card_height = tarot_cairo_default_card_painter_real_get_card_height;
}


static void tarot_cairo_default_card_painter_instance_init (TarotCairoDefaultCardPainter * self) {
	self->priv = TAROT_CAIRO_DEFAULT_CARD_PAINTER_GET_PRIVATE (self);
	self->priv->_card_width = (gdouble) 32;
	self->priv->_card_height = (gdouble) 48;
	self->border_width = (gdouble) 1;
}


static void tarot_cairo_default_card_painter_finalize (GObject* obj) {
	TarotCairoDefaultCardPainter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter);
	G_OBJECT_CLASS (tarot_cairo_default_card_painter_parent_class)->finalize (obj);
}


GType tarot_cairo_default_card_painter_get_type (void) {
	static volatile gsize tarot_cairo_default_card_painter_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_cairo_default_card_painter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotCairoDefaultCardPainterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_cairo_default_card_painter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotCairoDefaultCardPainter), 0, (GInstanceInitFunc) tarot_cairo_default_card_painter_instance_init, NULL };
		static const GInterfaceInfo tarot_cairo_card_painter_info = { (GInterfaceInitFunc) tarot_cairo_default_card_painter_tarot_cairo_card_painter_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType tarot_cairo_default_card_painter_type_id;
		tarot_cairo_default_card_painter_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotCairoDefaultCardPainter", &g_define_type_info, 0);
		g_type_add_interface_static (tarot_cairo_default_card_painter_type_id, TAROT_CAIRO_TYPE_CARD_PAINTER, &tarot_cairo_card_painter_info);
		g_once_init_leave (&tarot_cairo_default_card_painter_type_id__volatile, tarot_cairo_default_card_painter_type_id);
	}
	return tarot_cairo_default_card_painter_type_id__volatile;
}


static void _vala_tarot_cairo_default_card_painter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TarotCairoDefaultCardPainter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter);
	switch (property_id) {
		case TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH:
		g_value_set_double (value, tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self));
		break;
		case TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT:
		g_value_set_double (value, tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



