#include <config.h>
/* application.c generated by valac 0.34.7, the Vala compiler
 * generated from application.vala, do not modify */

/* main.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gio/gio.h>


#define TAROT_TYPE_MCTS_PARAMS (tarot_mcts_params_get_type ())
typedef struct _TarotMctsParams TarotMctsParams;
typedef struct _Block9Data Block9Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TAROT_TYPE_WINDOW (tarot_window_get_type ())
#define TAROT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_WINDOW, TarotWindow))
#define TAROT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_WINDOW, TarotWindowClass))
#define TAROT_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_WINDOW))
#define TAROT_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_WINDOW))
#define TAROT_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_WINDOW, TarotWindowClass))

typedef struct _TarotWindow TarotWindow;
typedef struct _TarotWindowClass TarotWindowClass;

struct _TarotMctsParams {
	const gchar* seed;
	gsize n_iterations;
	gdouble parameter;
	gdouble simulation_agreed;
	gdouble simulation_random;
};

struct _Block9Data {
	int _ref_count_;
	gsize n_players;
	gboolean call;
	TarotMctsParams mp;
	gsize retry;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	GtkApplication* app;
};



GType tarot_mcts_params_get_type (void) G_GNUC_CONST;
TarotMctsParams* tarot_mcts_params_dup (const TarotMctsParams* self);
void tarot_mcts_params_free (TarotMctsParams* self);
gint tarot_gui_try (gsize n_players, gboolean call, TarotMctsParams* mp, gsize retry, gboolean no_window, gchar** output);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ___lambda40_ (Block10Data* _data10_);
TarotWindow* tarot_window_new (GtkApplication* app, gsize n_players, gboolean with_call, TarotMctsParams* mp, gint retry);
TarotWindow* tarot_window_construct (GType object_type, GtkApplication* app, gsize n_players, gboolean with_call, TarotMctsParams* mp, gint retry);
GType tarot_window_get_type (void) G_GNUC_CONST;
static void ____lambda40__g_application_activate (GApplication* _sender, gpointer self);
gint tarot_solo_run (gsize n_players, gboolean call, TarotMctsParams* mp, gint retry, gchar** output);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static Block9Data* block9_data_ref (Block9Data* _data9_) {
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}


static void block9_data_unref (void * _userdata_) {
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		g_slice_free (Block9Data, _data9_);
	}
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		_g_object_unref0 (_data10_->app);
		block9_data_unref (_data10_->_data9_);
		_data10_->_data9_ = NULL;
		g_slice_free (Block10Data, _data10_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void ___lambda40_ (Block10Data* _data10_) {
	Block9Data* _data9_;
	GtkWindow* win = NULL;
	GtkApplication* _tmp0_ = NULL;
	GtkWindow* _tmp1_ = NULL;
	GtkWindow* _tmp2_ = NULL;
	GtkWindow* _tmp3_ = NULL;
	GtkWindow* _tmp4_ = NULL;
	GtkWindow* _tmp11_ = NULL;
	_data9_ = _data10_->_data9_;
	_tmp0_ = _data10_->app;
	_tmp1_ = gtk_application_get_active_window (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	win = _tmp3_;
	_tmp4_ = win;
	if (_tmp4_ == NULL) {
		GtkApplication* _tmp5_ = NULL;
		gsize _tmp6_ = 0UL;
		gboolean _tmp7_ = FALSE;
		TarotMctsParams _tmp8_ = {0};
		gsize _tmp9_ = 0UL;
		TarotWindow* _tmp10_ = NULL;
		_tmp5_ = _data10_->app;
		_tmp6_ = _data9_->n_players;
		_tmp7_ = _data9_->call;
		_tmp8_ = _data9_->mp;
		_tmp9_ = _data9_->retry;
		_tmp10_ = tarot_window_new (_tmp5_, _tmp6_, _tmp7_, &_tmp8_, (gint) _tmp9_);
		g_object_ref_sink (_tmp10_);
		_g_object_unref0 (win);
		win = (GtkWindow*) _tmp10_;
	}
	_tmp11_ = win;
	gtk_window_present (_tmp11_);
	_g_object_unref0 (win);
}


static void ____lambda40__g_application_activate (GApplication* _sender, gpointer self) {
	___lambda40_ (self);
}


gint tarot_gui_try (gsize n_players, gboolean call, TarotMctsParams* mp, gsize retry, gboolean no_window, gchar** output) {
	gchar* _vala_output = NULL;
	gint result = 0;
	Block9Data* _data9_;
	gsize _tmp0_ = 0UL;
	gboolean _tmp1_ = FALSE;
	TarotMctsParams _tmp2_ = {0};
	gsize _tmp3_ = 0UL;
	gchar** argv = NULL;
	gint argv_length1 = 0;
	gint _argv_size_ = 0;
	gchar** argv_ref = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint argv_ref_length1 = 0;
	gint _argv_ref_size_ = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	g_return_val_if_fail (mp != NULL, 0);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_tmp0_ = n_players;
	_data9_->n_players = _tmp0_;
	_tmp1_ = call;
	_data9_->call = _tmp1_;
	_tmp2_ = *mp;
	_data9_->mp = _tmp2_;
	_tmp3_ = retry;
	_data9_->retry = _tmp3_;
	_g_free0 (_vala_output);
	_vala_output = NULL;
	argv = NULL;
	argv_length1 = 0;
	_argv_size_ = argv_length1;
	_tmp4_ = argv;
	_tmp4__length1 = argv_length1;
	argv_ref = _tmp4_;
	argv_ref_length1 = _tmp4__length1;
	_argv_ref_size_ = argv_ref_length1;
	_tmp6_ = no_window;
	if (!_tmp6_) {
		gboolean _tmp7_ = FALSE;
		_tmp7_ = gtk_init_check (&argv_ref_length1, &argv_ref);
		_tmp5_ = _tmp7_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Block10Data* _data10_;
		GtkApplication* _tmp8_ = NULL;
		GtkApplication* _tmp9_ = NULL;
		GtkApplication* _tmp10_ = NULL;
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gint _tmp12_ = 0;
		_data10_ = g_slice_new0 (Block10Data);
		_data10_->_ref_count_ = 1;
		_data10_->_data9_ = block9_data_ref (_data9_);
		_tmp8_ = gtk_application_new (NULL, G_APPLICATION_FLAGS_NONE);
		_data10_->app = _tmp8_;
		_tmp9_ = _data10_->app;
		g_signal_connect_data ((GApplication*) _tmp9_, "activate", (GCallback) ____lambda40__g_application_activate, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
		_tmp10_ = _data10_->app;
		_tmp11_ = argv_ref;
		_tmp11__length1 = argv_ref_length1;
		_tmp12_ = g_application_run ((GApplication*) _tmp10_, _tmp11__length1, _tmp11_);
		result = _tmp12_;
		block10_data_unref (_data10_);
		_data10_ = NULL;
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		block9_data_unref (_data9_);
		_data9_ = NULL;
		if (output) {
			*output = _vala_output;
		} else {
			_g_free0 (_vala_output);
		}
		return result;
	} else {
		gchar* my_output = NULL;
		gint ret = 0;
		gsize _tmp13_ = 0UL;
		gboolean _tmp14_ = FALSE;
		TarotMctsParams _tmp15_ = {0};
		gsize _tmp16_ = 0UL;
		gchar* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		my_output = NULL;
		_tmp13_ = _data9_->n_players;
		_tmp14_ = _data9_->call;
		_tmp15_ = _data9_->mp;
		_tmp16_ = _data9_->retry;
		_tmp18_ = tarot_solo_run (_tmp13_, _tmp14_, &_tmp15_, (gint) _tmp16_, &_tmp17_);
		_g_free0 (my_output);
		my_output = _tmp17_;
		ret = _tmp18_;
		_tmp19_ = my_output;
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_vala_output);
		_vala_output = _tmp20_;
		result = ret;
		_g_free0 (my_output);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		block9_data_unref (_data9_);
		_data9_ = NULL;
		if (output) {
			*output = _vala_output;
		} else {
			_g_free0 (_vala_output);
		}
		return result;
	}
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	if (output) {
		*output = _vala_output;
	} else {
		_g_free0 (_vala_output);
	}
	block9_data_unref (_data9_);
	_data9_ = NULL;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



