// main.vala
//
// Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>
// 
//  This program is free software: you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation, either version 3 of the
//  License, or (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see
//  <http://www.gnu.org/licenses/>.

namespace Tarot {
	public int gui_try (size_t n_players, bool call, MctsParams mp, size_t retry, bool no_window, out string? output) {
		output = null;
		string[]? argv = null;
		unowned string[]? argv_ref = argv;
		if (!no_window && Gtk.init_check (ref argv_ref)) {
			var app = new Gtk.Application (null, ApplicationFlags.FLAGS_NONE);
			app.activate.connect (() => {
					var win = app.active_window;
					if (win == null) {
						win = new Tarot.Window (app, n_players, call, mp, (int) retry);
					}
					win.present ();
				});
			return app.run (argv_ref);
		} else {
			string? my_output = null;
			int ret = Solo.run (n_players, call, mp, (int) retry, out my_output);
			output = my_output;
			return ret;
		}
	}
}