#include <config.h>
/* history.c generated by valac 0.34.7, the Vala compiler
 * generated from history.vala, do not modify */

/* application.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>


#define TAROT_TYPE_HISTORY (tarot_history_get_type ())
#define TAROT_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_HISTORY, TarotHistory))
#define TAROT_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_HISTORY, TarotHistoryClass))
#define TAROT_IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_HISTORY))
#define TAROT_IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_HISTORY))
#define TAROT_HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_HISTORY, TarotHistoryClass))

typedef struct _TarotHistory TarotHistory;
typedef struct _TarotHistoryClass TarotHistoryClass;
typedef struct _TarotHistoryPrivate TarotHistoryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotHistory {
	GObject parent_instance;
	TarotHistoryPrivate * priv;
};

struct _TarotHistoryClass {
	GObjectClass parent_class;
};

struct _TarotHistoryPrivate {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	gpointer* m_history;
	gint m_history_length1;
	gint _m_history_size_;
	gint m_current;
	gint m_first;
	gint m_n;
};


static gpointer tarot_history_parent_class = NULL;

GType tarot_history_get_type (void) G_GNUC_CONST;
#define TAROT_HISTORY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TAROT_TYPE_HISTORY, TarotHistoryPrivate))
enum  {
	TAROT_HISTORY_DUMMY_PROPERTY,
	TAROT_HISTORY_T_TYPE,
	TAROT_HISTORY_T_DUP_FUNC,
	TAROT_HISTORY_T_DESTROY_FUNC,
	TAROT_HISTORY_CAPACITY,
	TAROT_HISTORY_CURRENT
};
static gint tarot_history_fold (TarotHistory* self, gint from_start);
static gint tarot_history_unfold (TarotHistory* self, gint index);
gboolean tarot_history_undo (TarotHistory* self);
gboolean tarot_history_redo (TarotHistory* self);
void tarot_history_push (TarotHistory* self, gconstpointer data);
TarotHistory* tarot_history_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
TarotHistory* tarot_history_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
TarotHistory* tarot_history_new_with_capacity (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, gint capacity);
TarotHistory* tarot_history_construct_with_capacity (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, gint capacity);
gint tarot_history_get_capacity (TarotHistory* self);
void tarot_history_set_capacity (TarotHistory* self, gint value);
static gpointer* _vala_array_dup2 (gpointer* self, int length, GBoxedCopyFunc t_dup_func);
gconstpointer tarot_history_get_current (TarotHistory* self);
static void tarot_history_finalize (GObject* obj);
static void _vala_tarot_history_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tarot_history_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gint tarot_history_fold (TarotHistory* self, gint from_start) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint pos = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gpointer* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = from_start;
	_tmp1_ = self->priv->m_n;
	_vala_assert (_tmp0_ < _tmp1_, "from_start < m_n");
	_tmp2_ = self->priv->m_first;
	_tmp3_ = from_start;
	pos = _tmp2_ + _tmp3_;
	_tmp4_ = pos;
	_tmp5_ = self->priv->m_history;
	_tmp5__length1 = self->priv->m_history_length1;
	if (_tmp4_ >= _tmp5__length1) {
		gint _tmp6_ = 0;
		gpointer* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		_tmp6_ = pos;
		_tmp7_ = self->priv->m_history;
		_tmp7__length1 = self->priv->m_history_length1;
		pos = _tmp6_ - _tmp7__length1;
	}
	_tmp9_ = pos;
	if (_tmp9_ >= 0) {
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		_tmp10_ = pos;
		_tmp11_ = self->priv->m_n;
		_tmp8_ = _tmp10_ < _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_vala_assert (_tmp8_, "pos >= 0 && pos < m_n");
	result = pos;
	return result;
}


static gint tarot_history_unfold (TarotHistory* self, gint index) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint pos = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = index;
	if (_tmp1_ >= 0) {
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		_tmp2_ = index;
		_tmp3_ = self->priv->m_n;
		_tmp0_ = _tmp2_ < _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "index >= 0 && index < m_n");
	_tmp4_ = index;
	_tmp5_ = self->priv->m_first;
	if (_tmp4_ >= _tmp5_) {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = index;
		_tmp7_ = self->priv->m_first;
		pos = _tmp6_ - _tmp7_;
	} else {
		gint _tmp8_ = 0;
		gpointer* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		gint _tmp10_ = 0;
		_tmp8_ = index;
		_tmp9_ = self->priv->m_history;
		_tmp9__length1 = self->priv->m_history_length1;
		_tmp10_ = self->priv->m_first;
		pos = (_tmp8_ + _tmp9__length1) - _tmp10_;
	}
	_tmp12_ = pos;
	if (_tmp12_ >= 0) {
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		_tmp13_ = pos;
		_tmp14_ = self->priv->m_n;
		_tmp11_ = _tmp13_ < _tmp14_;
	} else {
		_tmp11_ = FALSE;
	}
	_vala_assert (_tmp11_, "pos >= 0 && pos < m_n");
	result = pos;
	return result;
}


gboolean tarot_history_undo (TarotHistory* self) {
	gboolean result = FALSE;
	gint n = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp5_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_current;
	_tmp1_ = tarot_history_unfold (self, _tmp0_);
	n = _tmp1_;
	_tmp2_ = n;
	if (_tmp2_ != 0) {
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		_tmp3_ = n;
		_tmp4_ = tarot_history_fold (self, _tmp3_ - 1);
		self->priv->m_current = _tmp4_;
	}
	_tmp5_ = n;
	result = _tmp5_ != 0;
	return result;
}


gboolean tarot_history_redo (TarotHistory* self) {
	gboolean result = FALSE;
	gint n = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_current;
	_tmp1_ = tarot_history_unfold (self, _tmp0_);
	n = _tmp1_;
	_tmp2_ = n;
	_tmp3_ = self->priv->m_n;
	if ((_tmp2_ + 1) < _tmp3_) {
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		_tmp4_ = n;
		_tmp5_ = tarot_history_fold (self, _tmp4_ + 1);
		self->priv->m_current = _tmp5_;
	}
	_tmp6_ = n;
	_tmp7_ = self->priv->m_n;
	result = (_tmp6_ + 1) < _tmp7_;
	return result;
}


void tarot_history_push (TarotHistory* self, gconstpointer data) {
	gint n = 0;
	gint _tmp0_ = 0;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gpointer* _tmp20_ = NULL;
	gint _tmp20__length1 = 0;
	gint _tmp21_ = 0;
	gconstpointer _tmp22_ = NULL;
	gpointer _tmp23_ = NULL;
	gpointer _tmp24_ = NULL;
	g_return_if_fail (self != NULL);
	n = 0;
	_tmp0_ = self->priv->m_n;
	if (_tmp0_ > 0) {
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		_tmp1_ = self->priv->m_current;
		_tmp2_ = tarot_history_unfold (self, _tmp1_);
		n = _tmp2_;
		_tmp3_ = n;
		_tmp4_ = self->priv->m_n;
		if ((_tmp3_ + 1) < _tmp4_) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			_tmp5_ = n;
			n = _tmp5_ + 1;
			_tmp6_ = n;
			self->priv->m_n = _tmp6_;
		} else {
			gint _tmp7_ = 0;
			gpointer* _tmp8_ = NULL;
			gint _tmp8__length1 = 0;
			_tmp7_ = self->priv->m_n;
			_tmp8_ = self->priv->m_history;
			_tmp8__length1 = self->priv->m_history_length1;
			if (_tmp7_ >= _tmp8__length1) {
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gpointer* _tmp11_ = NULL;
				gint _tmp11__length1 = 0;
				_tmp9_ = self->priv->m_first;
				self->priv->m_first = _tmp9_ + 1;
				_tmp10_ = self->priv->m_first;
				_tmp11_ = self->priv->m_history;
				_tmp11__length1 = self->priv->m_history_length1;
				if (_tmp10_ >= _tmp11__length1) {
					self->priv->m_first = 0;
				}
			} else {
				gint _tmp12_ = 0;
				_tmp12_ = self->priv->m_n;
				self->priv->m_n = _tmp12_ + 1;
			}
		}
	} else {
		gint _tmp13_ = 0;
		_tmp13_ = self->priv->m_n;
		self->priv->m_n = _tmp13_ + 1;
	}
	_tmp15_ = n;
	if (_tmp15_ >= 0) {
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		_tmp16_ = n;
		_tmp17_ = self->priv->m_n;
		_tmp14_ = _tmp16_ < _tmp17_;
	} else {
		_tmp14_ = FALSE;
	}
	_vala_assert (_tmp14_, "n >= 0 && n < m_n");
	_tmp18_ = n;
	_tmp19_ = tarot_history_fold (self, _tmp18_);
	self->priv->m_current = _tmp19_;
	_tmp20_ = self->priv->m_history;
	_tmp20__length1 = self->priv->m_history_length1;
	_tmp21_ = self->priv->m_current;
	_tmp22_ = data;
	_tmp23_ = ((_tmp22_ != NULL) && (self->priv->t_dup_func != NULL)) ? self->priv->t_dup_func ((gpointer) _tmp22_) : ((gpointer) _tmp22_);
	((_tmp20_[_tmp21_] == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (_tmp20_[_tmp21_] = (self->priv->t_destroy_func (_tmp20_[_tmp21_]), NULL));
	_tmp20_[_tmp21_] = _tmp23_;
	_tmp24_ = _tmp20_[_tmp21_];
}


TarotHistory* tarot_history_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
	TarotHistory * self = NULL;
	self = (TarotHistory*) tarot_history_construct_with_capacity (object_type, t_type, t_dup_func, t_destroy_func, 1);
	self->priv->t_type = t_type;
	self->priv->t_dup_func = t_dup_func;
	self->priv->t_destroy_func = t_destroy_func;
	return self;
}


TarotHistory* tarot_history_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
	return tarot_history_construct (TAROT_TYPE_HISTORY, t_type, t_dup_func, t_destroy_func);
}


TarotHistory* tarot_history_construct_with_capacity (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, gint capacity) {
	TarotHistory * self = NULL;
	gint _tmp0_ = 0;
	gpointer* _tmp1_ = NULL;
	self = (TarotHistory*) g_object_new (object_type, NULL);
	self->priv->t_type = t_type;
	self->priv->t_dup_func = t_dup_func;
	self->priv->t_destroy_func = t_destroy_func;
	_tmp0_ = capacity;
	_tmp1_ = g_new0 (gpointer, _tmp0_);
	self->priv->m_history = (_vala_array_free (self->priv->m_history, self->priv->m_history_length1, (GDestroyNotify) t_destroy_func), NULL);
	self->priv->m_history = _tmp1_;
	self->priv->m_history_length1 = _tmp0_;
	self->priv->_m_history_size_ = self->priv->m_history_length1;
	self->priv->m_current = 0;
	self->priv->m_first = 0;
	self->priv->m_n = 0;
	return self;
}


TarotHistory* tarot_history_new_with_capacity (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, gint capacity) {
	return tarot_history_construct_with_capacity (TAROT_TYPE_HISTORY, t_type, t_dup_func, t_destroy_func, capacity);
}


gint tarot_history_get_capacity (TarotHistory* self) {
	gint result;
	gpointer* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->m_history;
	_tmp0__length1 = self->priv->m_history_length1;
	result = _tmp0__length1;
	return result;
}


static gpointer* _vala_array_dup2 (gpointer* self, int length, GBoxedCopyFunc t_dup_func) {
	gpointer* result;
	int i;
	result = g_new0 (gpointer, length);
	for (i = 0; i < length; i++) {
		gpointer _tmp0_ = NULL;
		_tmp0_ = ((self[i] != NULL) && (t_dup_func != NULL)) ? t_dup_func ((gpointer) self[i]) : ((gpointer) self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


void tarot_history_set_capacity (TarotHistory* self, gint value) {
	gint _tmp0_ = 0;
	TarotHistory* buffer = NULL;
	gint _tmp1_ = 0;
	TarotHistory* _tmp2_ = NULL;
	TarotHistory* _tmp14_ = NULL;
	gpointer* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gpointer* _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	TarotHistory* _tmp17_ = NULL;
	gint _tmp18_ = 0;
	TarotHistory* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	TarotHistory* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ < 1) {
		value = 1;
	}
	_tmp1_ = value;
	_tmp2_ = tarot_history_new_with_capacity (self->priv->t_type, (GBoxedCopyFunc) self->priv->t_dup_func, (GDestroyNotify) self->priv->t_destroy_func, _tmp1_);
	buffer = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				gpointer t = NULL;
				gpointer* _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gconstpointer _tmp10_ = NULL;
				gpointer _tmp11_ = NULL;
				TarotHistory* _tmp12_ = NULL;
				gconstpointer _tmp13_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = self->priv->m_n;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				_tmp7_ = self->priv->m_history;
				_tmp7__length1 = self->priv->m_history_length1;
				_tmp8_ = i;
				_tmp9_ = tarot_history_fold (self, _tmp8_);
				_tmp10_ = _tmp7_[_tmp9_];
				_tmp11_ = ((_tmp10_ != NULL) && (self->priv->t_dup_func != NULL)) ? self->priv->t_dup_func ((gpointer) _tmp10_) : ((gpointer) _tmp10_);
				t = _tmp11_;
				_tmp12_ = buffer;
				_tmp13_ = t;
				tarot_history_push (_tmp12_, _tmp13_);
				((t == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (t = (self->priv->t_destroy_func (t), NULL));
			}
		}
	}
	_tmp14_ = buffer;
	_tmp15_ = _tmp14_->priv->m_history;
	_tmp15__length1 = _tmp14_->priv->m_history_length1;
	_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup2 (_tmp15_, _tmp15__length1, self->priv->t_dup_func) : ((gpointer) _tmp15_);
	_tmp16__length1 = _tmp15__length1;
	self->priv->m_history = (_vala_array_free (self->priv->m_history, self->priv->m_history_length1, (GDestroyNotify) self->priv->t_destroy_func), NULL);
	self->priv->m_history = _tmp16_;
	self->priv->m_history_length1 = _tmp16__length1;
	self->priv->_m_history_size_ = self->priv->m_history_length1;
	_tmp17_ = buffer;
	_tmp18_ = _tmp17_->priv->m_current;
	self->priv->m_current = _tmp18_;
	_tmp19_ = buffer;
	_tmp20_ = _tmp19_->priv->m_first;
	self->priv->m_first = _tmp20_;
	_tmp21_ = buffer;
	_tmp22_ = _tmp21_->priv->m_n;
	self->priv->m_n = _tmp22_;
	_g_object_unref0 (buffer);
	g_object_notify ((GObject *) self, "capacity");
}


gconstpointer tarot_history_get_current (TarotHistory* self) {
	gconstpointer result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->m_current;
	_tmp1_ = self->priv->m_n;
	if (_tmp0_ < _tmp1_) {
		gpointer* _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
		gint _tmp3_ = 0;
		gconstpointer _tmp4_ = NULL;
		_tmp2_ = self->priv->m_history;
		_tmp2__length1 = self->priv->m_history_length1;
		_tmp3_ = self->priv->m_current;
		_tmp4_ = _tmp2_[_tmp3_];
		result = _tmp4_;
		return result;
	}
	result = NULL;
	return result;
}


static void tarot_history_class_init (TarotHistoryClass * klass) {
	tarot_history_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TarotHistoryPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_history_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tarot_history_set_property;
	G_OBJECT_CLASS (klass)->finalize = tarot_history_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_HISTORY_T_TYPE, g_param_spec_gtype ("t-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_HISTORY_T_DUP_FUNC, g_param_spec_pointer ("t-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_HISTORY_T_DESTROY_FUNC, g_param_spec_pointer ("t-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_HISTORY_CAPACITY, g_param_spec_int ("capacity", "capacity", "capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_HISTORY_CURRENT, g_param_spec_pointer ("current", "current", "current", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void tarot_history_instance_init (TarotHistory * self) {
	self->priv = TAROT_HISTORY_GET_PRIVATE (self);
}


static void tarot_history_finalize (GObject* obj) {
	TarotHistory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_HISTORY, TarotHistory);
	self->priv->m_history = (_vala_array_free (self->priv->m_history, self->priv->m_history_length1, (GDestroyNotify) self->priv->t_destroy_func), NULL);
	G_OBJECT_CLASS (tarot_history_parent_class)->finalize (obj);
}


GType tarot_history_get_type (void) {
	static volatile gsize tarot_history_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_history_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotHistoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_history_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotHistory), 0, (GInstanceInitFunc) tarot_history_instance_init, NULL };
		GType tarot_history_type_id;
		tarot_history_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotHistory", &g_define_type_info, 0);
		g_once_init_leave (&tarot_history_type_id__volatile, tarot_history_type_id);
	}
	return tarot_history_type_id__volatile;
}


static void _vala_tarot_history_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TarotHistory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_HISTORY, TarotHistory);
	switch (property_id) {
		case TAROT_HISTORY_CAPACITY:
		g_value_set_int (value, tarot_history_get_capacity (self));
		break;
		case TAROT_HISTORY_CURRENT:
		g_value_set_pointer (value, tarot_history_get_current (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_tarot_history_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TarotHistory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_HISTORY, TarotHistory);
	switch (property_id) {
		case TAROT_HISTORY_CAPACITY:
		tarot_history_set_capacity (self, g_value_get_int (value));
		break;
		case TAROT_HISTORY_T_TYPE:
		self->priv->t_type = g_value_get_gtype (value);
		break;
		case TAROT_HISTORY_T_DUP_FUNC:
		self->priv->t_dup_func = g_value_get_pointer (value);
		break;
		case TAROT_HISTORY_T_DESTROY_FUNC:
		self->priv->t_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



