#include <config.h>
/* main.c generated by valac 0.34.7, the Vala compiler
 * generated from main.vala, do not modify */

/* main.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include "tarot-gobject.h"
#include <gio/gio.h>


#define TAROT_TYPE_MCTS_PARAMS (tarot_mcts_params_get_type ())
typedef struct _TarotMctsParams TarotMctsParams;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block5Data Block5Data;

#define TAROT_TYPE_SERVER (tarot_server_get_type ())
#define TAROT_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_SERVER, TarotServer))
#define TAROT_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_SERVER, TarotServerClass))
#define TAROT_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_SERVER))
#define TAROT_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_SERVER))
#define TAROT_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_SERVER, TarotServerClass))

typedef struct _TarotServer TarotServer;
typedef struct _TarotServerClass TarotServerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

#define TAROT_TYPE_MCTS_GAME (tarot_mcts_game_get_type ())
#define TAROT_MCTS_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_MCTS_GAME, TarotMctsGame))
#define TAROT_MCTS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_MCTS_GAME, TarotMctsGameClass))
#define TAROT_IS_MCTS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_MCTS_GAME))
#define TAROT_IS_MCTS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_MCTS_GAME))
#define TAROT_MCTS_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_MCTS_GAME, TarotMctsGameClass))

typedef struct _TarotMctsGame TarotMctsGame;
typedef struct _TarotMctsGameClass TarotMctsGameClass;

#define TAROT_TYPE_SEAT (tarot_seat_get_type ())
#define TAROT_SEAT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_SEAT, TarotSeat))
#define TAROT_IS_SEAT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_SEAT))
#define TAROT_SEAT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TAROT_TYPE_SEAT, TarotSeatIface))

typedef struct _TarotSeat TarotSeat;
typedef struct _TarotSeatIface TarotSeatIface;

#define TAROT_TYPE_SEAT_PROXY (tarot_seat_proxy_get_type ())
typedef struct _TarotMctsGamePrivate TarotMctsGamePrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _TarotMctsParams {
	const gchar* seed;
	gsize n_iterations;
	gdouble parameter;
	gdouble simulation_agreed;
	gdouble simulation_random;
};

struct _Block5Data {
	int _ref_count_;
	gchar* main_object_name;
};

struct _Block6Data {
	int _ref_count_;
	GMainLoop* loop;
};

typedef enum  {
	TAROT_SERVER_ERROR_INVALID_EVENT,
	TAROT_SERVER_ERROR_INTERNAL_SERVER_ERROR
} TarotServerError;
#define TAROT_SERVER_ERROR tarot_server_error_quark ()
struct _TarotSeatIface {
	GTypeInterface parent_iface;
	guint (*me) (TarotSeat* self, GError** error);
	void (*subscribe) (TarotSeat* self, GError** error);
	void (*bid) (TarotSeat* self, guint bid, GError** error);
	void (*declare) (TarotSeat* self, gboolean slam, GError** error);
	void (*call) (TarotSeat* self, guint card, GError** error);
	void (*discard) (TarotSeat* self, guint* cards, int cards_length1, GError** error);
	void (*handful) (TarotSeat* self, guint* cards, int cards_length1, GError** error);
	void (*play) (TarotSeat* self, guint card, GError** error);
};

struct _TarotMctsGame {
	GObject parent_instance;
	TarotMctsGamePrivate * priv;
	gchar* seed;
	gsize n_iterations;
};

struct _TarotMctsGameClass {
	GObjectClass parent_class;
};



#define program_name "tarot"
GType tarot_mcts_params_get_type (void) G_GNUC_CONST;
TarotMctsParams* tarot_mcts_params_dup (const TarotMctsParams* self);
void tarot_mcts_params_free (TarotMctsParams* self);
gchar* tarot_read_input (FILE* input_source);
gboolean tarot_write_output (FILE* output, const gchar* data);
void tarot_create_option_none (const gchar* long_name, gchar short_name, gboolean** is_set, const gchar* documentation, GOptionEntry* result);
void tarot_create_option_string (const gchar* long_name, gchar short_name, gchar** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result);
void tarot_create_option_int (const gchar* long_name, gchar short_name, gint** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result);
void tarot_create_option_float (const gchar* long_name, gchar short_name, gdouble** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result);
gint tarot_main (gchar** args, int args_length1);
void tarot_setup_environment (const gchar* runtime_prefix_env, const gchar* sysconfdir, const gchar* localedir);
static void _vala_array_add5 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add6 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add7 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add8 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add9 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add10 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add11 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add12 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add13 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add14 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add15 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add16 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add17 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add18 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add19 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add20 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add21 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add22 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add23 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add24 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add25 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add26 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add27 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add28 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add29 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add30 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add31 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add32 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add33 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add34 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add35 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add36 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add37 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add38 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add39 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
static void _vala_array_add40 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value);
gint tarot_run_version (const gchar* package_string);
gint tarot_run_status (const gchar* input, gchar** output);
gint tarot_run_impute (const gchar* input, const gchar* seed, gint retry, gchar** output);
gint tarot_run_mcts (const gchar* input, TarotMctsParams* mp, gchar** output);
gint tarot_run_mcts_tree (const gchar* input, TarotMctsParams* mp, gchar** output);
gint tarot_run_new_game (gsize n_players, gboolean with_call, gchar** output);
gint tarot_run_deal_to (const gchar* input, const gchar* str, gchar** output);
gint tarot_run_deal_all (const gchar* input, const gchar* owners, gchar** output);
gint tarot_run_deal_random (const gchar* input, const gchar* seed, gint retry, gchar** output);
gint tarot_run_bid (const gchar* input, TarotBid bid, gchar** output);
gint tarot_run_decl (const gchar* input, gboolean decl, gchar** output);
gint tarot_run_call (const gchar* input, const gchar* card, gchar** output);
gint tarot_run_dog (const gchar* input, const gchar* cards, gchar** output);
gint tarot_run_discard (const gchar* input, const gchar* cards, gchar** output);
gint tarot_run_handful (const gchar* input, const gchar* cards, gchar** output);
gint tarot_run_play (const gchar* input, const gchar* card, gchar** output);
gint tarot_run_generate (gint n_players, gboolean with_call, TarotMctsParams* mp, gint retry, gchar** output);
gint tarot_run_render (const gchar* input, gint width, gint height, gchar** output, int* output_length1);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ______________________lambda9_ (Block5Data* _data5_, GDBusConnection* conn);
TarotServer* tarot_server_new (GDBusConnection* conn);
TarotServer* tarot_server_construct (GType object_type, GDBusConnection* conn);
GType tarot_server_get_type (void) G_GNUC_CONST;
guint tarot_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
static void _______________________lambda9__gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
GType tarot_mcts_game_get_type (void) G_GNUC_CONST;
GType tarot_seat_proxy_get_type (void) G_GNUC_CONST;
guint tarot_seat_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GQuark tarot_server_error_quark (void);
GType tarot_seat_get_type (void) G_GNUC_CONST;
TarotMctsGame* tarot_mcts_game_new (TarotSeat* seat);
TarotMctsGame* tarot_mcts_game_construct (GType object_type, TarotSeat* seat);
void tarot_mcts_game_set_parameter (TarotMctsGame* self, gdouble value);
void tarot_mcts_game_set_simulation_agreed (TarotMctsGame* self, gdouble value);
void tarot_mcts_game_set_simulation_random (TarotMctsGame* self, gdouble value);
static void _______________________lambda39_ (Block6Data* _data6_, gint score);
static void ________________________lambda39__tarot_mcts_game_finished (TarotMctsGame* _sender, gint my_score, gpointer self);
gint tarot_run_interactive (gsize n_players, gboolean call, TarotMctsParams* mp, gint retry, gboolean no_window, gchar** output);


TarotMctsParams* tarot_mcts_params_dup (const TarotMctsParams* self) {
	TarotMctsParams* dup;
	dup = g_new0 (TarotMctsParams, 1);
	memcpy (dup, self, sizeof (TarotMctsParams));
	return dup;
}


void tarot_mcts_params_free (TarotMctsParams* self) {
	g_free (self);
}


GType tarot_mcts_params_get_type (void) {
	static volatile gsize tarot_mcts_params_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_mcts_params_type_id__volatile)) {
		GType tarot_mcts_params_type_id;
		tarot_mcts_params_type_id = g_boxed_type_register_static ("TarotMctsParams", (GBoxedCopyFunc) tarot_mcts_params_dup, (GBoxedFreeFunc) tarot_mcts_params_free);
		g_once_init_leave (&tarot_mcts_params_type_id__volatile, tarot_mcts_params_type_id);
	}
	return tarot_mcts_params_type_id__volatile;
}


gchar* tarot_read_input (FILE* input_source) {
	gchar* result = NULL;
	gint c = 0;
	gchar* ret = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (input_source != NULL, NULL);
	c = 0;
	_tmp0_ = g_strdup ("");
	ret = _tmp0_;
	while (TRUE) {
		FILE* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		const gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		_tmp1_ = input_source;
		_tmp2_ = fgetc (_tmp1_);
		c = _tmp2_;
		_tmp3_ = c;
		if (!(_tmp3_ >= 0)) {
			break;
		}
		_tmp4_ = ret;
		_tmp5_ = c;
		_tmp6_ = g_strnfill ((gsize) 1, (gchar) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
		_g_free0 (ret);
		ret = _tmp8_;
		_g_free0 (_tmp7_);
	}
	result = ret;
	return result;
}


gboolean tarot_write_output (FILE* output, const gchar* data) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (output != NULL, FALSE);
	_tmp0_ = data;
	if (_tmp0_ != NULL) {
		FILE* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		_tmp1_ = output;
		_tmp2_ = data;
		fputs (_tmp2_, _tmp1_);
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


void tarot_create_option_none (const gchar* long_name, gchar short_name, gboolean** is_set, const gchar* documentation, GOptionEntry* result) {
	GOptionEntry ret = {0};
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar _tmp2_ = '\0';
	g_return_if_fail (long_name != NULL);
	g_return_if_fail (documentation != NULL);
	memset (&ret, 0, sizeof (GOptionEntry));
	ret.arg = G_OPTION_ARG_NONE;
	ret.arg_data = is_set;
	ret.arg_description = NULL;
	_tmp0_ = documentation;
	ret.description = _tmp0_;
	ret.flags = 0;
	_tmp1_ = long_name;
	ret.long_name = _tmp1_;
	_tmp2_ = short_name;
	ret.short_name = _tmp2_;
	*result = ret;
	return;
}


void tarot_create_option_string (const gchar* long_name, gchar short_name, gchar** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result) {
	GOptionEntry ret = {0};
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar _tmp3_ = '\0';
	g_return_if_fail (long_name != NULL);
	g_return_if_fail (documentation != NULL);
	g_return_if_fail (documentation_arg != NULL);
	memset (&ret, 0, sizeof (GOptionEntry));
	ret.arg = G_OPTION_ARG_STRING;
	ret.arg_data = value;
	_tmp0_ = documentation_arg;
	ret.arg_description = _tmp0_;
	_tmp1_ = documentation;
	ret.description = _tmp1_;
	ret.flags = 0;
	_tmp2_ = long_name;
	ret.long_name = _tmp2_;
	_tmp3_ = short_name;
	ret.short_name = _tmp3_;
	*result = ret;
	return;
}


void tarot_create_option_int (const gchar* long_name, gchar short_name, gint** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result) {
	GOptionEntry ret = {0};
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar _tmp3_ = '\0';
	g_return_if_fail (long_name != NULL);
	g_return_if_fail (documentation != NULL);
	g_return_if_fail (documentation_arg != NULL);
	memset (&ret, 0, sizeof (GOptionEntry));
	ret.arg = G_OPTION_ARG_INT;
	ret.arg_data = value;
	_tmp0_ = documentation_arg;
	ret.arg_description = _tmp0_;
	_tmp1_ = documentation;
	ret.description = _tmp1_;
	ret.flags = 0;
	_tmp2_ = long_name;
	ret.long_name = _tmp2_;
	_tmp3_ = short_name;
	ret.short_name = _tmp3_;
	*result = ret;
	return;
}


void tarot_create_option_float (const gchar* long_name, gchar short_name, gdouble** value, const gchar* documentation, const gchar* documentation_arg, GOptionEntry* result) {
	GOptionEntry ret = {0};
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar _tmp3_ = '\0';
	g_return_if_fail (long_name != NULL);
	g_return_if_fail (documentation != NULL);
	g_return_if_fail (documentation_arg != NULL);
	memset (&ret, 0, sizeof (GOptionEntry));
	ret.arg = G_OPTION_ARG_DOUBLE;
	ret.arg_data = value;
	_tmp0_ = documentation_arg;
	ret.arg_description = _tmp0_;
	_tmp1_ = documentation;
	ret.description = _tmp1_;
	ret.flags = 0;
	_tmp2_ = long_name;
	ret.long_name = _tmp2_;
	_tmp3_ = short_name;
	ret.short_name = _tmp3_;
	*result = ret;
	return;
}


static void _vala_array_add5 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add6 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add7 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add8 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add9 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add10 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add11 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add12 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add13 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add14 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add15 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add16 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add17 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add18 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add19 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add20 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add21 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add22 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add23 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add24 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add25 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add26 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add27 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add28 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add29 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add30 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add31 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add32 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add33 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add34 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add35 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add36 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add37 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add38 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add39 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add40 (GOptionEntry** array, int* length, int* size, const GOptionEntry* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GOptionEntry, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		_g_free0 (_data5_->main_object_name);
		g_slice_free (Block5Data, _data5_);
	}
}


static void ______________________lambda9_ (Block5Data* _data5_, GDBusConnection* conn) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (conn != NULL);
	{
		GDBusConnection* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		GDBusConnection* _tmp2_ = NULL;
		TarotServer* _tmp3_ = NULL;
		TarotServer* _tmp4_ = NULL;
		_tmp0_ = conn;
		_tmp1_ = _data5_->main_object_name;
		_tmp2_ = conn;
		_tmp3_ = tarot_server_new (_tmp2_);
		_tmp4_ = _tmp3_;
		tarot_server_register_object (_tmp4_, _tmp0_, _tmp1_, &_inner_error_);
		_g_object_unref0 (_tmp4_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch1_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally1;
	__catch1_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = _ ("Could not register the D-Bus server, sorry: %s.\n");
		_tmp7_ = e->message;
		fprintf (_tmp5_, _tmp6_, _tmp7_);
		exit (1);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _______________________lambda9__gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	______________________lambda9_ (self, connection);
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		_g_main_loop_unref0 (_data6_->loop);
		g_slice_free (Block6Data, _data6_);
	}
}


static void _______________________lambda39_ (Block6Data* _data6_, gint score) {
	FILE* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	FILE* _tmp2_ = NULL;
	GMainLoop* _tmp3_ = NULL;
	_tmp0_ = stdout;
	_tmp1_ = score;
	fprintf (_tmp0_, "%d\n", _tmp1_);
	_tmp2_ = stdout;
	fflush (_tmp2_);
	_tmp3_ = _data6_->loop;
	g_main_loop_quit (_tmp3_);
}


static void ________________________lambda39__tarot_mcts_game_finished (TarotMctsGame* _sender, gint my_score, gpointer self) {
	_______________________lambda39_ (self, my_score);
}


static gchar* g_date_time_to_string (GDateTime* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}


gint tarot_main (gchar** args, int args_length1) {
	gint result = 0;
	gint n_players = 0;
	gboolean call_allowed = FALSE;
	gchar* seed = NULL;
	gint retry = 0;
	gint n_iterations = 0;
	gdouble mcts_parameter = 0.0;
	gdouble mcts_simulation_agreed = 0.0;
	gdouble mcts_simulation_random = 0.0;
	gchar* output_resource = NULL;
	gchar* input_resource = NULL;
	gint width = 0;
	gint height = 0;
	gboolean print_version = FALSE;
	gboolean has_status = FALSE;
	gboolean has_new_game = FALSE;
	gchar* has_deal_to = NULL;
	gchar* has_deal_all = NULL;
	gboolean has_deal_random = FALSE;
	gboolean has_impute = FALSE;
	gboolean has_mcts = FALSE;
	gboolean has_mcts_tree = FALSE;
	gboolean has_generate = FALSE;
	gchar* has_bid = NULL;
	gchar* has_decl = NULL;
	gchar* has_call = NULL;
	gchar* has_dog = NULL;
	gchar* has_discard = NULL;
	gchar* has_handful = NULL;
	gchar* has_play = NULL;
	gboolean has_render = FALSE;
	gboolean has_dbus_server = FALSE;
	gchar* default_server_bus_name = NULL;
	gchar* _tmp0_ = NULL;
	gchar* server_bus_name = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* has_dbus_mcts = NULL;
	gboolean has_anonymous_dbus = FALSE;
	gboolean no_window = FALSE;
	const gchar* _tmp3_ = NULL;
	GOptionEntry* options = NULL;
	GOptionEntry* _tmp4_ = NULL;
	gint options_length1 = 0;
	gint _options_size_ = 0;
	GOptionEntry* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	GOptionEntry _tmp8_ = {0};
	GOptionEntry* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	GOptionEntry _tmp12_ = {0};
	GOptionEntry* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	const gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	GOptionEntry _tmp17_ = {0};
	GOptionEntry* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	GOptionEntry _tmp22_ = {0};
	GOptionEntry* _tmp23_ = NULL;
	gint _tmp23__length1 = 0;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	GOptionEntry _tmp27_ = {0};
	GOptionEntry* _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	const gchar* _tmp31_ = NULL;
	GOptionEntry _tmp32_ = {0};
	GOptionEntry* _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	const gchar* _tmp34_ = NULL;
	const gchar* _tmp35_ = NULL;
	const gchar* _tmp36_ = NULL;
	GOptionEntry _tmp37_ = {0};
	GOptionEntry* _tmp38_ = NULL;
	gint _tmp38__length1 = 0;
	const gchar* _tmp39_ = NULL;
	const gchar* _tmp40_ = NULL;
	const gchar* _tmp41_ = NULL;
	GOptionEntry _tmp42_ = {0};
	GOptionEntry* _tmp43_ = NULL;
	gint _tmp43__length1 = 0;
	const gchar* _tmp44_ = NULL;
	const gchar* _tmp45_ = NULL;
	const gchar* _tmp46_ = NULL;
	GOptionEntry _tmp47_ = {0};
	GOptionEntry* _tmp48_ = NULL;
	gint _tmp48__length1 = 0;
	const gchar* _tmp49_ = NULL;
	const gchar* _tmp50_ = NULL;
	const gchar* _tmp51_ = NULL;
	GOptionEntry _tmp52_ = {0};
	GOptionEntry* _tmp53_ = NULL;
	gint _tmp53__length1 = 0;
	const gchar* _tmp54_ = NULL;
	const gchar* _tmp55_ = NULL;
	const gchar* _tmp56_ = NULL;
	GOptionEntry _tmp57_ = {0};
	GOptionEntry* _tmp58_ = NULL;
	gint _tmp58__length1 = 0;
	const gchar* _tmp59_ = NULL;
	const gchar* _tmp60_ = NULL;
	GOptionEntry _tmp61_ = {0};
	GOptionEntry* _tmp62_ = NULL;
	gint _tmp62__length1 = 0;
	const gchar* _tmp63_ = NULL;
	const gchar* _tmp64_ = NULL;
	GOptionEntry _tmp65_ = {0};
	GOptionEntry* _tmp66_ = NULL;
	gint _tmp66__length1 = 0;
	const gchar* _tmp67_ = NULL;
	const gchar* _tmp68_ = NULL;
	GOptionEntry _tmp69_ = {0};
	GOptionEntry* _tmp70_ = NULL;
	gint _tmp70__length1 = 0;
	const gchar* _tmp71_ = NULL;
	const gchar* _tmp72_ = NULL;
	GOptionEntry _tmp73_ = {0};
	GOptionEntry* _tmp74_ = NULL;
	gint _tmp74__length1 = 0;
	const gchar* _tmp75_ = NULL;
	const gchar* _tmp76_ = NULL;
	GOptionEntry _tmp77_ = {0};
	GOptionEntry* _tmp78_ = NULL;
	gint _tmp78__length1 = 0;
	const gchar* _tmp79_ = NULL;
	const gchar* _tmp80_ = NULL;
	GOptionEntry _tmp81_ = {0};
	GOptionEntry* _tmp82_ = NULL;
	gint _tmp82__length1 = 0;
	const gchar* _tmp83_ = NULL;
	const gchar* _tmp84_ = NULL;
	GOptionEntry _tmp85_ = {0};
	GOptionEntry* _tmp86_ = NULL;
	gint _tmp86__length1 = 0;
	const gchar* _tmp87_ = NULL;
	const gchar* _tmp88_ = NULL;
	const gchar* _tmp89_ = NULL;
	GOptionEntry _tmp90_ = {0};
	GOptionEntry* _tmp91_ = NULL;
	gint _tmp91__length1 = 0;
	const gchar* _tmp92_ = NULL;
	const gchar* _tmp93_ = NULL;
	const gchar* _tmp94_ = NULL;
	GOptionEntry _tmp95_ = {0};
	GOptionEntry* _tmp96_ = NULL;
	gint _tmp96__length1 = 0;
	const gchar* _tmp97_ = NULL;
	const gchar* _tmp98_ = NULL;
	const gchar* _tmp99_ = NULL;
	GOptionEntry _tmp100_ = {0};
	GOptionEntry* _tmp101_ = NULL;
	gint _tmp101__length1 = 0;
	const gchar* _tmp102_ = NULL;
	const gchar* _tmp103_ = NULL;
	const gchar* _tmp104_ = NULL;
	GOptionEntry _tmp105_ = {0};
	GOptionEntry* _tmp106_ = NULL;
	gint _tmp106__length1 = 0;
	const gchar* _tmp107_ = NULL;
	const gchar* _tmp108_ = NULL;
	GOptionEntry _tmp109_ = {0};
	GOptionEntry* _tmp110_ = NULL;
	gint _tmp110__length1 = 0;
	const gchar* _tmp111_ = NULL;
	const gchar* _tmp112_ = NULL;
	const gchar* _tmp113_ = NULL;
	GOptionEntry _tmp114_ = {0};
	GOptionEntry* _tmp115_ = NULL;
	gint _tmp115__length1 = 0;
	const gchar* _tmp116_ = NULL;
	const gchar* _tmp117_ = NULL;
	const gchar* _tmp118_ = NULL;
	GOptionEntry _tmp119_ = {0};
	GOptionEntry* _tmp120_ = NULL;
	gint _tmp120__length1 = 0;
	const gchar* _tmp121_ = NULL;
	const gchar* _tmp122_ = NULL;
	const gchar* _tmp123_ = NULL;
	GOptionEntry _tmp124_ = {0};
	GOptionEntry* _tmp125_ = NULL;
	gint _tmp125__length1 = 0;
	const gchar* _tmp126_ = NULL;
	const gchar* _tmp127_ = NULL;
	const gchar* _tmp128_ = NULL;
	GOptionEntry _tmp129_ = {0};
	GOptionEntry* _tmp130_ = NULL;
	gint _tmp130__length1 = 0;
	const gchar* _tmp131_ = NULL;
	const gchar* _tmp132_ = NULL;
	const gchar* _tmp133_ = NULL;
	GOptionEntry _tmp134_ = {0};
	GOptionEntry* _tmp135_ = NULL;
	gint _tmp135__length1 = 0;
	const gchar* _tmp136_ = NULL;
	const gchar* _tmp137_ = NULL;
	const gchar* _tmp138_ = NULL;
	GOptionEntry _tmp139_ = {0};
	GOptionEntry* _tmp140_ = NULL;
	gint _tmp140__length1 = 0;
	const gchar* _tmp141_ = NULL;
	const gchar* _tmp142_ = NULL;
	GOptionEntry _tmp143_ = {0};
	GOptionEntry* _tmp144_ = NULL;
	gint _tmp144__length1 = 0;
	const gchar* _tmp145_ = NULL;
	const gchar* _tmp146_ = NULL;
	const gchar* _tmp147_ = NULL;
	GOptionEntry _tmp148_ = {0};
	GOptionEntry* _tmp149_ = NULL;
	gint _tmp149__length1 = 0;
	const gchar* _tmp150_ = NULL;
	const gchar* _tmp151_ = NULL;
	const gchar* _tmp152_ = NULL;
	GOptionEntry _tmp153_ = {0};
	GOptionEntry* _tmp154_ = NULL;
	gint _tmp154__length1 = 0;
	const gchar* _tmp155_ = NULL;
	const gchar* _tmp156_ = NULL;
	GOptionEntry _tmp157_ = {0};
	gchar* doc = NULL;
	const gchar* _tmp158_ = NULL;
	const gchar* _tmp159_ = NULL;
	gchar* _tmp160_ = NULL;
	GOptionEntry* _tmp161_ = NULL;
	gint _tmp161__length1 = 0;
	const gchar* _tmp162_ = NULL;
	const gchar* _tmp163_ = NULL;
	const gchar* _tmp164_ = NULL;
	GOptionEntry _tmp165_ = {0};
	GOptionEntry* _tmp166_ = NULL;
	gint _tmp166__length1 = 0;
	const gchar* _tmp167_ = NULL;
	const gchar* _tmp168_ = NULL;
	GOptionEntry _tmp169_ = {0};
	GOptionEntry final = {0};
	GOptionEntry _tmp170_ = {0};
	GOptionEntry* _tmp171_ = NULL;
	gint _tmp171__length1 = 0;
	GOptionEntry _tmp172_ = {0};
	gint ret = 0;
	TarotMctsParams mparams = {0};
	const gchar* _tmp183_ = NULL;
	gint _tmp184_ = 0;
	gdouble _tmp185_ = 0.0;
	gdouble _tmp186_ = 0.0;
	gdouble _tmp187_ = 0.0;
	gchar* actual_output = NULL;
	FILE* input_stream = NULL;
	FILE* _tmp188_ = NULL;
	FILE* file_input_stream = NULL;
	const gchar* _tmp189_ = NULL;
	gboolean _tmp193_ = FALSE;
	gboolean _tmp427_ = FALSE;
	gint _tmp428_ = 0;
	GError * _inner_error_ = NULL;
	n_players = 4;
	call_allowed = FALSE;
	seed = NULL;
	retry = 0;
	n_iterations = 100;
	mcts_parameter = (gdouble) -1;
	mcts_simulation_agreed = (gdouble) -1;
	mcts_simulation_random = (gdouble) -1;
	output_resource = NULL;
	input_resource = NULL;
	width = 640;
	height = 480;
	print_version = FALSE;
	has_status = FALSE;
	has_new_game = FALSE;
	has_deal_to = NULL;
	has_deal_all = NULL;
	has_deal_random = FALSE;
	has_impute = FALSE;
	has_mcts = FALSE;
	has_mcts_tree = FALSE;
	has_generate = FALSE;
	has_bid = NULL;
	has_decl = NULL;
	has_call = NULL;
	has_dog = NULL;
	has_discard = NULL;
	has_handful = NULL;
	has_play = NULL;
	has_render = FALSE;
	has_dbus_server = FALSE;
	_tmp0_ = g_strdup ("eu.planete_kraus.Tarot");
	default_server_bus_name = _tmp0_;
	_tmp1_ = default_server_bus_name;
	_tmp2_ = g_strdup (_tmp1_);
	server_bus_name = _tmp2_;
	has_dbus_mcts = NULL;
	has_anonymous_dbus = FALSE;
	no_window = FALSE;
	tarot_setup_environment (RUNTIME_PREFIX_ENV, SYSCONFDIR, LOCALEDIR);
	setlocale (LC_ALL, "");
	_tmp3_ = g_getenv ("LOCALEDIR");
	bindtextdomain (PACKAGE, _tmp3_);
	textdomain (PACKAGE);
	_tmp4_ = g_new0 (GOptionEntry, 0);
	options = _tmp4_;
	options_length1 = 0;
	_options_size_ = options_length1;
	_tmp5_ = options;
	_tmp5__length1 = options_length1;
	_tmp6_ = _ ("new-game");
	_tmp7_ = _ ("Create a new game");
	tarot_create_option_none (_tmp6_, (gchar) 0, &has_new_game, _tmp7_, &_tmp8_);
	_vala_array_add5 (&options, &options_length1, &_options_size_, &_tmp8_);
	_tmp9_ = options;
	_tmp9__length1 = options_length1;
	_tmp10_ = _ ("deal-random");
	_tmp11_ = _ ("Deal the cards at random");
	tarot_create_option_none (_tmp10_, (gchar) 0, &has_deal_random, _tmp11_, &_tmp12_);
	_vala_array_add6 (&options, &options_length1, &_options_size_, &_tmp12_);
	_tmp13_ = options;
	_tmp13__length1 = options_length1;
	_tmp14_ = _ ("deal-to");
	_tmp15_ = _ ("Deal cards to a specific player");
	_tmp16_ = _ ("PN=CARD,CARD,...");
	tarot_create_option_string (_tmp14_, (gchar) 0, &has_deal_to, _tmp15_, _tmp16_, &_tmp17_);
	_vala_array_add7 (&options, &options_length1, &_options_size_, &_tmp17_);
	_tmp18_ = options;
	_tmp18__length1 = options_length1;
	_tmp19_ = _ ("deal-all");
	_tmp20_ = _ ("Deal the cards to all players at once");
	_tmp21_ = _ ("OWNER1,OWNER2,...");
	tarot_create_option_string (_tmp19_, (gchar) 0, &has_deal_all, _tmp20_, _tmp21_, &_tmp22_);
	_vala_array_add8 (&options, &options_length1, &_options_size_, &_tmp22_);
	_tmp23_ = options;
	_tmp23__length1 = options_length1;
	_tmp24_ = _ ("bid");
	_tmp25_ = _ ("Add a bid to the game: 'pass', 'take', 'push', 'straight-keep', or 'do" \
"uble-keep'");
	_tmp26_ = _ ("BID");
	tarot_create_option_string (_tmp24_, (gchar) 0, &has_bid, _tmp25_, _tmp26_, &_tmp27_);
	_vala_array_add9 (&options, &options_length1, &_options_size_, &_tmp27_);
	_tmp28_ = options;
	_tmp28__length1 = options_length1;
	_tmp29_ = _ ("declare");
	_tmp30_ = _ ("Add a slam declaration to the game");
	_tmp31_ = _ ("'pass'/'slam'");
	tarot_create_option_string (_tmp29_, (gchar) 0, &has_decl, _tmp30_, _tmp31_, &_tmp32_);
	_vala_array_add10 (&options, &options_length1, &_options_size_, &_tmp32_);
	_tmp33_ = options;
	_tmp33__length1 = options_length1;
	_tmp34_ = _ ("call");
	_tmp35_ = _ ("Call a card");
	_tmp36_ = _ ("CARD");
	tarot_create_option_string (_tmp34_, (gchar) 0, &has_call, _tmp35_, _tmp36_, &_tmp37_);
	_vala_array_add11 (&options, &options_length1, &_options_size_, &_tmp37_);
	_tmp38_ = options;
	_tmp38__length1 = options_length1;
	_tmp39_ = _ ("dog");
	_tmp40_ = _ ("Reveal the dog");
	_tmp41_ = _ ("CARD,CARD...");
	tarot_create_option_string (_tmp39_, (gchar) 0, &has_dog, _tmp40_, _tmp41_, &_tmp42_);
	_vala_array_add12 (&options, &options_length1, &_options_size_, &_tmp42_);
	_tmp43_ = options;
	_tmp43__length1 = options_length1;
	_tmp44_ = _ ("discard");
	_tmp45_ = _ ("The discard is done");
	_tmp46_ = _ ("'' or CARD,CARD...");
	tarot_create_option_string (_tmp44_, (gchar) 0, &has_discard, _tmp45_, _tmp46_, &_tmp47_);
	_vala_array_add13 (&options, &options_length1, &_options_size_, &_tmp47_);
	_tmp48_ = options;
	_tmp48__length1 = options_length1;
	_tmp49_ = _ ("handful");
	_tmp50_ = _ ("Show a handful");
	_tmp51_ = _ ("'' or CARD,CARD...");
	tarot_create_option_string (_tmp49_, (gchar) 0, &has_handful, _tmp50_, _tmp51_, &_tmp52_);
	_vala_array_add14 (&options, &options_length1, &_options_size_, &_tmp52_);
	_tmp53_ = options;
	_tmp53__length1 = options_length1;
	_tmp54_ = _ ("play");
	_tmp55_ = _ ("Play a card");
	_tmp56_ = _ ("CARD");
	tarot_create_option_string (_tmp54_, (gchar) 0, &has_play, _tmp55_, _tmp56_, &_tmp57_);
	_vala_array_add15 (&options, &options_length1, &_options_size_, &_tmp57_);
	_tmp58_ = options;
	_tmp58__length1 = options_length1;
	_tmp59_ = _ ("status");
	_tmp60_ = _ ("Print the status of the game");
	tarot_create_option_none (_tmp59_, (gchar) 0, &has_status, _tmp60_, &_tmp61_);
	_vala_array_add16 (&options, &options_length1, &_options_size_, &_tmp61_);
	_tmp62_ = options;
	_tmp62__length1 = options_length1;
	_tmp63_ = _ ("generate");
	_tmp64_ = _ ("Generate an entire game with MCTS moves");
	tarot_create_option_none (_tmp63_, (gchar) 0, &has_generate, _tmp64_, &_tmp65_);
	_vala_array_add17 (&options, &options_length1, &_options_size_, &_tmp65_);
	_tmp66_ = options;
	_tmp66__length1 = options_length1;
	_tmp67_ = _ ("mcts");
	_tmp68_ = _ ("Play the next move with MCTS");
	tarot_create_option_none (_tmp67_, (gchar) 0, &has_mcts, _tmp68_, &_tmp69_);
	_vala_array_add18 (&options, &options_length1, &_options_size_, &_tmp69_);
	_tmp70_ = options;
	_tmp70__length1 = options_length1;
	_tmp71_ = _ ("mcts-tree");
	_tmp72_ = _ ("Print the MCTS tree for the next move");
	tarot_create_option_none (_tmp71_, (gchar) 0, &has_mcts_tree, _tmp72_, &_tmp73_);
	_vala_array_add19 (&options, &options_length1, &_options_size_, &_tmp73_);
	_tmp74_ = options;
	_tmp74__length1 = options_length1;
	_tmp75_ = _ ("impute");
	_tmp76_ = _ ("Impute the missing cards");
	tarot_create_option_none (_tmp75_, (gchar) 0, &has_impute, _tmp76_, &_tmp77_);
	_vala_array_add20 (&options, &options_length1, &_options_size_, &_tmp77_);
	_tmp78_ = options;
	_tmp78__length1 = options_length1;
	_tmp79_ = _ ("render");
	_tmp80_ = _ ("Render a game as PNG");
	tarot_create_option_none (_tmp79_, (gchar) 0, &has_render, _tmp80_, &_tmp81_);
	_vala_array_add21 (&options, &options_length1, &_options_size_, &_tmp81_);
	_tmp82_ = options;
	_tmp82__length1 = options_length1;
	_tmp83_ = _ ("dbus-server");
	_tmp84_ = _ ("Run as a DBus server");
	tarot_create_option_none (_tmp83_, (gchar) 0, &has_dbus_server, _tmp84_, &_tmp85_);
	_vala_array_add22 (&options, &options_length1, &_options_size_, &_tmp85_);
	_tmp86_ = options;
	_tmp86__length1 = options_length1;
	_tmp87_ = _ ("dbus-mcts");
	_tmp88_ = _ ("Run the MCTS as a DBus client");
	_tmp89_ = _ ("SEAT_PATH");
	tarot_create_option_string (_tmp87_, (gchar) 0, &has_dbus_mcts, _tmp88_, _tmp89_, &_tmp90_);
	_vala_array_add23 (&options, &options_length1, &_options_size_, &_tmp90_);
	_tmp91_ = options;
	_tmp91__length1 = options_length1;
	_tmp92_ = _ ("input");
	_tmp93_ = _ ("Input file to read (defaults to stdin)");
	_tmp94_ = _ ("FILE");
	tarot_create_option_string (_tmp92_, 'i', &input_resource, _tmp93_, _tmp94_, &_tmp95_);
	_vala_array_add24 (&options, &options_length1, &_options_size_, &_tmp95_);
	_tmp96_ = options;
	_tmp96__length1 = options_length1;
	_tmp97_ = _ ("output");
	_tmp98_ = _ ("Output file to write (defaults to stdout)");
	_tmp99_ = _ ("FILE");
	tarot_create_option_string (_tmp97_, 'o', &output_resource, _tmp98_, _tmp99_, &_tmp100_);
	_vala_array_add25 (&options, &options_length1, &_options_size_, &_tmp100_);
	_tmp101_ = options;
	_tmp101__length1 = options_length1;
	_tmp102_ = _ ("n-player");
	_tmp103_ = _ ("Specify the number of players for a new game");
	_tmp104_ = _ ("N");
	tarot_create_option_int (_tmp102_, 'n', &n_players, _tmp103_, _tmp104_, &_tmp105_);
	_vala_array_add26 (&options, &options_length1, &_options_size_, &_tmp105_);
	_tmp106_ = options;
	_tmp106__length1 = options_length1;
	_tmp107_ = _ ("call-allowed");
	_tmp108_ = _ ("The new game can have a call");
	tarot_create_option_none (_tmp107_, 'c', &call_allowed, _tmp108_, &_tmp109_);
	_vala_array_add27 (&options, &options_length1, &_options_size_, &_tmp109_);
	_tmp110_ = options;
	_tmp110__length1 = options_length1;
	_tmp111_ = _ ("seed");
	_tmp112_ = _ ("The random seed for MCTS-related operations (defaults to 'default')");
	_tmp113_ = _ ("NON-EMPTY");
	tarot_create_option_string (_tmp111_, 's', &seed, _tmp112_, _tmp113_, &_tmp114_);
	_vala_array_add28 (&options, &options_length1, &_options_size_, &_tmp114_);
	_tmp115_ = options;
	_tmp115__length1 = options_length1;
	_tmp116_ = _ ("retry");
	_tmp117_ = _ ("Number of times to retry an operation that may fail out of bad luck");
	_tmp118_ = _ ("N");
	tarot_create_option_int (_tmp116_, 'r', &retry, _tmp117_, _tmp118_, &_tmp119_);
	_vala_array_add29 (&options, &options_length1, &_options_size_, &_tmp119_);
	_tmp120_ = options;
	_tmp120__length1 = options_length1;
	_tmp121_ = _ ("n-iterations");
	_tmp122_ = _ ("Number of iterations for the MCTS exploration (defaults to 100)");
	_tmp123_ = _ ("N");
	tarot_create_option_int (_tmp121_, 'I', &n_iterations, _tmp122_, _tmp123_, &_tmp124_);
	_vala_array_add30 (&options, &options_length1, &_options_size_, &_tmp124_);
	_tmp125_ = options;
	_tmp125__length1 = options_length1;
	_tmp126_ = _ ("mcts-parameter");
	_tmp127_ = _ ("Parameter value for the MCTS algorithm.  Pass a negative value to use " \
"the maintainer's default");
	_tmp128_ = _ ("VALUE");
	tarot_create_option_float (_tmp126_, (gchar) 0, &mcts_parameter, _tmp127_, _tmp128_, &_tmp129_);
	_vala_array_add31 (&options, &options_length1, &_options_size_, &_tmp129_);
	_tmp130_ = options;
	_tmp130__length1 = options_length1;
	_tmp131_ = _ ("mcts-simulation-agreed");
	_tmp132_ = _ ("Tendency for the MCTS to use an agreed simulation.  Pass a negative va" \
"lue to use the maintainer's default");
	_tmp133_ = _ ("VALUE");
	tarot_create_option_float (_tmp131_, (gchar) 0, &mcts_simulation_agreed, _tmp132_, _tmp133_, &_tmp134_);
	_vala_array_add32 (&options, &options_length1, &_options_size_, &_tmp134_);
	_tmp135_ = options;
	_tmp135__length1 = options_length1;
	_tmp136_ = _ ("mcts-simulation-random");
	_tmp137_ = _ ("Tendency for the MCTS to use a random simulation.  Pass a negative val" \
"ue to use the maintainer's default");
	_tmp138_ = _ ("VALUE");
	tarot_create_option_float (_tmp136_, (gchar) 0, &mcts_simulation_random, _tmp137_, _tmp138_, &_tmp139_);
	_vala_array_add33 (&options, &options_length1, &_options_size_, &_tmp139_);
	_tmp140_ = options;
	_tmp140__length1 = options_length1;
	_tmp141_ = _ ("no-window");
	_tmp142_ = _ ("Do not open a graphical window");
	tarot_create_option_none (_tmp141_, (gchar) 0, &no_window, _tmp142_, &_tmp143_);
	_vala_array_add34 (&options, &options_length1, &_options_size_, &_tmp143_);
	_tmp144_ = options;
	_tmp144__length1 = options_length1;
	_tmp145_ = _ ("width");
	_tmp146_ = _ ("PNG width (defaults to 640)");
	_tmp147_ = _ ("N");
	tarot_create_option_int (_tmp145_, 'w', &width, _tmp146_, _tmp147_, &_tmp148_);
	_vala_array_add35 (&options, &options_length1, &_options_size_, &_tmp148_);
	_tmp149_ = options;
	_tmp149__length1 = options_length1;
	_tmp150_ = _ ("height");
	_tmp151_ = _ ("PNG height (defaults to 480)");
	_tmp152_ = _ ("N");
	tarot_create_option_int (_tmp150_, 'h', &height, _tmp151_, _tmp152_, &_tmp153_);
	_vala_array_add36 (&options, &options_length1, &_options_size_, &_tmp153_);
	_tmp154_ = options;
	_tmp154__length1 = options_length1;
	_tmp155_ = _ ("anonymous-dbus");
	_tmp156_ = _ ("Set this option if you want to run the D-Bus service anonymously.");
	tarot_create_option_none (_tmp155_, (gchar) 0, &has_anonymous_dbus, _tmp156_, &_tmp157_);
	_vala_array_add37 (&options, &options_length1, &_options_size_, &_tmp157_);
	_tmp158_ = _ ("Override the DBus server owned name (default: %s)");
	_tmp159_ = default_server_bus_name;
	_tmp160_ = g_strdup_printf (_tmp158_, _tmp159_);
	doc = _tmp160_;
	_tmp161_ = options;
	_tmp161__length1 = options_length1;
	_tmp162_ = _ ("dbus-server-name");
	_tmp163_ = doc;
	_tmp164_ = _ ("DBUS_NAME");
	tarot_create_option_string (_tmp162_, (gchar) 0, &server_bus_name, _tmp163_, _tmp164_, &_tmp165_);
	_vala_array_add38 (&options, &options_length1, &_options_size_, &_tmp165_);
	_tmp166_ = options;
	_tmp166__length1 = options_length1;
	_tmp167_ = _ ("version");
	_tmp168_ = _ ("Print version information and exit");
	tarot_create_option_none (_tmp167_, 'v', &print_version, _tmp168_, &_tmp169_);
	_vala_array_add39 (&options, &options_length1, &_options_size_, &_tmp169_);
	_tmp170_.long_name = NULL;
	final = _tmp170_;
	_tmp171_ = options;
	_tmp171__length1 = options_length1;
	_tmp172_ = final;
	_vala_array_add40 (&options, &options_length1, &_options_size_, &_tmp172_);
	ret = 0;
	{
		GOptionContext* opt_context = NULL;
		const gchar* _tmp173_ = NULL;
		GOptionContext* _tmp174_ = NULL;
		GOptionContext* _tmp175_ = NULL;
		GOptionContext* _tmp176_ = NULL;
		GOptionEntry* _tmp177_ = NULL;
		gint _tmp177__length1 = 0;
		GOptionContext* _tmp178_ = NULL;
		_tmp173_ = _ ("- Tarot command-line options");
		_tmp174_ = g_option_context_new (_tmp173_);
		opt_context = _tmp174_;
		_tmp175_ = opt_context;
		g_option_context_set_help_enabled (_tmp175_, TRUE);
		_tmp176_ = opt_context;
		_tmp177_ = options;
		_tmp177__length1 = options_length1;
		g_option_context_add_main_entries (_tmp176_, _tmp177_, NULL);
		_tmp178_ = opt_context;
		g_option_context_parse (_tmp178_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp179_ = 0;
			_g_option_context_free0 (opt_context);
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (opt_context);
			_g_free0 (doc);
			options = (g_free (options), NULL);
			_g_free0 (has_dbus_mcts);
			_g_free0 (server_bus_name);
			_g_free0 (default_server_bus_name);
			_g_free0 (has_play);
			_g_free0 (has_handful);
			_g_free0 (has_discard);
			_g_free0 (has_dog);
			_g_free0 (has_call);
			_g_free0 (has_decl);
			_g_free0 (has_bid);
			_g_free0 (has_deal_all);
			_g_free0 (has_deal_to);
			_g_free0 (input_resource);
			_g_free0 (output_resource);
			_g_free0 (seed);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp179_;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp180_ = NULL;
		const gchar* _tmp181_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp180_ = stderr;
		_tmp181_ = e->message;
		fprintf (_tmp180_, "Error: %s\n", _tmp181_);
		abort ();
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp182_ = 0;
		_g_free0 (doc);
		options = (g_free (options), NULL);
		_g_free0 (has_dbus_mcts);
		_g_free0 (server_bus_name);
		_g_free0 (default_server_bus_name);
		_g_free0 (has_play);
		_g_free0 (has_handful);
		_g_free0 (has_discard);
		_g_free0 (has_dog);
		_g_free0 (has_call);
		_g_free0 (has_decl);
		_g_free0 (has_bid);
		_g_free0 (has_deal_all);
		_g_free0 (has_deal_to);
		_g_free0 (input_resource);
		_g_free0 (output_resource);
		_g_free0 (seed);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp182_;
	}
	memset (&mparams, 0, sizeof (TarotMctsParams));
	_tmp183_ = seed;
	mparams.seed = _tmp183_;
	_tmp184_ = n_iterations;
	mparams.n_iterations = (gsize) _tmp184_;
	_tmp185_ = mcts_parameter;
	mparams.parameter = _tmp185_;
	_tmp186_ = mcts_simulation_agreed;
	mparams.simulation_agreed = _tmp186_;
	_tmp187_ = mcts_simulation_random;
	mparams.simulation_random = _tmp187_;
	actual_output = NULL;
	_tmp188_ = stdin;
	input_stream = _tmp188_;
	_tmp189_ = input_resource;
	if (_tmp189_ != NULL) {
		const gchar* _tmp190_ = NULL;
		FILE* _tmp191_ = NULL;
		FILE* _tmp192_ = NULL;
		_tmp190_ = input_resource;
		_tmp191_ = g_fopen (_tmp190_, "r");
		_fclose0 (file_input_stream);
		file_input_stream = _tmp191_;
		_tmp192_ = file_input_stream;
		input_stream = _tmp192_;
	}
	_tmp193_ = print_version;
	if (_tmp193_) {
		gint _tmp194_ = 0;
		_tmp194_ = tarot_run_version (PACKAGE_STRING);
		ret = _tmp194_;
	} else {
		gboolean _tmp195_ = FALSE;
		_tmp195_ = has_status;
		if (_tmp195_) {
			FILE* _tmp196_ = NULL;
			gchar* _tmp197_ = NULL;
			gchar* _tmp198_ = NULL;
			gchar* _tmp199_ = NULL;
			gint _tmp200_ = 0;
			_tmp196_ = input_stream;
			_tmp197_ = tarot_read_input (_tmp196_);
			_tmp198_ = _tmp197_;
			_tmp200_ = tarot_run_status (_tmp198_, &_tmp199_);
			_g_free0 (actual_output);
			actual_output = _tmp199_;
			ret = _tmp200_;
			_g_free0 (_tmp198_);
		} else {
			gboolean _tmp201_ = FALSE;
			_tmp201_ = has_impute;
			if (_tmp201_) {
				TarotMctsParams _tmp202_ = {0};
				const gchar* _tmp203_ = NULL;
				FILE* _tmp204_ = NULL;
				gchar* _tmp205_ = NULL;
				gchar* _tmp206_ = NULL;
				TarotMctsParams _tmp207_ = {0};
				const gchar* _tmp208_ = NULL;
				gint _tmp209_ = 0;
				gchar* _tmp210_ = NULL;
				gint _tmp211_ = 0;
				_tmp202_ = mparams;
				_tmp203_ = _tmp202_.seed;
				if (_tmp203_ == NULL) {
					mparams.seed = "default";
				}
				_tmp204_ = input_stream;
				_tmp205_ = tarot_read_input (_tmp204_);
				_tmp206_ = _tmp205_;
				_tmp207_ = mparams;
				_tmp208_ = _tmp207_.seed;
				_tmp209_ = retry;
				_tmp211_ = tarot_run_impute (_tmp206_, _tmp208_, _tmp209_, &_tmp210_);
				_g_free0 (actual_output);
				actual_output = _tmp210_;
				ret = _tmp211_;
				_g_free0 (_tmp206_);
			} else {
				gboolean _tmp212_ = FALSE;
				_tmp212_ = has_mcts;
				if (_tmp212_) {
					TarotMctsParams _tmp213_ = {0};
					const gchar* _tmp214_ = NULL;
					FILE* _tmp215_ = NULL;
					gchar* _tmp216_ = NULL;
					gchar* _tmp217_ = NULL;
					TarotMctsParams _tmp218_ = {0};
					gchar* _tmp219_ = NULL;
					gint _tmp220_ = 0;
					_tmp213_ = mparams;
					_tmp214_ = _tmp213_.seed;
					if (_tmp214_ == NULL) {
						mparams.seed = "default";
					}
					_tmp215_ = input_stream;
					_tmp216_ = tarot_read_input (_tmp215_);
					_tmp217_ = _tmp216_;
					_tmp218_ = mparams;
					_tmp220_ = tarot_run_mcts (_tmp217_, &_tmp218_, &_tmp219_);
					_g_free0 (actual_output);
					actual_output = _tmp219_;
					ret = _tmp220_;
					_g_free0 (_tmp217_);
				} else {
					gboolean _tmp221_ = FALSE;
					_tmp221_ = has_mcts_tree;
					if (_tmp221_) {
						TarotMctsParams _tmp222_ = {0};
						const gchar* _tmp223_ = NULL;
						FILE* _tmp224_ = NULL;
						gchar* _tmp225_ = NULL;
						gchar* _tmp226_ = NULL;
						TarotMctsParams _tmp227_ = {0};
						gchar* _tmp228_ = NULL;
						gint _tmp229_ = 0;
						_tmp222_ = mparams;
						_tmp223_ = _tmp222_.seed;
						if (_tmp223_ == NULL) {
							mparams.seed = "default";
						}
						_tmp224_ = input_stream;
						_tmp225_ = tarot_read_input (_tmp224_);
						_tmp226_ = _tmp225_;
						_tmp227_ = mparams;
						_tmp229_ = tarot_run_mcts_tree (_tmp226_, &_tmp227_, &_tmp228_);
						_g_free0 (actual_output);
						actual_output = _tmp228_;
						ret = _tmp229_;
						_g_free0 (_tmp226_);
					} else {
						gboolean _tmp230_ = FALSE;
						_tmp230_ = has_new_game;
						if (_tmp230_) {
							gint _tmp231_ = 0;
							gboolean _tmp232_ = FALSE;
							gchar* _tmp233_ = NULL;
							gint _tmp234_ = 0;
							_tmp231_ = n_players;
							_tmp232_ = call_allowed;
							_tmp234_ = tarot_run_new_game ((gsize) _tmp231_, _tmp232_, &_tmp233_);
							_g_free0 (actual_output);
							actual_output = _tmp233_;
							ret = _tmp234_;
						} else {
							const gchar* _tmp235_ = NULL;
							_tmp235_ = has_deal_to;
							if (_tmp235_ != NULL) {
								FILE* _tmp236_ = NULL;
								gchar* _tmp237_ = NULL;
								gchar* _tmp238_ = NULL;
								const gchar* _tmp239_ = NULL;
								gchar* _tmp240_ = NULL;
								gint _tmp241_ = 0;
								_tmp236_ = input_stream;
								_tmp237_ = tarot_read_input (_tmp236_);
								_tmp238_ = _tmp237_;
								_tmp239_ = has_deal_to;
								_tmp241_ = tarot_run_deal_to (_tmp238_, _tmp239_, &_tmp240_);
								_g_free0 (actual_output);
								actual_output = _tmp240_;
								ret = _tmp241_;
								_g_free0 (_tmp238_);
							} else {
								const gchar* _tmp242_ = NULL;
								_tmp242_ = has_deal_all;
								if (_tmp242_ != NULL) {
									FILE* _tmp243_ = NULL;
									gchar* _tmp244_ = NULL;
									gchar* _tmp245_ = NULL;
									const gchar* _tmp246_ = NULL;
									gchar* _tmp247_ = NULL;
									gint _tmp248_ = 0;
									_tmp243_ = input_stream;
									_tmp244_ = tarot_read_input (_tmp243_);
									_tmp245_ = _tmp244_;
									_tmp246_ = has_deal_all;
									_tmp248_ = tarot_run_deal_all (_tmp245_, _tmp246_, &_tmp247_);
									_g_free0 (actual_output);
									actual_output = _tmp247_;
									ret = _tmp248_;
									_g_free0 (_tmp245_);
								} else {
									gboolean _tmp249_ = FALSE;
									_tmp249_ = has_deal_random;
									if (_tmp249_) {
										TarotMctsParams _tmp250_ = {0};
										const gchar* _tmp251_ = NULL;
										FILE* _tmp252_ = NULL;
										gchar* _tmp253_ = NULL;
										gchar* _tmp254_ = NULL;
										TarotMctsParams _tmp255_ = {0};
										const gchar* _tmp256_ = NULL;
										gint _tmp257_ = 0;
										gchar* _tmp258_ = NULL;
										gint _tmp259_ = 0;
										_tmp250_ = mparams;
										_tmp251_ = _tmp250_.seed;
										if (_tmp251_ == NULL) {
											mparams.seed = "default";
										}
										_tmp252_ = input_stream;
										_tmp253_ = tarot_read_input (_tmp252_);
										_tmp254_ = _tmp253_;
										_tmp255_ = mparams;
										_tmp256_ = _tmp255_.seed;
										_tmp257_ = retry;
										_tmp259_ = tarot_run_deal_random (_tmp254_, _tmp256_, _tmp257_, &_tmp258_);
										_g_free0 (actual_output);
										actual_output = _tmp258_;
										ret = _tmp259_;
										_g_free0 (_tmp254_);
									} else {
										const gchar* _tmp260_ = NULL;
										_tmp260_ = has_bid;
										if (_tmp260_ != NULL) {
											TarotBid bid_arg = 0;
											const gchar* _tmp261_ = NULL;
											const gchar* _tmp262_ = NULL;
											FILE* _tmp273_ = NULL;
											gchar* _tmp274_ = NULL;
											gchar* _tmp275_ = NULL;
											TarotBid _tmp276_ = 0;
											gchar* _tmp277_ = NULL;
											gint _tmp278_ = 0;
											_tmp261_ = has_bid;
											_tmp262_ = _ ("pass");
											if (g_strcmp0 (_tmp261_, _tmp262_) == 0) {
												bid_arg = TAROT_PASS;
											} else {
												const gchar* _tmp263_ = NULL;
												const gchar* _tmp264_ = NULL;
												_tmp263_ = has_bid;
												_tmp264_ = _ ("take");
												if (g_strcmp0 (_tmp263_, _tmp264_) == 0) {
													bid_arg = TAROT_TAKE;
												} else {
													const gchar* _tmp265_ = NULL;
													const gchar* _tmp266_ = NULL;
													_tmp265_ = has_bid;
													_tmp266_ = _ ("push");
													if (g_strcmp0 (_tmp265_, _tmp266_) == 0) {
														bid_arg = TAROT_PUSH;
													} else {
														const gchar* _tmp267_ = NULL;
														const gchar* _tmp268_ = NULL;
														_tmp267_ = has_bid;
														_tmp268_ = _ ("straight-keep");
														if (g_strcmp0 (_tmp267_, _tmp268_) == 0) {
															bid_arg = TAROT_STRAIGHT_KEEP;
														} else {
															const gchar* _tmp269_ = NULL;
															const gchar* _tmp270_ = NULL;
															_tmp269_ = has_bid;
															_tmp270_ = _ ("double-keep");
															if (g_strcmp0 (_tmp269_, _tmp270_) == 0) {
																bid_arg = TAROT_DOUBLE_KEEP;
															} else {
																FILE* _tmp271_ = NULL;
																const gchar* _tmp272_ = NULL;
																_tmp271_ = stderr;
																_tmp272_ = has_bid;
																fprintf (_tmp271_, "Error: '%s' is not a bid\n", _tmp272_);
																result = 1;
																_fclose0 (file_input_stream);
																_g_free0 (actual_output);
																_g_free0 (doc);
																options = (g_free (options), NULL);
																_g_free0 (has_dbus_mcts);
																_g_free0 (server_bus_name);
																_g_free0 (default_server_bus_name);
																_g_free0 (has_play);
																_g_free0 (has_handful);
																_g_free0 (has_discard);
																_g_free0 (has_dog);
																_g_free0 (has_call);
																_g_free0 (has_decl);
																_g_free0 (has_bid);
																_g_free0 (has_deal_all);
																_g_free0 (has_deal_to);
																_g_free0 (input_resource);
																_g_free0 (output_resource);
																_g_free0 (seed);
																return result;
															}
														}
													}
												}
											}
											_tmp273_ = input_stream;
											_tmp274_ = tarot_read_input (_tmp273_);
											_tmp275_ = _tmp274_;
											_tmp276_ = bid_arg;
											_tmp278_ = tarot_run_bid (_tmp275_, _tmp276_, &_tmp277_);
											_g_free0 (actual_output);
											actual_output = _tmp277_;
											ret = _tmp278_;
											_g_free0 (_tmp275_);
										} else {
											const gchar* _tmp279_ = NULL;
											_tmp279_ = has_decl;
											if (_tmp279_ != NULL) {
												gboolean decl_arg = FALSE;
												const gchar* _tmp280_ = NULL;
												const gchar* _tmp281_ = NULL;
												FILE* _tmp286_ = NULL;
												gchar* _tmp287_ = NULL;
												gchar* _tmp288_ = NULL;
												gboolean _tmp289_ = FALSE;
												gchar* _tmp290_ = NULL;
												gint _tmp291_ = 0;
												_tmp280_ = has_decl;
												_tmp281_ = _ ("pass");
												if (g_strcmp0 (_tmp280_, _tmp281_) == 0) {
													decl_arg = FALSE;
												} else {
													const gchar* _tmp282_ = NULL;
													const gchar* _tmp283_ = NULL;
													_tmp282_ = has_decl;
													_tmp283_ = _ ("slam");
													if (g_strcmp0 (_tmp282_, _tmp283_) == 0) {
														decl_arg = TRUE;
													} else {
														FILE* _tmp284_ = NULL;
														const gchar* _tmp285_ = NULL;
														_tmp284_ = stderr;
														_tmp285_ = has_decl;
														fprintf (_tmp284_, "Error: '%s' is not a slam declaration\n", _tmp285_);
														result = 1;
														_fclose0 (file_input_stream);
														_g_free0 (actual_output);
														_g_free0 (doc);
														options = (g_free (options), NULL);
														_g_free0 (has_dbus_mcts);
														_g_free0 (server_bus_name);
														_g_free0 (default_server_bus_name);
														_g_free0 (has_play);
														_g_free0 (has_handful);
														_g_free0 (has_discard);
														_g_free0 (has_dog);
														_g_free0 (has_call);
														_g_free0 (has_decl);
														_g_free0 (has_bid);
														_g_free0 (has_deal_all);
														_g_free0 (has_deal_to);
														_g_free0 (input_resource);
														_g_free0 (output_resource);
														_g_free0 (seed);
														return result;
													}
												}
												_tmp286_ = input_stream;
												_tmp287_ = tarot_read_input (_tmp286_);
												_tmp288_ = _tmp287_;
												_tmp289_ = decl_arg;
												_tmp291_ = tarot_run_decl (_tmp288_, _tmp289_, &_tmp290_);
												_g_free0 (actual_output);
												actual_output = _tmp290_;
												ret = _tmp291_;
												_g_free0 (_tmp288_);
											} else {
												const gchar* _tmp292_ = NULL;
												_tmp292_ = has_call;
												if (_tmp292_ != NULL) {
													FILE* _tmp293_ = NULL;
													gchar* _tmp294_ = NULL;
													gchar* _tmp295_ = NULL;
													const gchar* _tmp296_ = NULL;
													gchar* _tmp297_ = NULL;
													gint _tmp298_ = 0;
													_tmp293_ = input_stream;
													_tmp294_ = tarot_read_input (_tmp293_);
													_tmp295_ = _tmp294_;
													_tmp296_ = has_call;
													_tmp298_ = tarot_run_call (_tmp295_, _tmp296_, &_tmp297_);
													_g_free0 (actual_output);
													actual_output = _tmp297_;
													ret = _tmp298_;
													_g_free0 (_tmp295_);
												} else {
													const gchar* _tmp299_ = NULL;
													_tmp299_ = has_dog;
													if (_tmp299_ != NULL) {
														FILE* _tmp300_ = NULL;
														gchar* _tmp301_ = NULL;
														gchar* _tmp302_ = NULL;
														const gchar* _tmp303_ = NULL;
														gchar* _tmp304_ = NULL;
														gint _tmp305_ = 0;
														_tmp300_ = input_stream;
														_tmp301_ = tarot_read_input (_tmp300_);
														_tmp302_ = _tmp301_;
														_tmp303_ = has_dog;
														_tmp305_ = tarot_run_dog (_tmp302_, _tmp303_, &_tmp304_);
														_g_free0 (actual_output);
														actual_output = _tmp304_;
														ret = _tmp305_;
														_g_free0 (_tmp302_);
													} else {
														const gchar* _tmp306_ = NULL;
														_tmp306_ = has_discard;
														if (_tmp306_ != NULL) {
															FILE* _tmp307_ = NULL;
															gchar* _tmp308_ = NULL;
															gchar* _tmp309_ = NULL;
															const gchar* _tmp310_ = NULL;
															gchar* _tmp311_ = NULL;
															gint _tmp312_ = 0;
															_tmp307_ = input_stream;
															_tmp308_ = tarot_read_input (_tmp307_);
															_tmp309_ = _tmp308_;
															_tmp310_ = has_discard;
															_tmp312_ = tarot_run_discard (_tmp309_, _tmp310_, &_tmp311_);
															_g_free0 (actual_output);
															actual_output = _tmp311_;
															ret = _tmp312_;
															_g_free0 (_tmp309_);
														} else {
															const gchar* _tmp313_ = NULL;
															_tmp313_ = has_handful;
															if (_tmp313_ != NULL) {
																FILE* _tmp314_ = NULL;
																gchar* _tmp315_ = NULL;
																gchar* _tmp316_ = NULL;
																const gchar* _tmp317_ = NULL;
																gchar* _tmp318_ = NULL;
																gint _tmp319_ = 0;
																_tmp314_ = input_stream;
																_tmp315_ = tarot_read_input (_tmp314_);
																_tmp316_ = _tmp315_;
																_tmp317_ = has_handful;
																_tmp319_ = tarot_run_handful (_tmp316_, _tmp317_, &_tmp318_);
																_g_free0 (actual_output);
																actual_output = _tmp318_;
																ret = _tmp319_;
																_g_free0 (_tmp316_);
															} else {
																const gchar* _tmp320_ = NULL;
																_tmp320_ = has_play;
																if (_tmp320_ != NULL) {
																	FILE* _tmp321_ = NULL;
																	gchar* _tmp322_ = NULL;
																	gchar* _tmp323_ = NULL;
																	const gchar* _tmp324_ = NULL;
																	gchar* _tmp325_ = NULL;
																	gint _tmp326_ = 0;
																	_tmp321_ = input_stream;
																	_tmp322_ = tarot_read_input (_tmp321_);
																	_tmp323_ = _tmp322_;
																	_tmp324_ = has_play;
																	_tmp326_ = tarot_run_play (_tmp323_, _tmp324_, &_tmp325_);
																	_g_free0 (actual_output);
																	actual_output = _tmp325_;
																	ret = _tmp326_;
																	_g_free0 (_tmp323_);
																} else {
																	gboolean _tmp327_ = FALSE;
																	_tmp327_ = has_generate;
																	if (_tmp327_) {
																		TarotMctsParams _tmp328_ = {0};
																		const gchar* _tmp329_ = NULL;
																		gint _tmp330_ = 0;
																		gboolean _tmp331_ = FALSE;
																		TarotMctsParams _tmp332_ = {0};
																		gint _tmp333_ = 0;
																		gchar* _tmp334_ = NULL;
																		gint _tmp335_ = 0;
																		_tmp328_ = mparams;
																		_tmp329_ = _tmp328_.seed;
																		if (_tmp329_ == NULL) {
																			mparams.seed = "default";
																		}
																		_tmp330_ = n_players;
																		_tmp331_ = call_allowed;
																		_tmp332_ = mparams;
																		_tmp333_ = retry;
																		_tmp335_ = tarot_run_generate (_tmp330_, _tmp331_, &_tmp332_, _tmp333_, &_tmp334_);
																		_g_free0 (actual_output);
																		actual_output = _tmp334_;
																		ret = _tmp335_;
																	} else {
																		gboolean _tmp336_ = FALSE;
																		_tmp336_ = has_render;
																		if (_tmp336_) {
																			gchar* png_bytes = NULL;
																			gchar* _tmp337_ = NULL;
																			gint png_bytes_length1 = 0;
																			gint _png_bytes_size_ = 0;
																			FILE* _tmp338_ = NULL;
																			gchar* _tmp339_ = NULL;
																			gchar* _tmp340_ = NULL;
																			gint _tmp341_ = 0;
																			gint _tmp342_ = 0;
																			gchar* _tmp343_ = NULL;
																			gint _tmp344_ = 0;
																			gint _tmp345_ = 0;
																			FILE* str = NULL;
																			FILE* _tmp346_ = NULL;
																			FILE* file_str = NULL;
																			const gchar* _tmp347_ = NULL;
																			gchar* _tmp354_ = NULL;
																			gint _tmp354__length1 = 0;
																			_tmp337_ = g_new0 (gchar, 0);
																			png_bytes = _tmp337_;
																			png_bytes_length1 = 0;
																			_png_bytes_size_ = png_bytes_length1;
																			_tmp338_ = input_stream;
																			_tmp339_ = tarot_read_input (_tmp338_);
																			_tmp340_ = _tmp339_;
																			_tmp341_ = width;
																			_tmp342_ = height;
																			_tmp345_ = tarot_run_render (_tmp340_, _tmp341_, _tmp342_, &_tmp343_, &_tmp344_);
																			png_bytes = (g_free (png_bytes), NULL);
																			png_bytes = _tmp343_;
																			png_bytes_length1 = _tmp344_;
																			_png_bytes_size_ = png_bytes_length1;
																			ret = _tmp345_;
																			_g_free0 (_tmp340_);
																			_tmp346_ = stdout;
																			str = _tmp346_;
																			_tmp347_ = output_resource;
																			if (_tmp347_ != NULL) {
																				const gchar* _tmp348_ = NULL;
																				FILE* _tmp349_ = NULL;
																				FILE* _tmp350_ = NULL;
																				FILE* _tmp353_ = NULL;
																				_tmp348_ = output_resource;
																				_tmp349_ = g_fopen (_tmp348_, "w");
																				_fclose0 (file_str);
																				file_str = _tmp349_;
																				_tmp350_ = file_str;
																				if (_tmp350_ == NULL) {
																					FILE* _tmp351_ = NULL;
																					const gchar* _tmp352_ = NULL;
																					_tmp351_ = stderr;
																					_tmp352_ = output_resource;
																					fprintf (_tmp351_, "Could not open file %s.\n", _tmp352_);
																					abort ();
																				}
																				_tmp353_ = file_str;
																				str = _tmp353_;
																			}
																			_tmp354_ = png_bytes;
																			_tmp354__length1 = png_bytes_length1;
																			{
																				gchar* c_collection = NULL;
																				gint c_collection_length1 = 0;
																				gint _c_collection_size_ = 0;
																				gint c_it = 0;
																				c_collection = _tmp354_;
																				c_collection_length1 = _tmp354__length1;
																				for (c_it = 0; c_it < _tmp354__length1; c_it = c_it + 1) {
																					gchar c = '\0';
																					c = c_collection[c_it];
																					{
																						FILE* _tmp355_ = NULL;
																						gchar _tmp356_ = '\0';
																						_tmp355_ = str;
																						_tmp356_ = c;
																						fputc (_tmp356_, _tmp355_);
																					}
																				}
																			}
																			_fclose0 (file_str);
																			png_bytes = (g_free (png_bytes), NULL);
																		} else {
																			gboolean _tmp357_ = FALSE;
																			_tmp357_ = has_dbus_server;
																			if (_tmp357_) {
																				Block5Data* _data5_;
																				gchar* _tmp358_ = NULL;
																				gboolean _tmp359_ = FALSE;
																				GMainLoop* _tmp378_ = NULL;
																				GMainLoop* _tmp379_ = NULL;
																				_data5_ = g_slice_new0 (Block5Data);
																				_data5_->_ref_count_ = 1;
																				ret = 0;
																				_tmp358_ = g_strdup ("/eu/planete_kraus/Tarot/Server/v1");
																				_data5_->main_object_name = _tmp358_;
																				_tmp359_ = has_anonymous_dbus;
																				if (!_tmp359_) {
																					const gchar* _tmp360_ = NULL;
																					_tmp360_ = server_bus_name;
																					g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, _tmp360_, G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((_______________________lambda9__gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _______________________lambda9__gbus_acquired_callback, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
																				} else {
																					{
																						GDBusConnection* conn = NULL;
																						GDBusConnection* _tmp361_ = NULL;
																						FILE* _tmp363_ = NULL;
																						GDBusConnection* _tmp364_ = NULL;
																						const gchar* _tmp365_ = NULL;
																						const gchar* _tmp366_ = NULL;
																						FILE* _tmp367_ = NULL;
																						GDBusConnection* _tmp368_ = NULL;
																						const gchar* _tmp369_ = NULL;
																						GDBusConnection* _tmp370_ = NULL;
																						TarotServer* _tmp371_ = NULL;
																						TarotServer* _tmp372_ = NULL;
																						_tmp361_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error_);
																						conn = _tmp361_;
																						if (G_UNLIKELY (_inner_error_ != NULL)) {
																							gint _tmp362_ = 0;
																							if (_inner_error_->domain == G_IO_ERROR) {
																								goto __catch2_g_io_error;
																							}
																							block5_data_unref (_data5_);
																							_data5_ = NULL;
																							_fclose0 (file_input_stream);
																							_g_free0 (actual_output);
																							_g_free0 (doc);
																							options = (g_free (options), NULL);
																							_g_free0 (has_dbus_mcts);
																							_g_free0 (server_bus_name);
																							_g_free0 (default_server_bus_name);
																							_g_free0 (has_play);
																							_g_free0 (has_handful);
																							_g_free0 (has_discard);
																							_g_free0 (has_dog);
																							_g_free0 (has_call);
																							_g_free0 (has_decl);
																							_g_free0 (has_bid);
																							_g_free0 (has_deal_all);
																							_g_free0 (has_deal_to);
																							_g_free0 (input_resource);
																							_g_free0 (output_resource);
																							_g_free0 (seed);
																							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
																							g_clear_error (&_inner_error_);
																							return _tmp362_;
																						}
																						_tmp363_ = stdout;
																						_tmp364_ = conn;
																						_tmp365_ = g_dbus_connection_get_unique_name (_tmp364_);
																						_tmp366_ = _tmp365_;
																						fprintf (_tmp363_, "%s\n", _tmp366_);
																						_tmp367_ = stdout;
																						fflush (_tmp367_);
																						_tmp368_ = conn;
																						_tmp369_ = _data5_->main_object_name;
																						_tmp370_ = conn;
																						_tmp371_ = tarot_server_new (_tmp370_);
																						_tmp372_ = _tmp371_;
																						tarot_server_register_object (_tmp372_, _tmp368_, _tmp369_, &_inner_error_);
																						_g_object_unref0 (_tmp372_);
																						if (G_UNLIKELY (_inner_error_ != NULL)) {
																							gint _tmp373_ = 0;
																							_g_object_unref0 (conn);
																							if (_inner_error_->domain == G_IO_ERROR) {
																								goto __catch2_g_io_error;
																							}
																							_g_object_unref0 (conn);
																							block5_data_unref (_data5_);
																							_data5_ = NULL;
																							_fclose0 (file_input_stream);
																							_g_free0 (actual_output);
																							_g_free0 (doc);
																							options = (g_free (options), NULL);
																							_g_free0 (has_dbus_mcts);
																							_g_free0 (server_bus_name);
																							_g_free0 (default_server_bus_name);
																							_g_free0 (has_play);
																							_g_free0 (has_handful);
																							_g_free0 (has_discard);
																							_g_free0 (has_dog);
																							_g_free0 (has_call);
																							_g_free0 (has_decl);
																							_g_free0 (has_bid);
																							_g_free0 (has_deal_all);
																							_g_free0 (has_deal_to);
																							_g_free0 (input_resource);
																							_g_free0 (output_resource);
																							_g_free0 (seed);
																							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
																							g_clear_error (&_inner_error_);
																							return _tmp373_;
																						}
																						_g_object_unref0 (conn);
																					}
																					goto __finally2;
																					__catch2_g_io_error:
																					{
																						GError* e = NULL;
																						FILE* _tmp374_ = NULL;
																						const gchar* _tmp375_ = NULL;
																						const gchar* _tmp376_ = NULL;
																						e = _inner_error_;
																						_inner_error_ = NULL;
																						_tmp374_ = stderr;
																						_tmp375_ = _ ("Could not register the D-Bus server, sorry: %s.\n");
																						_tmp376_ = e->message;
																						fprintf (_tmp374_, _tmp375_, _tmp376_);
																						exit (1);
																						_g_error_free0 (e);
																					}
																					__finally2:
																					if (G_UNLIKELY (_inner_error_ != NULL)) {
																						gint _tmp377_ = 0;
																						block5_data_unref (_data5_);
																						_data5_ = NULL;
																						_fclose0 (file_input_stream);
																						_g_free0 (actual_output);
																						_g_free0 (doc);
																						options = (g_free (options), NULL);
																						_g_free0 (has_dbus_mcts);
																						_g_free0 (server_bus_name);
																						_g_free0 (default_server_bus_name);
																						_g_free0 (has_play);
																						_g_free0 (has_handful);
																						_g_free0 (has_discard);
																						_g_free0 (has_dog);
																						_g_free0 (has_call);
																						_g_free0 (has_decl);
																						_g_free0 (has_bid);
																						_g_free0 (has_deal_all);
																						_g_free0 (has_deal_to);
																						_g_free0 (input_resource);
																						_g_free0 (output_resource);
																						_g_free0 (seed);
																						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
																						g_clear_error (&_inner_error_);
																						return _tmp377_;
																					}
																				}
																				_tmp378_ = g_main_loop_new (NULL, FALSE);
																				_tmp379_ = _tmp378_;
																				g_main_loop_run (_tmp379_);
																				_g_main_loop_unref0 (_tmp379_);
																				result = ret;
																				block5_data_unref (_data5_);
																				_data5_ = NULL;
																				_fclose0 (file_input_stream);
																				_g_free0 (actual_output);
																				_g_free0 (doc);
																				options = (g_free (options), NULL);
																				_g_free0 (has_dbus_mcts);
																				_g_free0 (server_bus_name);
																				_g_free0 (default_server_bus_name);
																				_g_free0 (has_play);
																				_g_free0 (has_handful);
																				_g_free0 (has_discard);
																				_g_free0 (has_dog);
																				_g_free0 (has_call);
																				_g_free0 (has_decl);
																				_g_free0 (has_bid);
																				_g_free0 (has_deal_all);
																				_g_free0 (has_deal_to);
																				_g_free0 (input_resource);
																				_g_free0 (output_resource);
																				_g_free0 (seed);
																				return result;
																			} else {
																				const gchar* _tmp380_ = NULL;
																				_tmp380_ = has_dbus_mcts;
																				if (_tmp380_ != NULL) {
																					Block6Data* _data6_;
																					TarotMctsGame* mcts = NULL;
																					TarotSeat* seat = NULL;
																					GMainLoop* _tmp381_ = NULL;
																					GMainLoop* _tmp412_ = NULL;
																					_data6_ = g_slice_new0 (Block6Data);
																					_data6_->_ref_count_ = 1;
																					mcts = NULL;
																					seat = NULL;
																					_tmp381_ = g_main_loop_new (NULL, FALSE);
																					_data6_->loop = _tmp381_;
																					{
																						TarotSeat* _tmp382_ = NULL;
																						const gchar* _tmp383_ = NULL;
																						const gchar* _tmp384_ = NULL;
																						TarotSeat* _tmp385_ = NULL;
																						TarotSeat* _tmp387_ = NULL;
																						TarotSeat* _tmp388_ = NULL;
																						TarotMctsGame* _tmp389_ = NULL;
																						TarotMctsParams _tmp390_ = {0};
																						const gchar* _tmp391_ = NULL;
																						TarotMctsGame* _tmp396_ = NULL;
																						TarotMctsParams _tmp397_ = {0};
																						gsize _tmp398_ = 0UL;
																						TarotMctsGame* _tmp399_ = NULL;
																						TarotMctsParams _tmp400_ = {0};
																						gdouble _tmp401_ = 0.0;
																						TarotMctsGame* _tmp402_ = NULL;
																						TarotMctsParams _tmp403_ = {0};
																						gdouble _tmp404_ = 0.0;
																						TarotMctsGame* _tmp405_ = NULL;
																						TarotMctsParams _tmp406_ = {0};
																						gdouble _tmp407_ = 0.0;
																						TarotMctsGame* _tmp408_ = NULL;
																						_tmp383_ = server_bus_name;
																						_tmp384_ = has_dbus_mcts;
																						_tmp385_ = g_initable_new (TAROT_TYPE_SEAT_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", _tmp383_, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", _tmp384_, "g-interface-name", "eu.planete_kraus.Tarot.Seat", "g-interface-info", g_type_get_qdata (TAROT_TYPE_SEAT, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
																						_tmp382_ = (TarotSeat*) _tmp385_;
																						if (G_UNLIKELY (_inner_error_ != NULL)) {
																							gint _tmp386_ = 0;
																							if (_inner_error_->domain == G_IO_ERROR) {
																								goto __catch3_g_io_error;
																							}
																							_g_object_unref0 (seat);
																							_g_object_unref0 (mcts);
																							block6_data_unref (_data6_);
																							_data6_ = NULL;
																							_fclose0 (file_input_stream);
																							_g_free0 (actual_output);
																							_g_free0 (doc);
																							options = (g_free (options), NULL);
																							_g_free0 (has_dbus_mcts);
																							_g_free0 (server_bus_name);
																							_g_free0 (default_server_bus_name);
																							_g_free0 (has_play);
																							_g_free0 (has_handful);
																							_g_free0 (has_discard);
																							_g_free0 (has_dog);
																							_g_free0 (has_call);
																							_g_free0 (has_decl);
																							_g_free0 (has_bid);
																							_g_free0 (has_deal_all);
																							_g_free0 (has_deal_to);
																							_g_free0 (input_resource);
																							_g_free0 (output_resource);
																							_g_free0 (seed);
																							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
																							g_clear_error (&_inner_error_);
																							return _tmp386_;
																						}
																						_tmp387_ = _tmp382_;
																						_tmp382_ = NULL;
																						_g_object_unref0 (seat);
																						seat = _tmp387_;
																						_tmp388_ = seat;
																						_tmp389_ = tarot_mcts_game_new (_tmp388_);
																						_g_object_unref0 (mcts);
																						mcts = _tmp389_;
																						_tmp390_ = mparams;
																						_tmp391_ = _tmp390_.seed;
																						if (_tmp391_ != NULL) {
																							TarotMctsGame* _tmp392_ = NULL;
																							TarotMctsParams _tmp393_ = {0};
																							const gchar* _tmp394_ = NULL;
																							gchar* _tmp395_ = NULL;
																							_tmp392_ = mcts;
																							_tmp393_ = mparams;
																							_tmp394_ = _tmp393_.seed;
																							_tmp395_ = g_strdup (_tmp394_);
																							_g_free0 (_tmp392_->seed);
																							_tmp392_->seed = _tmp395_;
																						}
																						_tmp396_ = mcts;
																						_tmp397_ = mparams;
																						_tmp398_ = _tmp397_.n_iterations;
																						_tmp396_->n_iterations = _tmp398_;
																						_tmp399_ = mcts;
																						_tmp400_ = mparams;
																						_tmp401_ = _tmp400_.parameter;
																						tarot_mcts_game_set_parameter (_tmp399_, _tmp401_);
																						_tmp402_ = mcts;
																						_tmp403_ = mparams;
																						_tmp404_ = _tmp403_.simulation_agreed;
																						tarot_mcts_game_set_simulation_agreed (_tmp402_, _tmp404_);
																						_tmp405_ = mcts;
																						_tmp406_ = mparams;
																						_tmp407_ = _tmp406_.simulation_random;
																						tarot_mcts_game_set_simulation_random (_tmp405_, _tmp407_);
																						_tmp408_ = mcts;
																						g_signal_connect_data (_tmp408_, "finished", (GCallback) ________________________lambda39__tarot_mcts_game_finished, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
																						_g_object_unref0 (_tmp382_);
																					}
																					goto __finally3;
																					__catch3_g_io_error:
																					{
																						GError* e = NULL;
																						FILE* _tmp409_ = NULL;
																						const gchar* _tmp410_ = NULL;
																						e = _inner_error_;
																						_inner_error_ = NULL;
																						_tmp409_ = stderr;
																						_tmp410_ = e->message;
																						fprintf (_tmp409_, "DBus error: %s\n", _tmp410_);
																						exit (1);
																						_g_error_free0 (e);
																					}
																					__finally3:
																					if (G_UNLIKELY (_inner_error_ != NULL)) {
																						gint _tmp411_ = 0;
																						_g_object_unref0 (seat);
																						_g_object_unref0 (mcts);
																						block6_data_unref (_data6_);
																						_data6_ = NULL;
																						_fclose0 (file_input_stream);
																						_g_free0 (actual_output);
																						_g_free0 (doc);
																						options = (g_free (options), NULL);
																						_g_free0 (has_dbus_mcts);
																						_g_free0 (server_bus_name);
																						_g_free0 (default_server_bus_name);
																						_g_free0 (has_play);
																						_g_free0 (has_handful);
																						_g_free0 (has_discard);
																						_g_free0 (has_dog);
																						_g_free0 (has_call);
																						_g_free0 (has_decl);
																						_g_free0 (has_bid);
																						_g_free0 (has_deal_all);
																						_g_free0 (has_deal_to);
																						_g_free0 (input_resource);
																						_g_free0 (output_resource);
																						_g_free0 (seed);
																						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
																						g_clear_error (&_inner_error_);
																						return _tmp411_;
																					}
																					_tmp412_ = _data6_->loop;
																					g_main_loop_run (_tmp412_);
																					result = 0;
																					_g_object_unref0 (seat);
																					_g_object_unref0 (mcts);
																					block6_data_unref (_data6_);
																					_data6_ = NULL;
																					_fclose0 (file_input_stream);
																					_g_free0 (actual_output);
																					_g_free0 (doc);
																					options = (g_free (options), NULL);
																					_g_free0 (has_dbus_mcts);
																					_g_free0 (server_bus_name);
																					_g_free0 (default_server_bus_name);
																					_g_free0 (has_play);
																					_g_free0 (has_handful);
																					_g_free0 (has_discard);
																					_g_free0 (has_dog);
																					_g_free0 (has_call);
																					_g_free0 (has_decl);
																					_g_free0 (has_bid);
																					_g_free0 (has_deal_all);
																					_g_free0 (has_deal_to);
																					_g_free0 (input_resource);
																					_g_free0 (output_resource);
																					_g_free0 (seed);
																					return result;
																				} else {
																					gchar* seed_now = NULL;
																					GDateTime* _tmp413_ = NULL;
																					GDateTime* _tmp414_ = NULL;
																					gchar* _tmp415_ = NULL;
																					gchar* _tmp416_ = NULL;
																					TarotMctsParams _tmp417_ = {0};
																					const gchar* _tmp418_ = NULL;
																					gint _tmp420_ = 0;
																					gboolean _tmp421_ = FALSE;
																					TarotMctsParams _tmp422_ = {0};
																					gint _tmp423_ = 0;
																					gboolean _tmp424_ = FALSE;
																					gchar* _tmp425_ = NULL;
																					gint _tmp426_ = 0;
																					_tmp413_ = g_date_time_new_now_utc ();
																					_tmp414_ = _tmp413_;
																					_tmp415_ = g_date_time_to_string (_tmp414_);
																					_tmp416_ = _tmp415_;
																					_g_date_time_unref0 (_tmp414_);
																					seed_now = _tmp416_;
																					_tmp417_ = mparams;
																					_tmp418_ = _tmp417_.seed;
																					if (_tmp418_ == NULL) {
																						const gchar* _tmp419_ = NULL;
																						_tmp419_ = seed_now;
																						mparams.seed = _tmp419_;
																					}
																					_tmp420_ = n_players;
																					_tmp421_ = call_allowed;
																					_tmp422_ = mparams;
																					_tmp423_ = retry;
																					_tmp424_ = no_window;
																					_tmp426_ = tarot_run_interactive ((gsize) _tmp420_, _tmp421_, &_tmp422_, _tmp423_, _tmp424_, &_tmp425_);
																					_g_free0 (actual_output);
																					actual_output = _tmp425_;
																					ret = _tmp426_;
																					_g_free0 (actual_output);
																					actual_output = NULL;
																					_g_free0 (seed_now);
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	tarot_quit ();
	_tmp428_ = ret;
	if (_tmp428_ == 0) {
		const gchar* _tmp429_ = NULL;
		_tmp429_ = actual_output;
		_tmp427_ = _tmp429_ != NULL;
	} else {
		_tmp427_ = FALSE;
	}
	if (_tmp427_) {
		FILE* str = NULL;
		FILE* _tmp430_ = NULL;
		FILE* file_str = NULL;
		const gchar* _tmp431_ = NULL;
		FILE* _tmp438_ = NULL;
		const gchar* _tmp439_ = NULL;
		_tmp430_ = stdout;
		str = _tmp430_;
		_tmp431_ = output_resource;
		if (_tmp431_ != NULL) {
			const gchar* _tmp432_ = NULL;
			FILE* _tmp433_ = NULL;
			FILE* _tmp434_ = NULL;
			FILE* _tmp437_ = NULL;
			_tmp432_ = output_resource;
			_tmp433_ = g_fopen (_tmp432_, "w");
			_fclose0 (file_str);
			file_str = _tmp433_;
			_tmp434_ = file_str;
			if (_tmp434_ == NULL) {
				FILE* _tmp435_ = NULL;
				const gchar* _tmp436_ = NULL;
				_tmp435_ = stderr;
				_tmp436_ = output_resource;
				fprintf (_tmp435_, "Could not open file %s.\n", _tmp436_);
				abort ();
			}
			_tmp437_ = file_str;
			str = _tmp437_;
		}
		_tmp438_ = str;
		_tmp439_ = actual_output;
		tarot_write_output (_tmp438_, _tmp439_);
		_fclose0 (file_str);
	}
	result = ret;
	_fclose0 (file_input_stream);
	_g_free0 (actual_output);
	_g_free0 (doc);
	options = (g_free (options), NULL);
	_g_free0 (has_dbus_mcts);
	_g_free0 (server_bus_name);
	_g_free0 (default_server_bus_name);
	_g_free0 (has_play);
	_g_free0 (has_handful);
	_g_free0 (has_discard);
	_g_free0 (has_dog);
	_g_free0 (has_call);
	_g_free0 (has_decl);
	_g_free0 (has_bid);
	_g_free0 (has_deal_all);
	_g_free0 (has_deal_to);
	_g_free0 (input_resource);
	_g_free0 (output_resource);
	_g_free0 (seed);
	return result;
}


int main (int argc, char ** argv) {
#if !GLIB_CHECK_VERSION (2,35,0)
	g_type_init ();
#endif
	return tarot_main (argv, argc);
}



