#include <config.h>
/* mcts.c generated by valac 0.34.7, the Vala compiler
 * generated from mcts.vala, do not modify */

/* mcts.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "tarot-gobject.h"
#include <stdio.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define TAROT_TYPE_MCTS_GAME (tarot_mcts_game_get_type ())
#define TAROT_MCTS_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_MCTS_GAME, TarotMctsGame))
#define TAROT_MCTS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_MCTS_GAME, TarotMctsGameClass))
#define TAROT_IS_MCTS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_MCTS_GAME))
#define TAROT_IS_MCTS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_MCTS_GAME))
#define TAROT_MCTS_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_MCTS_GAME, TarotMctsGameClass))

typedef struct _TarotMctsGame TarotMctsGame;
typedef struct _TarotMctsGameClass TarotMctsGameClass;
typedef struct _TarotMctsGamePrivate TarotMctsGamePrivate;
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))
#define __vala_TarotMcts_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotMcts_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TAROT_TYPE_SEAT (tarot_seat_get_type ())
#define TAROT_SEAT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_SEAT, TarotSeat))
#define TAROT_IS_SEAT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_SEAT))
#define TAROT_SEAT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TAROT_TYPE_SEAT, TarotSeatIface))

typedef struct _TarotSeat TarotSeat;
typedef struct _TarotSeatIface TarotSeatIface;

#define TAROT_TYPE_SEAT_PROXY (tarot_seat_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define __vala_TarotGameEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameEvent_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotMctsGame {
	GObject parent_instance;
	TarotMctsGamePrivate * priv;
	gchar* seed;
	gsize n_iterations;
};

struct _TarotMctsGameClass {
	GObjectClass parent_class;
};

struct _TarotMctsGamePrivate {
	TarotGame* m_game;
	TarotMcts* m_mcts;
	gboolean subscribed;
};

typedef enum  {
	TAROT_SERVER_ERROR_INVALID_EVENT,
	TAROT_SERVER_ERROR_INTERNAL_SERVER_ERROR
} TarotServerError;
#define TAROT_SERVER_ERROR tarot_server_error_quark ()
struct _TarotSeatIface {
	GTypeInterface parent_iface;
	guint (*me) (TarotSeat* self, GError** error);
	void (*subscribe) (TarotSeat* self, GError** error);
	void (*bid) (TarotSeat* self, guint bid, GError** error);
	void (*declare) (TarotSeat* self, gboolean slam, GError** error);
	void (*call) (TarotSeat* self, guint card, GError** error);
	void (*discard) (TarotSeat* self, guint* cards, int cards_length1, GError** error);
	void (*handful) (TarotSeat* self, guint* cards, int cards_length1, GError** error);
	void (*play) (TarotSeat* self, guint card, GError** error);
};

struct _Block8Data {
	int _ref_count_;
	TarotMctsGame* self;
	TarotSeat* seat;
};


static gpointer tarot_mcts_game_parent_class = NULL;

GType tarot_mcts_game_get_type (void) G_GNUC_CONST;
#define TAROT_MCTS_GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TAROT_TYPE_MCTS_GAME, TarotMctsGamePrivate))
enum  {
	TAROT_MCTS_GAME_DUMMY_PROPERTY,
	TAROT_MCTS_GAME_PARAMETER,
	TAROT_MCTS_GAME_SIMULATION_AGREED,
	TAROT_MCTS_GAME_SIMULATION_RANDOM
};
static void _vala_TarotGame_free (TarotGame* self);
static void _vala_TarotMcts_free (TarotMcts* self);
static TarotCard* tarot_mcts_game_to_cards (guint* cards, int cards_length1, int* result_length1);
static void tarot_mcts_game_add_event_or_fail (TarotMctsGame* self, TarotGameEvent* e);
static TarotGameError tarot_mcts_game_add_event (TarotMctsGame* self, TarotGameEvent* e);
const gchar* tarot_game_event_t_to_string (TarotGameEventT self);
GType tarot_seat_proxy_get_type (void) G_GNUC_CONST;
guint tarot_seat_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GQuark tarot_server_error_quark (void);
GType tarot_seat_get_type (void) G_GNUC_CONST;
TarotMctsGame* tarot_mcts_game_new (TarotSeat* seat);
TarotMctsGame* tarot_mcts_game_construct (GType object_type, TarotSeat* seat);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda22_ (TarotMctsGame* self, guint n_players, gboolean with_call);
static void _vala_TarotGameEvent_free (TarotGameEvent* self);
static void ___lambda22__tarot_seat_event_setup (TarotSeat* _sender, guint n_players, gboolean with_call, gpointer self);
static void __lambda23_ (Block8Data* _data8_, guint* icards, int icards_length1);
guint tarot_seat_me (TarotSeat* self, GError** error);
static void ___lambda23__tarot_seat_event_deal (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda24_ (TarotMctsGame* self, guint bid);
static void ___lambda24__tarot_seat_event_bid (TarotSeat* _sender, guint bid, gpointer self);
static void __lambda25_ (TarotMctsGame* self, gboolean decl);
static void ___lambda25__tarot_seat_event_decl (TarotSeat* _sender, gboolean decl, gpointer self);
static void __lambda26_ (TarotMctsGame* self, guint call);
static void ___lambda26__tarot_seat_event_call (TarotSeat* _sender, guint card, gpointer self);
static void __lambda27_ (TarotMctsGame* self, guint* icards, int icards_length1);
static void ___lambda27__tarot_seat_event_dog (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda28_ (TarotMctsGame* self, guint* icards, int icards_length1);
static void ___lambda28__tarot_seat_event_discard (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda29_ (TarotMctsGame* self, guint* icards, int icards_length1);
static void ___lambda29__tarot_seat_event_handful (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda30_ (TarotMctsGame* self, guint card);
static void ___lambda30__tarot_seat_event_play (TarotSeat* _sender, guint card, gpointer self);
static void __lambda31_ (TarotMctsGame* self);
void tarot_mcts_game_next (TarotMctsGame* self);
static void ___lambda31__tarot_seat_next (TarotSeat* _sender, gpointer self);
static void __lambda32_ (Block8Data* _data8_, gint* scores, int scores_length1);
static void ___lambda32__tarot_seat_end (TarotSeat* _sender, gint* scores, int scores_length1, gpointer self);
static void __lambda33_ (Block8Data* _data8_, guint bid);
void tarot_seat_bid (TarotSeat* self, guint bid, GError** error);
static void ___lambda33__tarot_mcts_game_event_bid (TarotMctsGame* _sender, guint bid, gpointer self);
static void __lambda34_ (Block8Data* _data8_, gboolean decl);
void tarot_seat_declare (TarotSeat* self, gboolean slam, GError** error);
static void ___lambda34__tarot_mcts_game_event_decl (TarotMctsGame* _sender, gboolean decl, gpointer self);
static void __lambda35_ (Block8Data* _data8_, guint card);
void tarot_seat_call (TarotSeat* self, guint card, GError** error);
static void ___lambda35__tarot_mcts_game_event_call (TarotMctsGame* _sender, guint card, gpointer self);
static void __lambda36_ (Block8Data* _data8_, guint* cards, int cards_length1);
void tarot_seat_discard (TarotSeat* self, guint* cards, int cards_length1, GError** error);
static void ___lambda36__tarot_mcts_game_event_discard (TarotMctsGame* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda37_ (Block8Data* _data8_, guint* cards, int cards_length1);
void tarot_seat_handful (TarotSeat* self, guint* cards, int cards_length1, GError** error);
static void ___lambda37__tarot_mcts_game_event_handful (TarotMctsGame* _sender, guint* cards, int cards_length1, gpointer self);
static void __lambda38_ (Block8Data* _data8_, guint card);
void tarot_seat_play (TarotSeat* self, guint card, GError** error);
static void ___lambda38__tarot_mcts_game_event_play (TarotMctsGame* _sender, guint card, gpointer self);
void tarot_seat_subscribe (TarotSeat* self, GError** error);
static TarotGameEvent* _vala_TarotGameEvent_copy (TarotGameEvent* self);
gdouble tarot_mcts_game_get_parameter (TarotMctsGame* self);
void tarot_mcts_game_set_parameter (TarotMctsGame* self, gdouble value);
gdouble tarot_mcts_game_get_simulation_agreed (TarotMctsGame* self);
void tarot_mcts_game_set_simulation_agreed (TarotMctsGame* self, gdouble value);
gdouble tarot_mcts_game_get_simulation_random (TarotMctsGame* self);
void tarot_mcts_game_set_simulation_random (TarotMctsGame* self, gdouble value);
static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void tarot_mcts_game_finalize (GObject* obj);
static void _vala_tarot_mcts_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tarot_mcts_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _vala_TarotGame_free (TarotGame* self) {
	g_boxed_free (tarot_game_get_type (), self);
}


static void _vala_TarotMcts_free (TarotMcts* self) {
	g_boxed_free (tarot_mcts_get_type (), self);
}


static TarotCard* tarot_mcts_game_to_cards (guint* cards, int cards_length1, int* result_length1) {
	TarotCard* result = NULL;
	TarotCard* ret = NULL;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	TarotCard* _tmp1_ = NULL;
	gint ret_length1 = 0;
	gint _ret_size_ = 0;
	TarotCard* _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	_tmp0_ = cards;
	_tmp0__length1 = cards_length1;
	_tmp1_ = g_new0 (TarotCard, _tmp0__length1);
	ret = _tmp1_;
	ret_length1 = _tmp0__length1;
	_ret_size_ = ret_length1;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gsize _tmp4_ = 0UL;
				guint* _tmp5_ = NULL;
				gint _tmp5__length1 = 0;
				TarotCard* _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gsize _tmp7_ = 0UL;
				guint* _tmp8_ = NULL;
				gint _tmp8__length1 = 0;
				gsize _tmp9_ = 0UL;
				guint _tmp10_ = 0U;
				TarotCard _tmp11_ = 0U;
				if (!_tmp2_) {
					gsize _tmp3_ = 0UL;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = cards;
				_tmp5__length1 = cards_length1;
				if (!(_tmp4_ < ((gsize) _tmp5__length1))) {
					break;
				}
				_tmp6_ = ret;
				_tmp6__length1 = ret_length1;
				_tmp7_ = i;
				_tmp8_ = cards;
				_tmp8__length1 = cards_length1;
				_tmp9_ = i;
				_tmp10_ = _tmp8_[_tmp9_];
				_tmp6_[_tmp7_] = (TarotCard) _tmp10_;
				_tmp11_ = _tmp6_[_tmp7_];
			}
		}
	}
	_tmp12_ = ret;
	_tmp12__length1 = ret_length1;
	if (result_length1) {
		*result_length1 = _tmp12__length1;
	}
	result = _tmp12_;
	return result;
}


static void tarot_mcts_game_add_event_or_fail (TarotMctsGame* self, TarotGameEvent* e) {
	TarotGameEvent* _tmp0_ = NULL;
	TarotGameError _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	_tmp0_ = e;
	_tmp1_ = tarot_mcts_game_add_event (self, _tmp0_);
	if (_tmp1_ != TAROT_GAME_OK) {
		FILE* _tmp2_ = NULL;
		TarotGameEvent* _tmp3_ = NULL;
		TarotGameEventT _tmp4_ = 0;
		GEnumValue* _tmp5_;
		_tmp2_ = stderr;
		_tmp3_ = e;
		_tmp4_ = tarot_game_event_type (_tmp3_);
		_tmp5_ = g_enum_get_value (g_type_class_ref (tarot_game_event_t_get_type ()), _tmp4_);
		fprintf (_tmp2_, "Invalid server event: %s.\n", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
		abort ();
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block8Data* block8_data_ref (Block8Data* _data8_) {
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		TarotMctsGame* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->seat);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}


static void _vala_TarotGameEvent_free (TarotGameEvent* self) {
	g_boxed_free (tarot_game_event_get_type (), self);
}


static void __lambda22_ (TarotMctsGame* self, guint n_players, gboolean with_call) {
	TarotGameEvent* e = NULL;
	guint _tmp0_ = 0U;
	gboolean _tmp1_ = FALSE;
	TarotGameEvent* _tmp2_ = NULL;
	_tmp0_ = n_players;
	_tmp1_ = with_call;
	_tmp2_ = tarot_game_event_alloc_setup ((gsize) _tmp0_, _tmp1_);
	e = _tmp2_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda22__tarot_seat_event_setup (TarotSeat* _sender, guint n_players, gboolean with_call, gpointer self) {
	__lambda22_ ((TarotMctsGame*) self, n_players, with_call);
}


static void __lambda23_ (Block8Data* _data8_, guint* icards, int icards_length1) {
	TarotMctsGame* self;
	TarotPlayer me = 0U;
	TarotGameEvent* e = NULL;
	TarotPlayer _tmp7_ = 0U;
	guint* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gint _tmp9_ = 0;
	TarotCard* _tmp10_ = NULL;
	TarotCard* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	TarotGameEvent* _tmp12_ = NULL;
	TarotGameEvent* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	me = (TarotPlayer) 0;
	{
		guint _tmp0_ = 0U;
		TarotSeat* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = _data8_->seat;
		_tmp2_ = tarot_seat_me (_tmp1_, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		me = (TarotPlayer) _tmp0_;
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		FILE* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = _ ("Could not get my player number: %s\n");
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp3_, _tmp4_, _tmp6_);
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp7_ = me;
	_tmp8_ = icards;
	_tmp8__length1 = icards_length1;
	_tmp10_ = tarot_mcts_game_to_cards (_tmp8_, _tmp8__length1, &_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _tmp9_;
	_tmp12_ = tarot_game_event_alloc_deal (_tmp7_, _tmp9_, _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp11_ = (g_free (_tmp11_), NULL);
	e = _tmp13_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda23__tarot_seat_event_deal (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda23_ (self, cards, cards_length1);
}


static void __lambda24_ (TarotMctsGame* self, guint bid) {
	TarotGameEvent* e = NULL;
	guint _tmp0_ = 0U;
	TarotGameEvent* _tmp1_ = NULL;
	_tmp0_ = bid;
	_tmp1_ = tarot_game_event_alloc_bid ((TarotBid) _tmp0_);
	e = _tmp1_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda24__tarot_seat_event_bid (TarotSeat* _sender, guint bid, gpointer self) {
	__lambda24_ ((TarotMctsGame*) self, bid);
}


static void __lambda25_ (TarotMctsGame* self, gboolean decl) {
	TarotGameEvent* e = NULL;
	gboolean _tmp0_ = FALSE;
	TarotGameEvent* _tmp1_ = NULL;
	_tmp0_ = decl;
	_tmp1_ = tarot_game_event_alloc_decl (_tmp0_);
	e = _tmp1_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda25__tarot_seat_event_decl (TarotSeat* _sender, gboolean decl, gpointer self) {
	__lambda25_ ((TarotMctsGame*) self, decl);
}


static void __lambda26_ (TarotMctsGame* self, guint call) {
	TarotGameEvent* e = NULL;
	guint _tmp0_ = 0U;
	TarotGameEvent* _tmp1_ = NULL;
	_tmp0_ = call;
	_tmp1_ = tarot_game_event_alloc_call ((TarotCard) _tmp0_);
	e = _tmp1_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda26__tarot_seat_event_call (TarotSeat* _sender, guint card, gpointer self) {
	__lambda26_ ((TarotMctsGame*) self, card);
}


static void __lambda27_ (TarotMctsGame* self, guint* icards, int icards_length1) {
	TarotGameEvent* e = NULL;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_ = NULL;
	TarotCard* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	TarotGameEvent* _tmp4_ = NULL;
	TarotGameEvent* _tmp5_ = NULL;
	_tmp0_ = icards;
	_tmp0__length1 = icards_length1;
	_tmp2_ = tarot_mcts_game_to_cards (_tmp0_, _tmp0__length1, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = tarot_game_event_alloc_dog (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	e = _tmp5_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda27__tarot_seat_event_dog (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda27_ ((TarotMctsGame*) self, cards, cards_length1);
}


static void __lambda28_ (TarotMctsGame* self, guint* icards, int icards_length1) {
	TarotGameEvent* e = NULL;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_ = NULL;
	TarotCard* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	TarotGameEvent* _tmp4_ = NULL;
	TarotGameEvent* _tmp5_ = NULL;
	_tmp0_ = icards;
	_tmp0__length1 = icards_length1;
	_tmp2_ = tarot_mcts_game_to_cards (_tmp0_, _tmp0__length1, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = tarot_game_event_alloc_discard (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	e = _tmp5_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda28__tarot_seat_event_discard (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda28_ ((TarotMctsGame*) self, cards, cards_length1);
}


static void __lambda29_ (TarotMctsGame* self, guint* icards, int icards_length1) {
	TarotGameEvent* e = NULL;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_ = NULL;
	TarotCard* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	TarotGameEvent* _tmp4_ = NULL;
	TarotGameEvent* _tmp5_ = NULL;
	_tmp0_ = icards;
	_tmp0__length1 = icards_length1;
	_tmp2_ = tarot_mcts_game_to_cards (_tmp0_, _tmp0__length1, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = tarot_game_event_alloc_handful (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	e = _tmp5_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda29__tarot_seat_event_handful (TarotSeat* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda29_ ((TarotMctsGame*) self, cards, cards_length1);
}


static void __lambda30_ (TarotMctsGame* self, guint card) {
	TarotGameEvent* e = NULL;
	guint _tmp0_ = 0U;
	TarotGameEvent* _tmp1_ = NULL;
	_tmp0_ = card;
	_tmp1_ = tarot_game_event_alloc_card ((TarotCard) _tmp0_);
	e = _tmp1_;
	tarot_mcts_game_add_event_or_fail (self, e);
	__vala_TarotGameEvent_free0 (e);
}


static void ___lambda30__tarot_seat_event_play (TarotSeat* _sender, guint card, gpointer self) {
	__lambda30_ ((TarotMctsGame*) self, card);
}


static void __lambda31_ (TarotMctsGame* self) {
	tarot_mcts_game_next (self);
}


static void ___lambda31__tarot_seat_next (TarotSeat* _sender, gpointer self) {
	__lambda31_ ((TarotMctsGame*) self);
}


static void __lambda32_ (Block8Data* _data8_, gint* scores, int scores_length1) {
	TarotMctsGame* self;
	guint me = 0U;
	gint* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	guint _tmp8_ = 0U;
	gint _tmp9_ = 0;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	me = (guint) 0;
	{
		guint _tmp0_ = 0U;
		TarotSeat* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = _data8_->seat;
		_tmp2_ = tarot_seat_me (_tmp1_, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
		me = _tmp0_;
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		FILE* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = _ ("Could not get my player number: %s\n");
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp3_, _tmp4_, _tmp6_);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp7_ = scores;
	_tmp7__length1 = scores_length1;
	_tmp8_ = me;
	_tmp9_ = _tmp7_[_tmp8_];
	g_signal_emit_by_name (self, "finished", _tmp9_);
}


static void ___lambda32__tarot_seat_end (TarotSeat* _sender, gint* scores, int scores_length1, gpointer self) {
	__lambda32_ (self, scores, scores_length1);
}


static void __lambda33_ (Block8Data* _data8_, guint bid) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		guint _tmp1_ = 0U;
		_tmp0_ = _data8_->seat;
		_tmp1_ = bid;
		tarot_seat_bid (_tmp0_, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda33__tarot_mcts_game_event_bid (TarotMctsGame* _sender, guint bid, gpointer self) {
	__lambda33_ (self, bid);
}


static void __lambda34_ (Block8Data* _data8_, gboolean decl) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		gboolean _tmp1_ = FALSE;
		_tmp0_ = _data8_->seat;
		_tmp1_ = decl;
		tarot_seat_declare (_tmp0_, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda34__tarot_mcts_game_event_decl (TarotMctsGame* _sender, gboolean decl, gpointer self) {
	__lambda34_ (self, decl);
}


static void __lambda35_ (Block8Data* _data8_, guint card) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		guint _tmp1_ = 0U;
		_tmp0_ = _data8_->seat;
		_tmp1_ = card;
		tarot_seat_call (_tmp0_, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally9:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda35__tarot_mcts_game_event_call (TarotMctsGame* _sender, guint card, gpointer self) {
	__lambda35_ (self, card);
}


static void __lambda36_ (Block8Data* _data8_, guint* cards, int cards_length1) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		guint* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		_tmp0_ = _data8_->seat;
		_tmp1_ = cards;
		_tmp1__length1 = cards_length1;
		tarot_seat_discard (_tmp0_, _tmp1_, _tmp1__length1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch10_g_error;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda36__tarot_mcts_game_event_discard (TarotMctsGame* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda36_ (self, cards, cards_length1);
}


static void __lambda37_ (Block8Data* _data8_, guint* cards, int cards_length1) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		guint* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		_tmp0_ = _data8_->seat;
		_tmp1_ = cards;
		_tmp1__length1 = cards_length1;
		tarot_seat_handful (_tmp0_, _tmp1_, _tmp1__length1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda37__tarot_mcts_game_event_handful (TarotMctsGame* _sender, guint* cards, int cards_length1, gpointer self) {
	__lambda37_ (self, cards, cards_length1);
}


static void __lambda38_ (Block8Data* _data8_, guint card) {
	TarotMctsGame* self;
	GError * _inner_error_ = NULL;
	self = _data8_->self;
	{
		TarotSeat* _tmp0_ = NULL;
		guint _tmp1_ = 0U;
		_tmp0_ = _data8_->seat;
		_tmp1_ = card;
		tarot_seat_play (_tmp0_, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch12_g_error;
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Could not play: %s\n");
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp2_, _tmp3_, _tmp5_);
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda38__tarot_mcts_game_event_play (TarotMctsGame* _sender, guint card, gpointer self) {
	__lambda38_ (self, card);
}


TarotMctsGame* tarot_mcts_game_construct (GType object_type, TarotSeat* seat) {
	TarotMctsGame * self = NULL;
	Block8Data* _data8_;
	TarotSeat* _tmp0_ = NULL;
	TarotSeat* _tmp1_ = NULL;
	TarotGame* _tmp2_ = NULL;
	TarotMcts* _tmp3_ = NULL;
	TarotSeat* _tmp4_ = NULL;
	TarotSeat* _tmp5_ = NULL;
	TarotSeat* _tmp6_ = NULL;
	TarotSeat* _tmp7_ = NULL;
	TarotSeat* _tmp8_ = NULL;
	TarotSeat* _tmp9_ = NULL;
	TarotSeat* _tmp10_ = NULL;
	TarotSeat* _tmp11_ = NULL;
	TarotSeat* _tmp12_ = NULL;
	TarotSeat* _tmp13_ = NULL;
	TarotSeat* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (seat != NULL, NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_tmp0_ = seat;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data8_->seat);
	_data8_->seat = _tmp1_;
	self = (TarotMctsGame*) g_object_new (object_type, NULL);
	_data8_->self = g_object_ref (self);
	_tmp2_ = tarot_game_alloc ();
	__vala_TarotGame_free0 (self->priv->m_game);
	self->priv->m_game = _tmp2_;
	_tmp3_ = tarot_mcts_alloc ((gsize) ((2 * 1024) * 1024));
	__vala_TarotMcts_free0 (self->priv->m_mcts);
	self->priv->m_mcts = _tmp3_;
	_tmp4_ = _data8_->seat;
	g_signal_connect_object (_tmp4_, "event-setup", (GCallback) ___lambda22__tarot_seat_event_setup, self, 0);
	_tmp5_ = _data8_->seat;
	g_signal_connect_data (_tmp5_, "event-deal", (GCallback) ___lambda23__tarot_seat_event_deal, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_tmp6_ = _data8_->seat;
	g_signal_connect_object (_tmp6_, "event-bid", (GCallback) ___lambda24__tarot_seat_event_bid, self, 0);
	_tmp7_ = _data8_->seat;
	g_signal_connect_object (_tmp7_, "event-decl", (GCallback) ___lambda25__tarot_seat_event_decl, self, 0);
	_tmp8_ = _data8_->seat;
	g_signal_connect_object (_tmp8_, "event-call", (GCallback) ___lambda26__tarot_seat_event_call, self, 0);
	_tmp9_ = _data8_->seat;
	g_signal_connect_object (_tmp9_, "event-dog", (GCallback) ___lambda27__tarot_seat_event_dog, self, 0);
	_tmp10_ = _data8_->seat;
	g_signal_connect_object (_tmp10_, "event-discard", (GCallback) ___lambda28__tarot_seat_event_discard, self, 0);
	_tmp11_ = _data8_->seat;
	g_signal_connect_object (_tmp11_, "event-handful", (GCallback) ___lambda29__tarot_seat_event_handful, self, 0);
	_tmp12_ = _data8_->seat;
	g_signal_connect_object (_tmp12_, "event-play", (GCallback) ___lambda30__tarot_seat_event_play, self, 0);
	_tmp13_ = _data8_->seat;
	g_signal_connect_object (_tmp13_, "next", (GCallback) ___lambda31__tarot_seat_next, self, 0);
	_tmp14_ = _data8_->seat;
	g_signal_connect_data (_tmp14_, "end", (GCallback) ___lambda32__tarot_seat_end, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-bid", (GCallback) ___lambda33__tarot_mcts_game_event_bid, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-decl", (GCallback) ___lambda34__tarot_mcts_game_event_decl, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-call", (GCallback) ___lambda35__tarot_mcts_game_event_call, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-discard", (GCallback) ___lambda36__tarot_mcts_game_event_discard, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-handful", (GCallback) ___lambda37__tarot_mcts_game_event_handful, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (self, "event-play", (GCallback) ___lambda38__tarot_mcts_game_event_play, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	{
		TarotSeat* _tmp15_ = NULL;
		self->priv->subscribed = TRUE;
		_tmp15_ = _data8_->seat;
		tarot_seat_subscribe (_tmp15_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch13_g_error;
		}
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError* e = NULL;
		FILE* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = stderr;
		_tmp17_ = _ ("Could not subscribe to the signals: %s\n");
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		fprintf (_tmp16_, _tmp17_, _tmp19_);
		_g_error_free0 (e);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		block8_data_unref (_data8_);
		_data8_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	block8_data_unref (_data8_);
	_data8_ = NULL;
	return self;
}


TarotMctsGame* tarot_mcts_game_new (TarotSeat* seat) {
	return tarot_mcts_game_construct (TAROT_TYPE_MCTS_GAME, seat);
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static TarotGameEvent* _vala_TarotGameEvent_copy (TarotGameEvent* self) {
	return g_boxed_copy (tarot_game_event_get_type (), self);
}


static gpointer __vala_TarotGameEvent_copy0 (gpointer self) {
	return self ? _vala_TarotGameEvent_copy (self) : NULL;
}


void tarot_mcts_game_next (TarotMctsGame* self) {
	gboolean _tmp0_ = FALSE;
	TarotPlayer myself = 0U;
	TarotGame* _tmp1_ = NULL;
	TarotPlayer _tmp2_ = 0U;
	TarotGameError _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->subscribed;
	_vala_assert (_tmp0_, "subscribed");
	_tmp1_ = self->priv->m_game;
	_tmp3_ = tarot_game_get_main_player (_tmp1_, &_tmp2_);
	myself = _tmp2_;
	if (_tmp3_ != TAROT_GAME_OK) {
		TarotGame* _tmp4_ = NULL;
		TarotStep _tmp5_ = 0;
		_tmp4_ = self->priv->m_game;
		_tmp5_ = tarot_game_step (_tmp4_);
		_vala_assert (_tmp5_ == TAROT_SETUP, "m_game.step () == Tarot.Step.SETUP");
	} else {
		TarotPlayer next = 0U;
		TarotGame* _tmp6_ = NULL;
		TarotPlayer _tmp7_ = 0U;
		TarotGameError _tmp8_ = 0;
		_tmp6_ = self->priv->m_game;
		_tmp8_ = tarot_game_get_next (_tmp6_, &_tmp7_);
		next = _tmp7_;
		if (_tmp8_ == TAROT_GAME_OK) {
			TarotPlayer _tmp9_ = 0U;
			TarotPlayer _tmp10_ = 0U;
			_tmp9_ = myself;
			_tmp10_ = next;
			if (_tmp9_ == _tmp10_) {
				TarotMcts* _tmp11_ = NULL;
				TarotGame* _tmp12_ = NULL;
				TarotMctsError _tmp13_ = 0;
				gchar* seed_bytes = NULL;
				const gchar* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				gchar* _tmp17_ = NULL;
				gint seed_bytes_length1 = 0;
				gint _seed_bytes_size_ = 0;
				TarotMcts* _tmp30_ = NULL;
				gchar* _tmp31_ = NULL;
				gint _tmp31__length1 = 0;
				TarotGameEvent* best = NULL;
				TarotMcts* _tmp35_ = NULL;
				TarotGameEvent* _tmp36_ = NULL;
				TarotGameEvent* _tmp37_ = NULL;
				TarotBid b = 0;
				gboolean d = FALSE;
				TarotCard c = 0U;
				TarotCard* cs = NULL;
				gint cs_length1 = 0;
				gint _cs_size_ = 0;
				TarotGameEvent* _tmp38_ = NULL;
				TarotBid _tmp39_ = 0;
				TarotGameEventError _tmp40_ = 0;
				TarotGameEvent* _tmp42_ = NULL;
				gboolean _tmp43_ = FALSE;
				TarotGameEventError _tmp44_ = 0;
				TarotGameEvent* _tmp46_ = NULL;
				TarotCard _tmp47_ = 0U;
				TarotGameEventError _tmp48_ = 0;
				TarotGameEvent* _tmp50_ = NULL;
				TarotCard* _tmp51_ = NULL;
				gsize _tmp52_;
				TarotGameEventError _tmp53_ = 0;
				TarotGameEvent* _tmp55_ = NULL;
				TarotCard* _tmp56_ = NULL;
				gsize _tmp57_;
				TarotGameEventError _tmp58_ = 0;
				TarotGameEvent* _tmp60_ = NULL;
				TarotCard _tmp61_ = 0U;
				TarotGameEventError _tmp62_ = 0;
				_tmp11_ = self->priv->m_mcts;
				_tmp12_ = self->priv->m_game;
				_tmp13_ = tarot_mcts_set_base (_tmp11_, _tmp12_);
				if (_tmp13_ != TAROT_MCTS_OK) {
					_vala_assert (FALSE, "false");
				}
				_tmp14_ = self->seed;
				_tmp15_ = strlen (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = g_new0 (gchar, _tmp16_);
				seed_bytes = _tmp17_;
				seed_bytes_length1 = _tmp16_;
				_seed_bytes_size_ = seed_bytes_length1;
				{
					glong j = 0L;
					j = (glong) 0;
					{
						gboolean _tmp18_ = FALSE;
						_tmp18_ = TRUE;
						while (TRUE) {
							glong _tmp20_ = 0L;
							const gchar* _tmp21_ = NULL;
							gint _tmp22_ = 0;
							gint _tmp23_ = 0;
							gchar* _tmp24_ = NULL;
							gint _tmp24__length1 = 0;
							glong _tmp25_ = 0L;
							const gchar* _tmp26_ = NULL;
							glong _tmp27_ = 0L;
							gchar _tmp28_ = '\0';
							gchar _tmp29_ = '\0';
							if (!_tmp18_) {
								glong _tmp19_ = 0L;
								_tmp19_ = j;
								j = _tmp19_ + 1;
							}
							_tmp18_ = FALSE;
							_tmp20_ = j;
							_tmp21_ = self->seed;
							_tmp22_ = strlen (_tmp21_);
							_tmp23_ = _tmp22_;
							if (!(_tmp20_ < ((glong) _tmp23_))) {
								break;
							}
							_tmp24_ = seed_bytes;
							_tmp24__length1 = seed_bytes_length1;
							_tmp25_ = j;
							_tmp26_ = self->seed;
							_tmp27_ = j;
							_tmp28_ = string_get (_tmp26_, _tmp27_);
							_tmp24_[_tmp25_] = _tmp28_;
							_tmp29_ = _tmp24_[_tmp25_];
						}
					}
				}
				_tmp30_ = self->priv->m_mcts;
				_tmp31_ = seed_bytes;
				_tmp31__length1 = seed_bytes_length1;
				tarot_mcts_seed (_tmp30_, (gsize) _tmp31__length1, _tmp31_);
				while (TRUE) {
					TarotMcts* _tmp32_ = NULL;
					gsize _tmp33_ = 0UL;
					TarotMctsError _tmp34_ = 0;
					_tmp32_ = self->priv->m_mcts;
					_tmp33_ = self->n_iterations;
					_tmp34_ = tarot_mcts_run (_tmp32_, _tmp33_);
					if (!(_tmp34_ != TAROT_MCTS_OK)) {
						break;
					}
				}
				_tmp35_ = self->priv->m_mcts;
				_tmp36_ = tarot_mcts_get_best (_tmp35_);
				_tmp37_ = __vala_TarotGameEvent_copy0 (_tmp36_);
				best = _tmp37_;
				_tmp38_ = best;
				_tmp40_ = tarot_game_event_get_bid (_tmp38_, &_tmp39_);
				b = _tmp39_;
				if (_tmp40_ == TAROT_EVENT_OK) {
					TarotBid _tmp41_ = 0;
					_tmp41_ = b;
					g_signal_emit_by_name (self, "event-bid", (guint) _tmp41_);
				}
				_tmp42_ = best;
				_tmp44_ = tarot_game_event_get_decl (_tmp42_, &_tmp43_);
				d = _tmp43_;
				if (_tmp44_ == TAROT_EVENT_OK) {
					gboolean _tmp45_ = FALSE;
					_tmp45_ = d;
					g_signal_emit_by_name (self, "event-decl", _tmp45_);
				}
				_tmp46_ = best;
				_tmp48_ = tarot_game_event_get_call (_tmp46_, &_tmp47_);
				c = _tmp47_;
				if (_tmp48_ == TAROT_EVENT_OK) {
					TarotCard _tmp49_ = 0U;
					_tmp49_ = c;
					g_signal_emit_by_name (self, "event-call", (guint) _tmp49_);
				}
				_tmp50_ = best;
				_tmp53_ = tarot_game_event_get_discard_alloc (_tmp50_, &_tmp52_, &_tmp51_);
				cs = (g_free (cs), NULL);
				cs = _tmp51_;
				cs_length1 = _tmp52_;
				_cs_size_ = cs_length1;
				if (_tmp53_ == TAROT_EVENT_OK) {
					TarotCard* _tmp54_ = NULL;
					gint _tmp54__length1 = 0;
					_tmp54_ = cs;
					_tmp54__length1 = cs_length1;
					g_signal_emit_by_name (self, "event-discard", (guint*) _tmp54_, (_tmp54__length1 * sizeof (TarotCard)) / sizeof (guint));
				}
				_tmp55_ = best;
				_tmp58_ = tarot_game_event_get_handful_alloc (_tmp55_, &_tmp57_, &_tmp56_);
				cs = (g_free (cs), NULL);
				cs = _tmp56_;
				cs_length1 = _tmp57_;
				_cs_size_ = cs_length1;
				if (_tmp58_ == TAROT_EVENT_OK) {
					TarotCard* _tmp59_ = NULL;
					gint _tmp59__length1 = 0;
					_tmp59_ = cs;
					_tmp59__length1 = cs_length1;
					g_signal_emit_by_name (self, "event-handful", (guint*) _tmp59_, (_tmp59__length1 * sizeof (TarotCard)) / sizeof (guint));
				}
				_tmp60_ = best;
				_tmp62_ = tarot_game_event_get_card (_tmp60_, &_tmp61_);
				c = _tmp61_;
				if (_tmp62_ == TAROT_EVENT_OK) {
					TarotCard _tmp63_ = 0U;
					_tmp63_ = c;
					g_signal_emit_by_name (self, "event-play", (guint) _tmp63_);
				}
				cs = (g_free (cs), NULL);
				__vala_TarotGameEvent_free0 (best);
				seed_bytes = (g_free (seed_bytes), NULL);
			}
		}
	}
}


static TarotGameError tarot_mcts_game_add_event (TarotMctsGame* self, TarotGameEvent* e) {
	TarotGameError result = 0;
	gsize n = 0UL;
	TarotGameEvent* _tmp0_ = NULL;
	TarotPlayer* _tmp1_ = NULL;
	TarotPlayer* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gsize _tmp3_ = 0UL;
	TarotGameEventError _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	TarotGameError err = 0;
	TarotGame* _tmp6_ = NULL;
	TarotGameEvent* _tmp7_ = NULL;
	TarotGameError _tmp8_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (e != NULL, 0);
	_tmp0_ = e;
	_tmp1_ = g_new0 (TarotPlayer, 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = 0;
	_tmp4_ = tarot_game_event_get_deal_all (_tmp0_, &_tmp3_, (gsize) 0, (gsize) 0, _tmp2_);
	n = _tmp3_;
	_tmp5_ = _tmp4_ == TAROT_EVENT_OK;
	_tmp2_ = (g_free (_tmp2_), NULL);
	if (_tmp5_) {
		result = TAROT_GAME_INVEV;
		return result;
	}
	_tmp6_ = self->priv->m_game;
	_tmp7_ = e;
	_tmp8_ = tarot_game_add_event (_tmp6_, _tmp7_);
	err = _tmp8_;
	result = err;
	return result;
}


gdouble tarot_mcts_game_get_parameter (TarotMctsGame* self) {
	gdouble result;
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = tarot_mcts_get_parameter (_tmp0_);
	result = _tmp1_;
	return result;
}


void tarot_mcts_game_set_parameter (TarotMctsGame* self, gdouble value) {
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = value;
	tarot_mcts_set_parameter (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "parameter");
}


gdouble tarot_mcts_game_get_simulation_agreed (TarotMctsGame* self) {
	gdouble result;
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = tarot_mcts_get_simulation_agreed (_tmp0_);
	result = _tmp1_;
	return result;
}


void tarot_mcts_game_set_simulation_agreed (TarotMctsGame* self, gdouble value) {
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = value;
	tarot_mcts_set_simulation_agreed (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "simulation-agreed");
}


gdouble tarot_mcts_game_get_simulation_random (TarotMctsGame* self) {
	gdouble result;
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = tarot_mcts_get_simulation_random (_tmp0_);
	result = _tmp1_;
	return result;
}


void tarot_mcts_game_set_simulation_random (TarotMctsGame* self, gdouble value) {
	TarotMcts* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_mcts;
	_tmp1_ = value;
	tarot_mcts_set_simulation_random (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "simulation-random");
}


static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__POINTER_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__POINTER_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void tarot_mcts_game_class_init (TarotMctsGameClass * klass) {
	tarot_mcts_game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TarotMctsGamePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_mcts_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tarot_mcts_game_set_property;
	G_OBJECT_CLASS (klass)->finalize = tarot_mcts_game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_MCTS_GAME_PARAMETER, g_param_spec_double ("parameter", "parameter", "parameter", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_MCTS_GAME_SIMULATION_AGREED, g_param_spec_double ("simulation-agreed", "simulation-agreed", "simulation-agreed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_MCTS_GAME_SIMULATION_RANDOM, g_param_spec_double ("simulation-random", "simulation-random", "simulation-random", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("event_bid", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	g_signal_new ("event_decl", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("event_call", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	g_signal_new ("event_discard", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	g_signal_new ("event_handful", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	g_signal_new ("event_play", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	g_signal_new ("finished", TAROT_TYPE_MCTS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}


static void tarot_mcts_game_instance_init (TarotMctsGame * self) {
	gchar* _tmp0_ = NULL;
	self->priv = TAROT_MCTS_GAME_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("default");
	self->seed = _tmp0_;
	self->n_iterations = (gsize) 100;
	self->priv->subscribed = FALSE;
}


static void tarot_mcts_game_finalize (GObject* obj) {
	TarotMctsGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_MCTS_GAME, TarotMctsGame);
	__vala_TarotGame_free0 (self->priv->m_game);
	__vala_TarotMcts_free0 (self->priv->m_mcts);
	_g_free0 (self->seed);
	G_OBJECT_CLASS (tarot_mcts_game_parent_class)->finalize (obj);
}


GType tarot_mcts_game_get_type (void) {
	static volatile gsize tarot_mcts_game_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_mcts_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotMctsGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_mcts_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotMctsGame), 0, (GInstanceInitFunc) tarot_mcts_game_instance_init, NULL };
		GType tarot_mcts_game_type_id;
		tarot_mcts_game_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotMctsGame", &g_define_type_info, 0);
		g_once_init_leave (&tarot_mcts_game_type_id__volatile, tarot_mcts_game_type_id);
	}
	return tarot_mcts_game_type_id__volatile;
}


static void _vala_tarot_mcts_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TarotMctsGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_MCTS_GAME, TarotMctsGame);
	switch (property_id) {
		case TAROT_MCTS_GAME_PARAMETER:
		g_value_set_double (value, tarot_mcts_game_get_parameter (self));
		break;
		case TAROT_MCTS_GAME_SIMULATION_AGREED:
		g_value_set_double (value, tarot_mcts_game_get_simulation_agreed (self));
		break;
		case TAROT_MCTS_GAME_SIMULATION_RANDOM:
		g_value_set_double (value, tarot_mcts_game_get_simulation_random (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_tarot_mcts_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TarotMctsGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_MCTS_GAME, TarotMctsGame);
	switch (property_id) {
		case TAROT_MCTS_GAME_PARAMETER:
		tarot_mcts_game_set_parameter (self, g_value_get_double (value));
		break;
		case TAROT_MCTS_GAME_SIMULATION_AGREED:
		tarot_mcts_game_set_simulation_agreed (self, g_value_get_double (value));
		break;
		case TAROT_MCTS_GAME_SIMULATION_RANDOM:
		tarot_mcts_game_set_simulation_random (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



