#include <config.h>
/* solo.c generated by valac 0.34.7, the Vala compiler
 * generated from solo.vala, do not modify */

/* solo.vala*/
/**/
/* Copyright (C) 2019 Vivien Kraus <vivien@planete-kraus.eu>*/
/* */
/*  This program is free software: you can redistribute it and/or*/
/*  modify it under the terms of the GNU General Public License as*/
/*  published by the Free Software Foundation, either version 3 of the*/
/*  License, or (at your option) any later version.*/
/* */
/*  This program is distributed in the hope that it will be useful, but*/
/*  WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/*  General Public License for more details.*/
/* */
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see*/
/*  <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "tarot-gobject.h"
#include <stdio.h>
#include <glib/gi18n-lib.h>


#define TAROT_TYPE_SOLO (tarot_solo_get_type ())
#define TAROT_SOLO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_SOLO, TarotSolo))
#define TAROT_SOLO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_SOLO, TarotSoloClass))
#define TAROT_IS_SOLO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_SOLO))
#define TAROT_IS_SOLO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_SOLO))
#define TAROT_SOLO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_SOLO, TarotSoloClass))

typedef struct _TarotSolo TarotSolo;
typedef struct _TarotSoloClass TarotSoloClass;
typedef struct _TarotSoloPrivate TarotSoloPrivate;

#define TAROT_TYPE_MCTS_PARAMS (tarot_mcts_params_get_type ())
typedef struct _TarotMctsParams TarotMctsParams;
typedef struct _Block2Data Block2Data;
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))

#define TAROT_TYPE_APPLICATION (tarot_application_get_type ())
#define TAROT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_APPLICATION, TarotApplication))
#define TAROT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_APPLICATION, TarotApplicationClass))
#define TAROT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_APPLICATION))
#define TAROT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_APPLICATION))
#define TAROT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_APPLICATION, TarotApplicationClass))

typedef struct _TarotApplication TarotApplication;
typedef struct _TarotApplicationClass TarotApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotSolo {
	GObject parent_instance;
	TarotSoloPrivate * priv;
};

struct _TarotSoloClass {
	GObjectClass parent_class;
};

struct _TarotMctsParams {
	const gchar* seed;
	gsize n_iterations;
	gdouble parameter;
	gdouble simulation_agreed;
	gdouble simulation_random;
};

struct _Block2Data {
	int _ref_count_;
	TarotGame* my_game;
	TarotPlayer myself;
};


static gpointer tarot_solo_parent_class = NULL;

gchar* readline (const gchar* prompt);
void add_history (const gchar* command);
GType tarot_solo_get_type (void) G_GNUC_CONST;
enum  {
	TAROT_SOLO_DUMMY_PROPERTY
};
GType tarot_mcts_params_get_type (void) G_GNUC_CONST;
TarotMctsParams* tarot_mcts_params_dup (const TarotMctsParams* self);
void tarot_mcts_params_free (TarotMctsParams* self);
gint tarot_solo_run (gsize n_players, gboolean call, TarotMctsParams* mp, gint retry, gchar** output);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void _vala_TarotGame_free (TarotGame* self);
static void block2_data_unref (void * _userdata_);
GType tarot_application_get_type (void) G_GNUC_CONST;
TarotApplication* tarot_application_new (void);
TarotApplication* tarot_application_construct (GType object_type);
static void __lambda6_ (Block2Data* _data2_, TarotGameEvent* e);
const gchar* tarot_game_event_t_to_string (TarotGameEventT self);
static void ___lambda6__tarot_application_broadcast_event (TarotApplication* _sender, TarotGameEvent* e, gpointer self);
static void __lambda7_ (Block2Data* _data2_, TarotGameEvent* e, gint who);
static void ___lambda7__tarot_application_unicast_event (TarotApplication* _sender, TarotGameEvent* e, gint who, gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void ___lambda8__tarot_application_reset (TarotApplication* _sender, gpointer self);
gboolean tarot_application_new_game (TarotApplication* self, gsize n_players, gboolean with_call);
gboolean tarot_application_deal_random (TarotApplication* self, const gchar* seed, gint retry);
gchar* tarot_pretty_status_print (TarotGame* game);
gboolean tarot_application_mcts (TarotApplication* self, TarotMctsParams* mp);
gboolean tarot_application_bid (TarotApplication* self, TarotBid bid);
gboolean tarot_application_decl (TarotApplication* self, gboolean decl);
gboolean tarot_application_call (TarotApplication* self, TarotCard call);
static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value);
static gchar** _vala_array_dup3 (gchar** self, int length);
gboolean tarot_application_discard (TarotApplication* self, TarotCard* discard, int discard_length1);
gboolean tarot_application_play (TarotApplication* self, TarotCard play);
gboolean tarot_application_handful (TarotApplication* self, TarotCard* handful, int handful_length1);
gchar* tarot_application_get_xml (TarotApplication* self);
TarotSolo* tarot_solo_new (void);
TarotSolo* tarot_solo_construct (GType object_type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void _vala_TarotGame_free (TarotGame* self) {
	g_boxed_free (tarot_game_get_type (), self);
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		__vala_TarotGame_free0 (_data2_->my_game);
		g_slice_free (Block2Data, _data2_);
	}
}


static void __lambda6_ (Block2Data* _data2_, TarotGameEvent* e) {
	TarotGame* _tmp0_ = NULL;
	TarotGameEvent* _tmp1_ = NULL;
	TarotGameError _tmp2_ = 0;
	g_return_if_fail (e != NULL);
	_tmp0_ = _data2_->my_game;
	_tmp1_ = e;
	_tmp2_ = tarot_game_add_event (_tmp0_, _tmp1_);
	if (_tmp2_ != TAROT_GAME_OK) {
		FILE* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		TarotGameEvent* _tmp5_ = NULL;
		TarotGameEventT _tmp6_ = 0;
		GEnumValue* _tmp7_;
		TarotGame* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = _ ("Could not add an event of type %s to game %s.\n");
		_tmp5_ = e;
		_tmp6_ = tarot_game_event_type (_tmp5_);
		_tmp7_ = g_enum_get_value (g_type_class_ref (tarot_game_event_t_get_type ()), _tmp6_);
		_tmp8_ = _data2_->my_game;
		_tmp9_ = tarot_game_save_to_xml_alloc (_tmp8_);
		_tmp10_ = _tmp9_;
		fprintf (_tmp3_, _tmp4_, (_tmp7_ != NULL) ? _tmp7_->value_name : NULL, _tmp10_);
		_g_free0 (_tmp10_);
		_vala_assert (FALSE, "false");
	}
}


static void ___lambda6__tarot_application_broadcast_event (TarotApplication* _sender, TarotGameEvent* e, gpointer self) {
	__lambda6_ (self, e);
}


static void __lambda7_ (Block2Data* _data2_, TarotGameEvent* e, gint who) {
	gint _tmp0_ = 0;
	TarotPlayer _tmp1_ = 0U;
	g_return_if_fail (e != NULL);
	_tmp0_ = who;
	_tmp1_ = _data2_->myself;
	if (((TarotPlayer) _tmp0_) == _tmp1_) {
		TarotGame* _tmp2_ = NULL;
		TarotGameEvent* _tmp3_ = NULL;
		TarotGameError _tmp4_ = 0;
		_tmp2_ = _data2_->my_game;
		_tmp3_ = e;
		_tmp4_ = tarot_game_add_event (_tmp2_, _tmp3_);
		if (_tmp4_ != TAROT_GAME_OK) {
			FILE* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			TarotGameEvent* _tmp7_ = NULL;
			TarotGameEventT _tmp8_ = 0;
			GEnumValue* _tmp9_;
			TarotGame* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			_tmp5_ = stderr;
			_tmp6_ = _ ("Could not add an event of type %s to game %s.\n");
			_tmp7_ = e;
			_tmp8_ = tarot_game_event_type (_tmp7_);
			_tmp9_ = g_enum_get_value (g_type_class_ref (tarot_game_event_t_get_type ()), _tmp8_);
			_tmp10_ = _data2_->my_game;
			_tmp11_ = tarot_game_save_to_xml_alloc (_tmp10_);
			_tmp12_ = _tmp11_;
			fprintf (_tmp5_, _tmp6_, (_tmp9_ != NULL) ? _tmp9_->value_name : NULL, _tmp12_);
			_g_free0 (_tmp12_);
			_vala_assert (FALSE, "false");
		}
	}
}


static void ___lambda7__tarot_application_unicast_event (TarotApplication* _sender, TarotGameEvent* e, gint who, gpointer self) {
	__lambda7_ (self, e, who);
}


static void __lambda8_ (Block2Data* _data2_) {
	TarotGame* _tmp0_ = NULL;
	_tmp0_ = tarot_game_alloc ();
	__vala_TarotGame_free0 (_data2_->my_game);
	_data2_->my_game = _tmp0_;
}


static void ___lambda8__tarot_application_reset (TarotApplication* _sender, gpointer self) {
	__lambda8_ (self);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gchar** _vala_array_dup3 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


gint tarot_solo_run (gsize n_players, gboolean call, TarotMctsParams* mp, gint retry, gchar** output) {
	gchar* _vala_output = NULL;
	gint result = 0;
	Block2Data* _data2_;
	TarotApplication* app = NULL;
	TarotApplication* _tmp0_ = NULL;
	TarotGame* _tmp1_ = NULL;
	TarotApplication* _tmp2_ = NULL;
	TarotApplication* _tmp3_ = NULL;
	TarotApplication* _tmp4_ = NULL;
	TarotApplication* _tmp5_ = NULL;
	gsize _tmp6_ = 0UL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	TarotApplication* _tmp12_ = NULL;
	TarotMctsParams _tmp13_ = {0};
	const gchar* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gboolean _tmp16_ = FALSE;
	gboolean eof = FALSE;
	FILE* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	gchar* ss = NULL;
	TarotGame* _tmp261_ = NULL;
	gchar* _tmp262_ = NULL;
	FILE* _tmp263_ = NULL;
	const gchar* _tmp264_ = NULL;
	TarotApplication* _tmp265_ = NULL;
	gchar* _tmp266_ = NULL;
	gchar* _tmp267_ = NULL;
	g_return_val_if_fail (mp != NULL, 0);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = tarot_application_new ();
	app = _tmp0_;
	_tmp1_ = tarot_game_alloc ();
	_data2_->my_game = _tmp1_;
	_data2_->myself = (TarotPlayer) 0;
	_g_free0 (_vala_output);
	_vala_output = NULL;
	_tmp2_ = app;
	g_signal_connect_data (_tmp2_, "broadcast-event", (GCallback) ___lambda6__tarot_application_broadcast_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp3_ = app;
	g_signal_connect_data (_tmp3_, "unicast-event", (GCallback) ___lambda7__tarot_application_unicast_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp4_ = app;
	g_signal_connect_data (_tmp4_, "reset", (GCallback) ___lambda8__tarot_application_reset, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp5_ = app;
	_tmp6_ = n_players;
	_tmp7_ = call;
	_tmp8_ = tarot_application_new_game (_tmp5_, _tmp6_, _tmp7_);
	if (!_tmp8_) {
		FILE* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gsize _tmp11_ = 0UL;
		_tmp9_ = stderr;
		_tmp10_ = _ ("Error: wrong number of players (%lu) or the call is not accepted\n");
		_tmp11_ = n_players;
		fprintf (_tmp9_, _tmp10_, _tmp11_);
		result = 1;
		_g_object_unref0 (app);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		if (output) {
			*output = _vala_output;
		} else {
			_g_free0 (_vala_output);
		}
		return result;
	}
	_tmp12_ = app;
	_tmp13_ = *mp;
	_tmp14_ = _tmp13_.seed;
	_tmp15_ = retry;
	_tmp16_ = tarot_application_deal_random (_tmp12_, _tmp14_, _tmp15_);
	if (!_tmp16_) {
		FILE* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		TarotMctsParams _tmp19_ = {0};
		const gchar* _tmp20_ = NULL;
		_tmp17_ = stderr;
		_tmp18_ = _ ("Error: wrong seed '%s', try another one\n");
		_tmp19_ = *mp;
		_tmp20_ = _tmp19_.seed;
		fprintf (_tmp17_, _tmp18_, _tmp20_);
		result = 1;
		_g_object_unref0 (app);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		if (output) {
			*output = _vala_output;
		} else {
			_g_free0 (_vala_output);
		}
		return result;
	}
	eof = FALSE;
	_tmp21_ = stdout;
	_tmp22_ = _ ("tarot %s\n" \
"Copyright (C) 2019 Vivien Kraus\n" \
"This program comes with ABSOLUTELY NO WARRANTY.\n" \
"This is free software, and you are welcome to redistribute it under\n" \
"the conditions of the GNU General Public License, version 3 or later.\n" \
"You should have received a copy of the GNU General Public License\n" \
"along with this program.  If not, see <http://www.gnu.org/licenses/>.\n");
	fprintf (_tmp21_, _tmp22_, PACKAGE_VERSION);
	while (TRUE) {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gchar* ss = NULL;
		TarotGame* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		TarotPlayer next = 0U;
		gboolean has_next = FALSE;
		TarotGame* _tmp29_ = NULL;
		TarotPlayer _tmp30_ = 0U;
		TarotGameError _tmp31_ = 0;
		FILE* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		gboolean _tmp34_ = FALSE;
		TarotPlayer _tmp35_ = 0U;
		TarotPlayer _tmp36_ = 0U;
		_tmp24_ = eof;
		if (!_tmp24_) {
			TarotGame* _tmp25_ = NULL;
			TarotStep _tmp26_ = 0;
			_tmp25_ = _data2_->my_game;
			_tmp26_ = tarot_game_step (_tmp25_);
			_tmp23_ = _tmp26_ != TAROT_END;
		} else {
			_tmp23_ = FALSE;
		}
		if (!_tmp23_) {
			break;
		}
		_tmp27_ = _data2_->my_game;
		_tmp28_ = tarot_pretty_status_print (_tmp27_);
		ss = _tmp28_;
		_tmp29_ = _data2_->my_game;
		_tmp31_ = tarot_game_get_next (_tmp29_, &_tmp30_);
		next = _tmp30_;
		has_next = _tmp31_ == TAROT_GAME_OK;
		_tmp32_ = stdout;
		_tmp33_ = ss;
		fprintf (_tmp32_, "%s\n", _tmp33_);
		_tmp34_ = has_next;
		_vala_assert (_tmp34_, "has_next");
		_tmp35_ = next;
		_tmp36_ = _data2_->myself;
		if (_tmp35_ != _tmp36_) {
			TarotApplication* _tmp37_ = NULL;
			TarotMctsParams _tmp38_ = {0};
			gboolean _tmp39_ = FALSE;
			_tmp37_ = app;
			_tmp38_ = *mp;
			_tmp39_ = tarot_application_mcts (_tmp37_, &_tmp38_);
			if (!_tmp39_) {
				FILE* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				_tmp40_ = stderr;
				_tmp41_ = _ ("Error: could not auto play.  Try with more iterations.\n");
				fprintf (_tmp40_, "%s", _tmp41_);
				result = 1;
				_g_free0 (ss);
				_g_object_unref0 (app);
				block2_data_unref (_data2_);
				_data2_ = NULL;
				if (output) {
					*output = _vala_output;
				} else {
					_g_free0 (_vala_output);
				}
				return result;
			}
		} else {
			gchar* help_about_card_names = NULL;
			const gchar* _tmp42_ = NULL;
			gchar* _tmp43_ = NULL;
			TarotStep step = 0;
			TarotGame* _tmp44_ = NULL;
			TarotStep _tmp45_ = 0;
			TarotStep _tmp46_ = 0;
			_tmp42_ = _ ("The cards are formed by a number followed by a suit indicator.  Exampl" \
"es are:\n" \
" - AH: the ace of hearts;\n" \
" - 10C: the ten of clubs;\n" \
" - JS: the jack of spades;\n" \
" - CD: the knight of diamonds;\n" \
" - QH: the queen of hearts;\n" \
" - KD: the knight of diamonds;\n" \
" - 12T: the twelve of trumps;\n" \
" - EXC: the excuse.\n");
			_tmp43_ = g_strdup (_tmp42_);
			help_about_card_names = _tmp43_;
			_tmp44_ = _data2_->my_game;
			_tmp45_ = tarot_game_step (_tmp44_);
			step = _tmp45_;
			_tmp46_ = step;
			switch (_tmp46_) {
				case TAROT_BIDS:
				{
					gchar* line = NULL;
					const gchar* _tmp47_ = NULL;
					gchar* _tmp48_ = NULL;
					const gchar* _tmp49_ = NULL;
					_tmp47_ = _ ("bid> ");
					_tmp48_ = readline (_tmp47_);
					line = _tmp48_;
					_tmp49_ = line;
					if (_tmp49_ != NULL) {
						const gchar* _tmp50_ = NULL;
						gchar* _tmp51_ = NULL;
						gboolean _tmp52_ = FALSE;
						const gchar* _tmp53_ = NULL;
						const gchar* _tmp54_ = NULL;
						_tmp50_ = line;
						_tmp51_ = string_strip (_tmp50_);
						_g_free0 (line);
						line = _tmp51_;
						_tmp53_ = line;
						_tmp54_ = _ ("pass");
						if (g_strcmp0 (_tmp53_, _tmp54_) == 0) {
							TarotApplication* _tmp55_ = NULL;
							gboolean _tmp56_ = FALSE;
							_tmp55_ = app;
							_tmp56_ = tarot_application_bid (_tmp55_, TAROT_PASS);
							_tmp52_ = _tmp56_;
						} else {
							_tmp52_ = FALSE;
						}
						if (_tmp52_) {
							const gchar* _tmp57_ = NULL;
							_tmp57_ = _ ("pass");
							add_history (_tmp57_);
						} else {
							gboolean _tmp58_ = FALSE;
							const gchar* _tmp59_ = NULL;
							const gchar* _tmp60_ = NULL;
							_tmp59_ = line;
							_tmp60_ = _ ("take");
							if (g_strcmp0 (_tmp59_, _tmp60_) == 0) {
								TarotApplication* _tmp61_ = NULL;
								gboolean _tmp62_ = FALSE;
								_tmp61_ = app;
								_tmp62_ = tarot_application_bid (_tmp61_, TAROT_TAKE);
								_tmp58_ = _tmp62_;
							} else {
								_tmp58_ = FALSE;
							}
							if (_tmp58_) {
								const gchar* _tmp63_ = NULL;
								_tmp63_ = _ ("take");
								add_history (_tmp63_);
							} else {
								gboolean _tmp64_ = FALSE;
								const gchar* _tmp65_ = NULL;
								const gchar* _tmp66_ = NULL;
								_tmp65_ = line;
								_tmp66_ = _ ("push");
								if (g_strcmp0 (_tmp65_, _tmp66_) == 0) {
									TarotApplication* _tmp67_ = NULL;
									gboolean _tmp68_ = FALSE;
									_tmp67_ = app;
									_tmp68_ = tarot_application_bid (_tmp67_, TAROT_PUSH);
									_tmp64_ = _tmp68_;
								} else {
									_tmp64_ = FALSE;
								}
								if (_tmp64_) {
									const gchar* _tmp69_ = NULL;
									_tmp69_ = _ ("push");
									add_history (_tmp69_);
								} else {
									gboolean _tmp70_ = FALSE;
									const gchar* _tmp71_ = NULL;
									const gchar* _tmp72_ = NULL;
									_tmp71_ = line;
									_tmp72_ = _ ("straight keep");
									if (g_strcmp0 (_tmp71_, _tmp72_) == 0) {
										TarotApplication* _tmp73_ = NULL;
										gboolean _tmp74_ = FALSE;
										_tmp73_ = app;
										_tmp74_ = tarot_application_bid (_tmp73_, TAROT_STRAIGHT_KEEP);
										_tmp70_ = _tmp74_;
									} else {
										_tmp70_ = FALSE;
									}
									if (_tmp70_) {
										const gchar* _tmp75_ = NULL;
										_tmp75_ = _ ("straight keep");
										add_history (_tmp75_);
									} else {
										gboolean _tmp76_ = FALSE;
										const gchar* _tmp77_ = NULL;
										const gchar* _tmp78_ = NULL;
										_tmp77_ = line;
										_tmp78_ = _ ("double keep");
										if (g_strcmp0 (_tmp77_, _tmp78_) == 0) {
											TarotApplication* _tmp79_ = NULL;
											gboolean _tmp80_ = FALSE;
											_tmp79_ = app;
											_tmp80_ = tarot_application_bid (_tmp79_, TAROT_DOUBLE_KEEP);
											_tmp76_ = _tmp80_;
										} else {
											_tmp76_ = FALSE;
										}
										if (_tmp76_) {
											const gchar* _tmp81_ = NULL;
											_tmp81_ = _ ("double keep");
											add_history (_tmp81_);
										} else {
											FILE* _tmp82_ = NULL;
											const gchar* _tmp83_ = NULL;
											_tmp82_ = stderr;
											_tmp83_ = _ ("The bids are 'pass', 'take', 'push', 'straight keep' and 'double keep'" \
", but you have to outbid.\n");
											fprintf (_tmp82_, "%s", _tmp83_);
										}
									}
								}
							}
						}
					} else {
						eof = TRUE;
					}
					_g_free0 (line);
					break;
				}
				case TAROT_DECLS:
				{
					gchar* line = NULL;
					const gchar* _tmp84_ = NULL;
					gchar* _tmp85_ = NULL;
					const gchar* _tmp86_ = NULL;
					_tmp84_ = _ ("declare> ");
					_tmp85_ = readline (_tmp84_);
					line = _tmp85_;
					_tmp86_ = line;
					if (_tmp86_ != NULL) {
						const gchar* _tmp87_ = NULL;
						gchar* _tmp88_ = NULL;
						gboolean _tmp89_ = FALSE;
						const gchar* _tmp90_ = NULL;
						const gchar* _tmp91_ = NULL;
						_tmp87_ = line;
						_tmp88_ = string_strip (_tmp87_);
						_g_free0 (line);
						line = _tmp88_;
						_tmp90_ = line;
						_tmp91_ = _ ("pass");
						if (g_strcmp0 (_tmp90_, _tmp91_) == 0) {
							TarotApplication* _tmp92_ = NULL;
							gboolean _tmp93_ = FALSE;
							_tmp92_ = app;
							_tmp93_ = tarot_application_decl (_tmp92_, FALSE);
							_tmp89_ = _tmp93_;
						} else {
							_tmp89_ = FALSE;
						}
						if (_tmp89_) {
							const gchar* _tmp94_ = NULL;
							_tmp94_ = _ ("pass");
							add_history (_tmp94_);
						} else {
							gboolean _tmp95_ = FALSE;
							const gchar* _tmp96_ = NULL;
							const gchar* _tmp97_ = NULL;
							_tmp96_ = line;
							_tmp97_ = _ ("slam");
							if (g_strcmp0 (_tmp96_, _tmp97_) == 0) {
								TarotApplication* _tmp98_ = NULL;
								gboolean _tmp99_ = FALSE;
								_tmp98_ = app;
								_tmp99_ = tarot_application_decl (_tmp98_, TRUE);
								_tmp95_ = _tmp99_;
							} else {
								_tmp95_ = FALSE;
							}
							if (_tmp95_) {
								const gchar* _tmp100_ = NULL;
								_tmp100_ = _ ("slam");
								add_history (_tmp100_);
							} else {
								FILE* _tmp101_ = NULL;
								const gchar* _tmp102_ = NULL;
								_tmp101_ = stderr;
								_tmp102_ = _ ("The declarations are 'pass' or 'slam'.\n");
								fprintf (_tmp101_, "%s", _tmp102_);
							}
						}
					} else {
						eof = TRUE;
					}
					_g_free0 (line);
					break;
				}
				case TAROT_CALL:
				{
					gchar* line = NULL;
					const gchar* _tmp103_ = NULL;
					gchar* _tmp104_ = NULL;
					const gchar* _tmp105_ = NULL;
					_tmp103_ = _ ("call> ");
					_tmp104_ = readline (_tmp103_);
					line = _tmp104_;
					_tmp105_ = line;
					if (_tmp105_ != NULL) {
						const gchar* _tmp106_ = NULL;
						gchar* _tmp107_ = NULL;
						TarotCard c = 0U;
						const gchar* _tmp108_ = NULL;
						TarotCard _tmp109_ = 0U;
						gboolean _tmp110_ = FALSE;
						TarotCard _tmp111_ = 0U;
						_tmp106_ = line;
						_tmp107_ = string_strip (_tmp106_);
						_g_free0 (line);
						line = _tmp107_;
						_tmp108_ = line;
						_tmp109_ = tarot_string_to_card (_tmp108_);
						c = _tmp109_;
						_tmp111_ = c;
						if (_tmp111_ == ((TarotCard) -1)) {
							_tmp110_ = TRUE;
						} else {
							TarotApplication* _tmp112_ = NULL;
							TarotCard _tmp113_ = 0U;
							gboolean _tmp114_ = FALSE;
							_tmp112_ = app;
							_tmp113_ = c;
							_tmp114_ = tarot_application_call (_tmp112_, _tmp113_);
							_tmp110_ = !_tmp114_;
						}
						if (_tmp110_) {
							FILE* _tmp115_ = NULL;
							const gchar* _tmp116_ = NULL;
							_tmp115_ = stderr;
							_tmp116_ = _ ("You should call a face card.  Example: KH (king of hearts), QC (queen " \
"of clubs), CD (knight of diamonds), JS (jack of spades).  Not all card" \
"s are possible.\n");
							fprintf (_tmp115_, "%s", _tmp116_);
						} else {
							TarotCard _tmp117_ = 0U;
							gchar* _tmp118_ = NULL;
							gchar* _tmp119_ = NULL;
							_tmp117_ = c;
							_tmp118_ = tarot_card_to_string_alloc (_tmp117_);
							_tmp119_ = _tmp118_;
							add_history (_tmp119_);
							_g_free0 (_tmp119_);
						}
					} else {
						eof = TRUE;
					}
					_g_free0 (line);
					break;
				}
				case TAROT_DISCARD:
				{
					gchar* line = NULL;
					const gchar* _tmp120_ = NULL;
					gchar* _tmp121_ = NULL;
					const gchar* _tmp122_ = NULL;
					_tmp120_ = _ ("discard> ");
					_tmp121_ = readline (_tmp120_);
					line = _tmp121_;
					_tmp122_ = line;
					if (_tmp122_ != NULL) {
						const gchar* _tmp123_ = NULL;
						gchar* _tmp124_ = NULL;
						gchar** split = NULL;
						const gchar* _tmp125_ = NULL;
						gchar** _tmp126_ = NULL;
						gchar** _tmp127_ = NULL;
						gint split_length1 = 0;
						gint _split_size_ = 0;
						gchar** split_filtered = NULL;
						gchar** _tmp128_ = NULL;
						gint split_filtered_length1 = 0;
						gint _split_filtered_size_ = 0;
						gchar** _tmp129_ = NULL;
						gint _tmp129__length1 = 0;
						gchar** _tmp135_ = NULL;
						gint _tmp135__length1 = 0;
						gchar** _tmp136_ = NULL;
						gint _tmp136__length1 = 0;
						TarotCard* cards = NULL;
						gchar** _tmp137_ = NULL;
						gint _tmp137__length1 = 0;
						TarotCard* _tmp138_ = NULL;
						gint cards_length1 = 0;
						gint _cards_size_ = 0;
						gboolean ok = FALSE;
						gboolean _tmp163_ = FALSE;
						_tmp123_ = line;
						_tmp124_ = string_strip (_tmp123_);
						_g_free0 (line);
						line = _tmp124_;
						_tmp125_ = line;
						_tmp127_ = _tmp126_ = g_strsplit (_tmp125_, " ", 0);
						split = _tmp127_;
						split_length1 = _vala_array_length (_tmp126_);
						_split_size_ = split_length1;
						_tmp128_ = g_new0 (gchar*, 0 + 1);
						split_filtered = _tmp128_;
						split_filtered_length1 = 0;
						_split_filtered_size_ = split_filtered_length1;
						_tmp129_ = split;
						_tmp129__length1 = split_length1;
						{
							gchar** c_collection = NULL;
							gint c_collection_length1 = 0;
							gint _c_collection_size_ = 0;
							gint c_it = 0;
							c_collection = _tmp129_;
							c_collection_length1 = _tmp129__length1;
							for (c_it = 0; c_it < _tmp129__length1; c_it = c_it + 1) {
								gchar* _tmp130_ = NULL;
								gchar* c = NULL;
								_tmp130_ = g_strdup (c_collection[c_it]);
								c = _tmp130_;
								{
									const gchar* _tmp131_ = NULL;
									_tmp131_ = c;
									if (g_strcmp0 (_tmp131_, "") != 0) {
										gchar** _tmp132_ = NULL;
										gint _tmp132__length1 = 0;
										const gchar* _tmp133_ = NULL;
										gchar* _tmp134_ = NULL;
										_tmp132_ = split_filtered;
										_tmp132__length1 = split_filtered_length1;
										_tmp133_ = c;
										_tmp134_ = g_strdup (_tmp133_);
										_vala_array_add4 (&split_filtered, &split_filtered_length1, &_split_filtered_size_, _tmp134_);
									}
									_g_free0 (c);
								}
							}
						}
						_tmp135_ = split_filtered;
						_tmp135__length1 = split_filtered_length1;
						_tmp136_ = (_tmp135_ != NULL) ? _vala_array_dup3 (_tmp135_, _tmp135__length1) : ((gpointer) _tmp135_);
						_tmp136__length1 = _tmp135__length1;
						split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
						split = _tmp136_;
						split_length1 = _tmp136__length1;
						_split_size_ = split_length1;
						_tmp137_ = split;
						_tmp137__length1 = split_length1;
						_tmp138_ = g_new0 (TarotCard, _tmp137__length1);
						cards = _tmp138_;
						cards_length1 = _tmp137__length1;
						_cards_size_ = cards_length1;
						ok = TRUE;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp139_ = FALSE;
								_tmp139_ = TRUE;
								while (TRUE) {
									gint _tmp141_ = 0;
									gchar** _tmp142_ = NULL;
									gint _tmp142__length1 = 0;
									TarotCard c = 0U;
									gchar** _tmp143_ = NULL;
									gint _tmp143__length1 = 0;
									gint _tmp144_ = 0;
									const gchar* _tmp145_ = NULL;
									TarotCard _tmp146_ = 0U;
									TarotCard _tmp147_ = 0U;
									TarotCard* _tmp154_ = NULL;
									gint _tmp154__length1 = 0;
									gint _tmp155_ = 0;
									TarotCard _tmp156_ = 0U;
									TarotCard _tmp157_ = 0U;
									gchar** _tmp158_ = NULL;
									gint _tmp158__length1 = 0;
									gint _tmp159_ = 0;
									TarotCard _tmp160_ = 0U;
									gchar* _tmp161_ = NULL;
									gchar* _tmp162_ = NULL;
									if (!_tmp139_) {
										gint _tmp140_ = 0;
										_tmp140_ = i;
										i = _tmp140_ + 1;
									}
									_tmp139_ = FALSE;
									_tmp141_ = i;
									_tmp142_ = split;
									_tmp142__length1 = split_length1;
									if (!(_tmp141_ < _tmp142__length1)) {
										break;
									}
									_tmp143_ = split;
									_tmp143__length1 = split_length1;
									_tmp144_ = i;
									_tmp145_ = _tmp143_[_tmp144_];
									_tmp146_ = tarot_string_to_card (_tmp145_);
									c = _tmp146_;
									_tmp147_ = c;
									if (_tmp147_ == ((TarotCard) -1)) {
										FILE* _tmp148_ = NULL;
										const gchar* _tmp149_ = NULL;
										gchar** _tmp150_ = NULL;
										gint _tmp150__length1 = 0;
										gint _tmp151_ = 0;
										const gchar* _tmp152_ = NULL;
										const gchar* _tmp153_ = NULL;
										_tmp148_ = stderr;
										_tmp149_ = _ ("'%s' is not a valid card.  %s");
										_tmp150_ = split;
										_tmp150__length1 = split_length1;
										_tmp151_ = i;
										_tmp152_ = _tmp150_[_tmp151_];
										_tmp153_ = help_about_card_names;
										fprintf (_tmp148_, _tmp149_, _tmp152_, _tmp153_);
										ok = FALSE;
										break;
									}
									_tmp154_ = cards;
									_tmp154__length1 = cards_length1;
									_tmp155_ = i;
									_tmp156_ = c;
									_tmp154_[_tmp155_] = _tmp156_;
									_tmp157_ = _tmp154_[_tmp155_];
									_tmp158_ = split;
									_tmp158__length1 = split_length1;
									_tmp159_ = i;
									_tmp160_ = c;
									_tmp161_ = tarot_card_to_string_alloc (_tmp160_);
									_g_free0 (_tmp158_[_tmp159_]);
									_tmp158_[_tmp159_] = _tmp161_;
									_tmp162_ = _tmp158_[_tmp159_];
								}
							}
						}
						_tmp163_ = ok;
						if (!_tmp163_) {
						} else {
							TarotApplication* _tmp164_ = NULL;
							TarotCard* _tmp165_ = NULL;
							gint _tmp165__length1 = 0;
							gboolean _tmp166_ = FALSE;
							_tmp164_ = app;
							_tmp165_ = cards;
							_tmp165__length1 = cards_length1;
							_tmp166_ = tarot_application_discard (_tmp164_, _tmp165_, _tmp165__length1);
							if (_tmp166_) {
								gchar** _tmp167_ = NULL;
								gint _tmp167__length1 = 0;
								gchar* _tmp168_ = NULL;
								gchar* _tmp169_ = NULL;
								_tmp167_ = split;
								_tmp167__length1 = split_length1;
								_tmp168_ = g_strjoin (" ", _tmp167_, NULL);
								_tmp169_ = _tmp168_;
								add_history (_tmp169_);
								_g_free0 (_tmp169_);
							} else {
								FILE* _tmp170_ = NULL;
								const gchar* _tmp171_ = NULL;
								_tmp170_ = stderr;
								_tmp171_ = _ ("This discard is not possible.\n");
								fprintf (_tmp170_, "%s", _tmp171_);
							}
						}
						cards = (g_free (cards), NULL);
						split_filtered = (_vala_array_free (split_filtered, split_filtered_length1, (GDestroyNotify) g_free), NULL);
						split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
					} else {
						eof = TRUE;
					}
					_g_free0 (line);
					break;
				}
				case TAROT_TRICKS:
				{
					gsize current_trick = 0UL;
					gboolean has_current_trick = FALSE;
					TarotGame* _tmp172_ = NULL;
					gsize _tmp173_ = 0UL;
					TarotGameError _tmp174_ = 0;
					gboolean _tmp175_ = FALSE;
					gboolean _tmp176_ = FALSE;
					_tmp172_ = _data2_->my_game;
					_tmp174_ = tarot_game_get_current_trick (_tmp172_, &_tmp173_);
					current_trick = _tmp173_;
					has_current_trick = _tmp174_ == TAROT_GAME_OK;
					_tmp176_ = has_current_trick;
					if (_tmp176_) {
						gsize _tmp177_ = 0UL;
						_tmp177_ = current_trick;
						_tmp175_ = _tmp177_ == ((gsize) 0);
					} else {
						_tmp175_ = FALSE;
					}
					if (_tmp175_) {
						gchar* line = NULL;
						const gchar* _tmp178_ = NULL;
						gchar* _tmp179_ = NULL;
						const gchar* _tmp180_ = NULL;
						_tmp178_ = _ ("play / show> ");
						_tmp179_ = readline (_tmp178_);
						line = _tmp179_;
						_tmp180_ = line;
						if (_tmp180_ != NULL) {
							const gchar* _tmp181_ = NULL;
							gchar* _tmp182_ = NULL;
							gchar** split = NULL;
							const gchar* _tmp183_ = NULL;
							gchar** _tmp184_ = NULL;
							gchar** _tmp185_ = NULL;
							gint split_length1 = 0;
							gint _split_size_ = 0;
							gchar** _tmp186_ = NULL;
							gint _tmp186__length1 = 0;
							_tmp181_ = line;
							_tmp182_ = string_strip (_tmp181_);
							_g_free0 (line);
							line = _tmp182_;
							_tmp183_ = line;
							_tmp185_ = _tmp184_ = g_strsplit (_tmp183_, " ", 0);
							split = _tmp185_;
							split_length1 = _vala_array_length (_tmp184_);
							_split_size_ = split_length1;
							_tmp186_ = split;
							_tmp186__length1 = split_length1;
							if (_tmp186__length1 == 0) {
								FILE* _tmp187_ = NULL;
								const gchar* _tmp188_ = NULL;
								const gchar* _tmp189_ = NULL;
								_tmp187_ = stderr;
								_tmp188_ = _ ("Enter multiple cards to show a handful, or one to play.  %s");
								_tmp189_ = help_about_card_names;
								fprintf (_tmp187_, _tmp188_, _tmp189_);
							} else {
								gchar** _tmp190_ = NULL;
								gint _tmp190__length1 = 0;
								_tmp190_ = split;
								_tmp190__length1 = split_length1;
								if (_tmp190__length1 == 1) {
									TarotCard card_to_play = 0U;
									gchar** _tmp191_ = NULL;
									gint _tmp191__length1 = 0;
									const gchar* _tmp192_ = NULL;
									TarotCard _tmp193_ = 0U;
									gboolean _tmp194_ = FALSE;
									TarotCard _tmp195_ = 0U;
									_tmp191_ = split;
									_tmp191__length1 = split_length1;
									_tmp192_ = _tmp191_[0];
									_tmp193_ = tarot_string_to_card (_tmp192_);
									card_to_play = _tmp193_;
									_tmp195_ = card_to_play;
									if (_tmp195_ == ((TarotCard) -1)) {
										_tmp194_ = TRUE;
									} else {
										TarotApplication* _tmp196_ = NULL;
										TarotCard _tmp197_ = 0U;
										gboolean _tmp198_ = FALSE;
										_tmp196_ = app;
										_tmp197_ = card_to_play;
										_tmp198_ = tarot_application_play (_tmp196_, _tmp197_);
										_tmp194_ = !_tmp198_;
									}
									if (_tmp194_) {
										FILE* _tmp199_ = NULL;
										const gchar* _tmp200_ = NULL;
										gchar** _tmp201_ = NULL;
										gint _tmp201__length1 = 0;
										const gchar* _tmp202_ = NULL;
										const gchar* _tmp203_ = NULL;
										_tmp199_ = stderr;
										_tmp200_ = _ ("'%s' is not a valid card to play.  %s");
										_tmp201_ = split;
										_tmp201__length1 = split_length1;
										_tmp202_ = _tmp201_[0];
										_tmp203_ = help_about_card_names;
										fprintf (_tmp199_, _tmp200_, _tmp202_, _tmp203_);
									} else {
										TarotCard _tmp204_ = 0U;
										gchar* _tmp205_ = NULL;
										gchar* _tmp206_ = NULL;
										_tmp204_ = card_to_play;
										_tmp205_ = tarot_card_to_string_alloc (_tmp204_);
										_tmp206_ = _tmp205_;
										add_history (_tmp206_);
										_g_free0 (_tmp206_);
									}
								} else {
									TarotCard* cards = NULL;
									gchar** _tmp207_ = NULL;
									gint _tmp207__length1 = 0;
									TarotCard* _tmp208_ = NULL;
									gint cards_length1 = 0;
									gint _cards_size_ = 0;
									gboolean ok = FALSE;
									gboolean _tmp233_ = FALSE;
									_tmp207_ = split;
									_tmp207__length1 = split_length1;
									_tmp208_ = g_new0 (TarotCard, _tmp207__length1);
									cards = _tmp208_;
									cards_length1 = _tmp207__length1;
									_cards_size_ = cards_length1;
									ok = TRUE;
									{
										gint i = 0;
										i = 0;
										{
											gboolean _tmp209_ = FALSE;
											_tmp209_ = TRUE;
											while (TRUE) {
												gint _tmp211_ = 0;
												gchar** _tmp212_ = NULL;
												gint _tmp212__length1 = 0;
												TarotCard c = 0U;
												gchar** _tmp213_ = NULL;
												gint _tmp213__length1 = 0;
												gint _tmp214_ = 0;
												const gchar* _tmp215_ = NULL;
												TarotCard _tmp216_ = 0U;
												TarotCard _tmp217_ = 0U;
												TarotCard* _tmp224_ = NULL;
												gint _tmp224__length1 = 0;
												gint _tmp225_ = 0;
												TarotCard _tmp226_ = 0U;
												TarotCard _tmp227_ = 0U;
												gchar** _tmp228_ = NULL;
												gint _tmp228__length1 = 0;
												gint _tmp229_ = 0;
												TarotCard _tmp230_ = 0U;
												gchar* _tmp231_ = NULL;
												gchar* _tmp232_ = NULL;
												if (!_tmp209_) {
													gint _tmp210_ = 0;
													_tmp210_ = i;
													i = _tmp210_ + 1;
												}
												_tmp209_ = FALSE;
												_tmp211_ = i;
												_tmp212_ = split;
												_tmp212__length1 = split_length1;
												if (!(_tmp211_ < _tmp212__length1)) {
													break;
												}
												_tmp213_ = split;
												_tmp213__length1 = split_length1;
												_tmp214_ = i;
												_tmp215_ = _tmp213_[_tmp214_];
												_tmp216_ = tarot_string_to_card (_tmp215_);
												c = _tmp216_;
												_tmp217_ = c;
												if (_tmp217_ == ((TarotCard) -1)) {
													FILE* _tmp218_ = NULL;
													const gchar* _tmp219_ = NULL;
													gchar** _tmp220_ = NULL;
													gint _tmp220__length1 = 0;
													gint _tmp221_ = 0;
													const gchar* _tmp222_ = NULL;
													const gchar* _tmp223_ = NULL;
													_tmp218_ = stderr;
													_tmp219_ = _ ("'%s' is not a valid card.  %s");
													_tmp220_ = split;
													_tmp220__length1 = split_length1;
													_tmp221_ = i;
													_tmp222_ = _tmp220_[_tmp221_];
													_tmp223_ = help_about_card_names;
													fprintf (_tmp218_, _tmp219_, _tmp222_, _tmp223_);
													ok = FALSE;
													break;
												}
												_tmp224_ = cards;
												_tmp224__length1 = cards_length1;
												_tmp225_ = i;
												_tmp226_ = c;
												_tmp224_[_tmp225_] = _tmp226_;
												_tmp227_ = _tmp224_[_tmp225_];
												_tmp228_ = split;
												_tmp228__length1 = split_length1;
												_tmp229_ = i;
												_tmp230_ = c;
												_tmp231_ = tarot_card_to_string_alloc (_tmp230_);
												_g_free0 (_tmp228_[_tmp229_]);
												_tmp228_[_tmp229_] = _tmp231_;
												_tmp232_ = _tmp228_[_tmp229_];
											}
										}
									}
									_tmp233_ = ok;
									if (!_tmp233_) {
									} else {
										TarotApplication* _tmp234_ = NULL;
										TarotCard* _tmp235_ = NULL;
										gint _tmp235__length1 = 0;
										gboolean _tmp236_ = FALSE;
										_tmp234_ = app;
										_tmp235_ = cards;
										_tmp235__length1 = cards_length1;
										_tmp236_ = tarot_application_handful (_tmp234_, _tmp235_, _tmp235__length1);
										if (_tmp236_) {
											gchar** _tmp237_ = NULL;
											gint _tmp237__length1 = 0;
											gchar* _tmp238_ = NULL;
											gchar* _tmp239_ = NULL;
											_tmp237_ = split;
											_tmp237__length1 = split_length1;
											_tmp238_ = g_strjoin (" ", _tmp237_, NULL);
											_tmp239_ = _tmp238_;
											add_history (_tmp239_);
											_g_free0 (_tmp239_);
										} else {
											FILE* _tmp240_ = NULL;
											const gchar* _tmp241_ = NULL;
											_tmp240_ = stderr;
											_tmp241_ = _ ("This handful is not possible.\n");
											fprintf (_tmp240_, "%s", _tmp241_);
										}
									}
									cards = (g_free (cards), NULL);
								}
							}
							split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
						} else {
							eof = TRUE;
						}
						_g_free0 (line);
					} else {
						gchar* line = NULL;
						const gchar* _tmp242_ = NULL;
						gchar* _tmp243_ = NULL;
						const gchar* _tmp244_ = NULL;
						_tmp242_ = _ ("play> ");
						_tmp243_ = readline (_tmp242_);
						line = _tmp243_;
						_tmp244_ = line;
						if (_tmp244_ != NULL) {
							const gchar* _tmp245_ = NULL;
							gchar* _tmp246_ = NULL;
							TarotCard card_to_play = 0U;
							const gchar* _tmp247_ = NULL;
							TarotCard _tmp248_ = 0U;
							gboolean _tmp249_ = FALSE;
							TarotCard _tmp250_ = 0U;
							_tmp245_ = line;
							_tmp246_ = string_strip (_tmp245_);
							_g_free0 (line);
							line = _tmp246_;
							_tmp247_ = line;
							_tmp248_ = tarot_string_to_card (_tmp247_);
							card_to_play = _tmp248_;
							_tmp250_ = card_to_play;
							if (_tmp250_ == ((TarotCard) -1)) {
								_tmp249_ = TRUE;
							} else {
								TarotApplication* _tmp251_ = NULL;
								TarotCard _tmp252_ = 0U;
								gboolean _tmp253_ = FALSE;
								_tmp251_ = app;
								_tmp252_ = card_to_play;
								_tmp253_ = tarot_application_play (_tmp251_, _tmp252_);
								_tmp249_ = !_tmp253_;
							}
							if (_tmp249_) {
								FILE* _tmp254_ = NULL;
								const gchar* _tmp255_ = NULL;
								const gchar* _tmp256_ = NULL;
								const gchar* _tmp257_ = NULL;
								_tmp254_ = stderr;
								_tmp255_ = _ ("'%s' is not a valid card to play.  %s");
								_tmp256_ = line;
								_tmp257_ = help_about_card_names;
								fprintf (_tmp254_, _tmp255_, _tmp256_, _tmp257_);
							} else {
								TarotCard _tmp258_ = 0U;
								gchar* _tmp259_ = NULL;
								gchar* _tmp260_ = NULL;
								_tmp258_ = card_to_play;
								_tmp259_ = tarot_card_to_string_alloc (_tmp258_);
								_tmp260_ = _tmp259_;
								add_history (_tmp260_);
								_g_free0 (_tmp260_);
							}
						} else {
							eof = TRUE;
						}
						_g_free0 (line);
					}
					break;
				}
				default:
				{
					abort ();
				}
			}
			_g_free0 (help_about_card_names);
		}
		_g_free0 (ss);
	}
	_tmp261_ = _data2_->my_game;
	_tmp262_ = tarot_pretty_status_print (_tmp261_);
	ss = _tmp262_;
	_tmp263_ = stdout;
	_tmp264_ = ss;
	fprintf (_tmp263_, "%s\n", _tmp264_);
	_tmp265_ = app;
	_tmp266_ = tarot_application_get_xml (_tmp265_);
	_tmp267_ = _tmp266_;
	_g_free0 (_vala_output);
	_vala_output = _tmp267_;
	result = 0;
	_g_free0 (ss);
	_g_object_unref0 (app);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	if (output) {
		*output = _vala_output;
	} else {
		_g_free0 (_vala_output);
	}
	return result;
}


TarotSolo* tarot_solo_construct (GType object_type) {
	TarotSolo * self = NULL;
	self = (TarotSolo*) g_object_new (object_type, NULL);
	return self;
}


TarotSolo* tarot_solo_new (void) {
	return tarot_solo_construct (TAROT_TYPE_SOLO);
}


static void tarot_solo_class_init (TarotSoloClass * klass) {
	tarot_solo_parent_class = g_type_class_peek_parent (klass);
}


static void tarot_solo_instance_init (TarotSolo * self) {
}


GType tarot_solo_get_type (void) {
	static volatile gsize tarot_solo_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_solo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotSoloClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_solo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotSolo), 0, (GInstanceInitFunc) tarot_solo_instance_init, NULL };
		GType tarot_solo_type_id;
		tarot_solo_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotSolo", &g_define_type_info, 0);
		g_once_init_leave (&tarot_solo_type_id__volatile, tarot_solo_type_id);
	}
	return tarot_solo_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



