#!/bin/sh

tarot --help > /dev/null || exit 1

AT_END=$(tarot --new-game -n 5 -c \
	  | tarot --deal-to P5=19T,18T,17T,16T,15T,14T,13T,12T,11T,EXC,KH,QH,CH,JH,10H \
	  | tarot --bid=take \
	  | tarot --bid=pass \
	  | tarot --bid=pass \
	  | tarot --bid=pass \
	  | tarot --bid=pass \
	  | tarot --declare=pass \
	  | tarot --declare=pass \
	  | tarot --declare=pass \
	  | tarot --declare=pass \
	  | tarot --declare=slam \
	  | tarot --call=KC \
	  | tarot --dog=6H,7H,8H \
	  | tarot --discard= \
	  | tarot --handful=EXC,11T,12T,13T,14T,15T,16T,17T,18T,19T \
	  | tarot --play=19T \
	  | tarot --handful=1T,2T,3T,4T,5T,6T,7T,8T,9T,10T \
	  | tarot --play=10T \
	  | tarot --play=20T \
	  | tarot --play=21T \
	  | tarot --play=6C \
	  | tarot --play=AC \
	  | tarot --play=7C \
	  | tarot --play=11T \
	  | tarot --play=9T \
	  | tarot --play=10C \
	  | tarot --play=KH \
	  | tarot --play=4H \
	  | tarot --play=10D \
	  | tarot --play=2C \
	  | tarot --play=9H \
	  | tarot --play=QH \
	  | tarot --play=5H \
	  | tarot --play=JC \
	  | tarot --play=3C \
	  | tarot --play=8C \
	  | tarot --play=CH \
	  | tarot --play=6H \
	  | tarot --play=JD \
	  | tarot --play=4C \
	  | tarot --play=9C \
	  | tarot --play=JH \
	  | tarot --play=7H \
	  | tarot --play=JS \
	  | tarot --play=5C \
	  | tarot --play=6D \
	  | tarot --play=10H \
	  | tarot --play=8H \
	  | tarot --play=CC \
	  | tarot --play=AD \
	  | tarot --play=7D \
	  | tarot --play=18T \
	  | tarot --play=8T \
	  | tarot --play=CD \
	  | tarot --play=2D \
	  | tarot --play=8D \
	  | tarot --play=17T \
	  | tarot --play=7T \
	  | tarot --play=CS \
	  | tarot --play=3D \
	  | tarot --play=9D \
	  | tarot --play=16T \
	  | tarot --play=6T \
	  | tarot --play=QC \
	  | tarot --play=4D \
	  | tarot --play=5S \
	  | tarot --play=15T \
	  | tarot --play=5T \
	  | tarot --play=QD \
	  | tarot --play=5D \
	  | tarot --play=6S \
	  | tarot --play=14T \
	  | tarot --play=4T \
	  | tarot --play=QS \
	  | tarot --play=AS \
	  | tarot --play=7S \
	  | tarot --play=13T \
	  | tarot --play=3T \
	  | tarot --play=KD \
	  | tarot --play=2S \
	  | tarot --play=8S \
	  | tarot --play=12T \
	  | tarot --play=1T \
	  | tarot --play=KS \
	  | tarot --play=3S \
	  | tarot --play=9S \
	  | tarot --play=EXC \
	  | tarot --play=2T \
	  | tarot --play=KC \
	  | tarot --play=4S \
	  | tarot --play=10S \
   )

END_STATUS=$(echo "$AT_END" | tarot --status)
END_STATUS_IMPUTED=$(echo "$AT_END" | tarot --impute | tarot --status)

END_STATUS_EXPECTED=$(
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│** P1   │   P2 * │   P3   │   P4   │   P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  take  │  pass  │  pass  │  pass  │  pass  │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  pass  │  pass  │  pass  │  pass  │  slam! │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
    echo " - Call: K♣"
    echo " - Dog: 6♥, 7♥, 8♥"
    echo " - Discard: A♥, 2♥, 3♥"
    echo " - Double handful of P1: 1★, 2★, 3★, 4★, 5★, 6★, 7★, 8★, 9★, 10★"
    echo " - Double handful of P5: 11★, 12★, 13★, 14★, 15★, 16★, 17★, 18★, 19★, EXC"
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│** P1   │   P2 * │   P3   │   P4   │   P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  10★  ☹│  20★   │  21★ * │   6♣  #│->19★   │"
    echo "│   9★  ☹│  10♣   │-> A♣   │   7♣   │  11★ */│"
    echo "│   4♥   │  10♦  #│   2♣  #│   9♥   │-> K♥ * │"
    echo "│   5♥   │   J♣  #│   3♣  #│   8♣  #│-> Q♥ * │"
    echo "│   6♥   │   J♦  #│   4♣  #│   9♣  #│-> C♥ * │"
    echo "│   7♥   │   J♠  #│   5♣  #│   6♦  #│-> J♥ * │"
    echo "│   8♥   │   C♣  #│   A♦  #│   7♦  #│->10♥ * │"
    echo "│   8★  ☹│   C♦  #│   2♦  #│   8♦  #│->18★ * │"
    echo "│   7★  ☹│   C♠  #│   3♦  #│   9♦  #│->17★ * │"
    echo "│   6★  ☹│   Q♣  #│   4♦  #│   5♠  #│->16★ * │"
    echo "│   5★  ☹│   Q♦  #│   5♦  #│   6♠  #│->15★ * │"
    echo "│   4★  ☹│   Q♠  #│   A♠  #│   7♠  #│->14★ * │"
    echo "│   3★  ☹│   K♦  #│   2♠  #│   8♠  #│->13★ * │"
    echo "│   1★  ☹│   K♠  #│   3♠  #│   9♠  #│->12★ * │"
    echo "│   2★   │   K♣  #│   4♠  #│  10♠  #│->EXC * │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  -1080 │   -540 │   +540 │   +540 │   +540 │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
		   )

if test "$END_STATUS" != "$END_STATUS_EXPECTED"
then
    >&2 echo "FAILED: the ending status is not correct ('$END_STATUS' != '$END_STATUS_EXPECTED')"
    exit 1
fi

if test "$END_STATUS_IMPUTED" != "$END_STATUS_EXPECTED"
then
    >&2 echo "FAILED: the ending status with imputation is not correct ('$END_STATUS' != '$END_STATUS_EXPECTED')"
    exit 1
fi
