#!/bin/sh

tarot --help > /dev/null || exit 1

AT_PLAY=$(tarot --new-game -n 5 -c \
	| tarot --deal-all P6,P1,P4,P4,P4,P4,P4,P3,P2,P1,P3,P5,P5,P5,P2,P3,P2,P2,P3,P3,P4,P5,P1,P2,P4,P3,P1,P1,P5,P5,P1,P3,P1,P4,P2,P3,P4,P4,P2,P3,P5,P5,P4,P2,P3,P4,P2,P1,P1,P2,P4,P2,P1,P3,P3,P6,P5,P2,P2,P5,P1,P4,P3,P5,P5,P1,P1,P3,P5,P2,P3,P4,P2,P1,P1,P5,P5,P6 \
	| tarot --bid=take \
	| tarot --bid=pass \
	| tarot --bid=pass \
	| tarot --bid=pass \
	| tarot --bid=push \
	| tarot --declare=pass \
	| tarot --declare=slam \
	| tarot --call=KC)

STATUS=$(echo "$AT_PLAY" | tarot --status)

STATUS_EXPECTED=$(
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│   P1 * │   P2   │   P3   │   P4   │** P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  take  │  pass  │  pass  │  pass  │  push  │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  pass  │  slam! │  pass  │  pass  │  pass  │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
    echo " - Call: K♣"
    echo " - Dog: A♥, K♠, EXC"
    echo " - Cards of P1: 2♥, 10♥, 9♣, Q♣, K♣, 3♦, 5♦, 6♠, 7♠, J♠, 5★, 10★, 11★, 18★, 19★"
    echo " - Cards of P2: 9♥, A♣, 3♣, 4♣, 10♣, 7♦, J♦, 2♠, 5♠, 8♠, 10♠, 2★, 3★, 14★, 17★"
    echo " - Cards of P3: 8♥, J♥, 2♣, 5♣, 6♣, C♣, 4♦, 8♦, C♦, 3♠, C♠, Q♠, 7★, 12★, 15★"
    echo " - Cards of P4: 3♥, 4♥, 5♥, 6♥, 7♥, 7♣, J♣, 6♦, 9♦, 10♦, A♠, 4♠, 9♠, 6★, 16★"
    echo " - Cards of P5: C♥, Q♥, K♥, 8♣, A♦, 2♦, Q♦, K♦, 1★, 4★, 8★, 9★, 13★, 20★, 21★"
    echo "P5 should discard 3 cards among A♥, C♥, Q♥, 8♣, A♦, 2♦, Q♦"
	       )

if test "$STATUS" != "$STATUS_EXPECTED"
then
    >&2 echo "FAILED: the status is not correct ('$STATUS' != '$STATUS_EXPECTED')"
    exit 1
fi

if echo "$AT_PLAY" | tarot --discard= > /dev/null 2>&1
then
    >&2 echo "FAILED: I was not supposed to be able to discard these"
    exit 1
fi
