#!/bin/sh

tarot --help > /dev/null || exit 1

AT_DOG=$(tarot --new-game -n 5 -c \
	| tarot --deal-to P1=21T,20T,13T,9T,8T,4T,1T,KH,QH,CH,KD,QD,2D,AD,8C \
	| tarot --bid=take \
	| tarot --bid=pass \
	| tarot --bid=pass \
	| tarot --bid=pass \
	| tarot --bid=push \
	| tarot --declare=slam \
	| tarot --call=KC \
	| tarot --dog=AH,KS,EXC)

STATUS=$(echo "$AT_DOG" | tarot --status)

STATUS_EXPECTED=$(
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│   P1   │   P2   │   P3   │   P4   │** P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  take  │  pass  │  pass  │  pass  │  push  │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  slam! │  pass  │  pass  │  pass  │  pass  │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
    echo " - Call: K♣"
    echo " - Dog: A♥, K♠, EXC"
    echo " - Cards of P1: C♥, Q♥, K♥, 8♣, A♦, 2♦, Q♦, K♦, 1★, 4★, 8★, 9★, 13★, 20★, 21★"
    echo "P5 should discard 3 cards"
	       )

if test "$STATUS" != "$STATUS_EXPECTED"
then
    >&2 echo "FAILED: the status is not correct ('$STATUS' != '$STATUS_EXPECTED')"
    exit 1
fi

if echo "$AT_DOG" | tarot --discard=5C > /dev/null 2>&1
then
    >&2 echo "FAILED: I was not supposed to be able to discard these"
    exit 1
fi
