#!/bin/sh

tarot --help > /dev/null || exit 1

OUTPUT=$(tarot --status <<"EOF"
<?xml version="1.0"?>
<game xmlns="http://planete-kraus.eu/tarot">
  <setup n-players="5" with-call="yes"/>
  <deal-all>
    <player player="P2"/>
    <player player="P1"/>
    <player player="P5"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P4"/>
    <player player="P4"/>
    <player player="P4"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P1"/>
    <player player="P4"/>
    <player player="P2"/>
    <player player="P1"/>
    <player player="P5"/>
    <player player="P1"/>
    <player player="P4"/>
    <player player="P3"/>
    <player player="P4"/>
    <player player="P5"/>
    <player player="P6"/>
    <player player="P4"/>
    <player player="P5"/>
    <player player="P1"/>
    <player player="P1"/>
    <player player="P3"/>
    <player player="P5"/>
    <player player="P5"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P5"/>
    <player player="P3"/>
    <player player="P3"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P5"/>
    <player player="P1"/>
    <player player="P4"/>
    <player player="P5"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P3"/>
    <player player="P2"/>
    <player player="P5"/>
    <player player="P4"/>
    <player player="P5"/>
    <player player="P5"/>
    <player player="P4"/>
    <player player="P1"/>
    <player player="P1"/>
    <player player="P1"/>
    <player player="P3"/>
    <player player="P4"/>
    <player player="P2"/>
    <player player="P5"/>
    <player player="P1"/>
    <player player="P4"/>
    <player player="P1"/>
    <player player="P5"/>
    <player player="P6"/>
    <player player="P5"/>
    <player player="P1"/>
    <player player="P4"/>
    <player player="P4"/>
    <player player="P1"/>
    <player player="P6"/>
    <player player="P2"/>
    <player player="P1"/>
    <player player="P2"/>
    <player player="P2"/>
    <player player="P4"/>
  </deal-all>
  <bid bid="take"/>
  <bid bid="push"/>
  <bid bid="pass"/>
  <bid bid="pass"/>
  <bid bid="pass"/>
  <decl slam="no"/>
  <decl slam="no"/>
  <decl slam="yes"/>
  <call card="KS"/>
  <dog>
    <card card="JC"/>
    <card card="11T"/>
    <card card="17T"/>
  </dog>
  <discard>
    <card card="CH"/>
    <card card="5D"/>
    <card card="6S"/>
  </discard>
  <handful/>
  <card card="3T"/>
  <handful/>
  <card card="8T"/>
  <handful/>
  <card card="12T"/>
  <handful/>
  <card card="19T"/>
  <handful/>
  <card card="20T"/>
  <card card="21T"/>
  <card card="7S"/>
  <card card="14T"/>
  <card card="10T"/>
  <card card="1T"/>
  <card card="18T"/>
  <card card="5S"/>
  <card card="4T"/>
  <card card="6T"/>
  <card card="2T"/>
  <card card="KH"/>
  <card card="QH"/>
  <card card="6H"/>
  <card card="3H"/>
  <card card="2H"/>
  <card card="AH"/>
  <card card="JH"/>
  <card card="7H"/>
  <card card="QD"/>
  <card card="7T"/>
  <card card="16T"/>
  <card card="17T"/>
  <card card="5H"/>
  <card card="EXC"/>
  <card card="QC"/>
  <card card="4H"/>
  <card card="10H"/>
  <card card="8H"/>
  <card card="CS"/>
  <card card="13T"/>
  <card card="KD"/>
  <card card="JD"/>
  <card card="CD"/>
  <card card="15T"/>
  <card card="3D"/>
  <card card="QS"/>
  <card card="JS"/>
  <card card="KS"/>
  <card card="8S"/>
  <card card="3S"/>
  <card card="AC"/>
  <card card="JC"/>
  <card card="8C"/>
  <card card="CC"/>
  <card card="5C"/>
  <card card="9C"/>
  <card card="10C"/>
  <card card="KC"/>
  <card card="3C"/>
  <card card="9D"/>
  <card card="9T"/>
  <card card="11T"/>
  <card card="10D"/>
  <card card="AS"/>
  <card card="2S"/>
  <card card="9H"/>
  <card card="8D"/>
  <card card="2C"/>
  <card card="9S"/>
  <card card="4C"/>
  <card card="5T"/>
  <card card="6D"/>
  <card card="10S"/>
  <card card="4D"/>
  <card card="6C"/>
  <card card="4S"/>
  <card card="2D"/>
  <card card="7C"/>
  <card card="7D"/>
  <card card="AD"/>
</game>
EOF
      )

STATUS_EXPECTED=$(
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│   P1 * │** P2   │   P3   │   P4   │   P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  take  │  push  │  pass  │  pass  │  pass  │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  pass  │  pass  │  slam! │  pass  │  pass  │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
    echo " - Call: K♠"
    echo " - Dog: J♣, 11★, 17★"
    echo " - Discard: C♥, 5♦, 6♠"
    echo "╭────────┬────────┬────────┬────────┬────────╮"
    echo "│   P1 * │** P2   │   P3   │   P4   │   P5   │"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│  19★   │  20★ * │-> 3★   │   8★   │  12★   │"
    echo "│   1★  ☹│->21★ * │   7♠  #│  14★  ☹│  10★  ☹│"
    echo "│   2★  ☹│->18★ * │   5♠  #│   4★  ☹│   6★  ☹│"
    echo "│   2♥   │-> K♥ * │   Q♥   │   6♥   │   3♥   │"
    echo "│   7★ */│-> A♥   │   J♥   │   7♥   │   Q♦  #│"
    echo "│->16★   │  17★ * │   5♥  #│  EXC   │   Q♣  #│"
    echo "│  13★ */│-> 4♥   │  10♥   │   8♥   │   C♠  #│"
    echo "│-> K♦   │   J♦   │   C♦   │  15★ */│   3♦   │"
    echo "│   K♠ * │   8♠   │   3♠   │-> Q♠   │   J♠   │"
    echo "│-> A♣   │   J♣   │   8♣   │   C♣ * │   5♣   │"
    echo "│   K♣ * │   3♣   │   9♦  #│-> 9♣   │  10♣   │"
    echo "│-> 9★   │  11★ * │  10♦  #│   A♠  #│   2♠  #│"
    echo "│   4♣  #│-> 9♥ * │   8♦  #│   2♣  #│   9♠  #│"
    echo "│   6♣  #│-> 5★ * │   6♦  #│  10♠  #│   4♦  #│"
    echo "│   A♦  #│-> 4♠ * │   2♦  #│   7♣  #│   7♦  #│"
    echo "├────────┼────────┼────────┼────────┼────────┤"
    echo "│   +312 │   +624 │   -312 │   -312 │   -312 │"
    echo "╰────────┴────────┴────────┴────────┴────────╯"
		     )

if test "$OUTPUT" != "$STATUS_EXPECTED"
then
    >&2 echo "FAILED: the status is not correct ('$OUTPUT' != '$STATUS_EXPECTED')"
    exit 1
fi
